ChangeLog (UTF-8, ff=dos)
Visual Novel Reader
Since 6/18/2011

2/19/2016 FRI
  * Fix google translation support, which was broke because of API change.
    Translation alignment for Google is broken because of the change.
    Thanks for @mireado sama's report!

1/24/2016 SUN
  [Game Engine]
  * Handle text tags in QLiE engine as requested by @mireado.

1/22/2016 FRI
  [TAHScript](English, @riz)
  * Update TAH script for LEC and Atlas.
    The scripts are from @errzotl sensei, and you can say thanks to him/her at TAHscript@outlook.com.

1/9/2016 SAT
  [Game Engine]
  * Update WillPlus engine to support 見上げてごらん、夜空の星を.
    Scenario/Name/History/Choice can be translated.
    User-shared subtitles tested working.

        http://i.imgur.com/nt8gQmr.png
        http://i.imgur.com/NV2AE3V.png

    为「見上げてごらん、夜空の星を」添加了内嵌翻译的支持。

1/1/2016 FRI
  [Game Engine]
  * Add translation support for コドモノアソビ.
    Embed translation also works.

      en: http://i.imgur.com/MMl0SHn.png
      zh: http://i.imgur.com/AThGjDW.png
      ko: http://i.imgur.com/kFpfx2W.png

    为「コドモノアソビ」添加了提取文本的支持。
    内嵌翻译的截图在上边。

    Note that the BGI games have ruby text like <r>...</r> that will downgrade translation quality.
    If you are using Embed Translation, then nothing needed to be done as it will take care of ruby by default.
    Otherwise, if you are using ITH engine, just make sure the ruby elimination rules in Shared Dictionary are associated with your version of the game.

  * Add translation support for IZUMO4.
    Embed translation is broken for this game.

    为IZUMO4添加了提取文本的支持。
    但内嵌翻译无法工作。

    I suspect Studio ego is using a different (older) game engine than Debonosu.
    So, I will not spend time fixing embed translation for this game until the next Debonosu game releases.

12/27/2015 SUN
  VNR's servers are migrated from Japan to US.
  Older versions of VNRs might be broken because of the migration after a month.

  VNR的服务器搬迁到US了。
  老版本的VNR在一个月后可能会无法正常使用了。

12/7/2015 Mon
  [i18n](Korean, @mireado)
  * Update VNR's UI translation in Korean made by @mireado sensei.

11/27/2015 FRI
  [Game Engine]
  * Do not extract English letters for mono games.

11/22/2015 SUN
  [Network]
  * Changed to access VNR's servers by domain names instead of by IP.

    Going to migrate VNR's servers from Japan to US some time next month or next year, where the servers are cheaper while having much more updated technologies.
    VNR's machine translation servers have already been deployed in the bay area, which worked pretty well.
    Changing to access domain names would make the server-side migration transparent to the end users.

    VNR used to access certain websites by IPs to bypass CCP's Internet censorship for foreign hosts and DNS.
    For example, whenever there is a big event in China, foreign domains tend to become unstable or temporarily blocked.
    But this made changing VNR server's IP address a pain in ass that all older versions of VNR would be broken.

  [TTS]
  * Fixed the broken Voiceroid+ TTS caused by the online API changes.
    Also add support of male voice actor 水無瀬コウ (http://www.ah-soft.com/voiceroid/kou/).

    修正了Voiceroid+在线TTS无法使用的问题。
    另外，添加了对男性的水無瀬コウ的支持。
    感谢@水上薰·墨香sama的报告！

  [Game Engine]
  * Add support for 凍京NECRO.

    Embed translation also works but only supports English translation.
    But font is too large and English is so much verbose that the translation could go out of screen.

        http://i.imgur.com/FFqgnyF.png

    为「凍京NECRO」添加了提取文本的支持。
    内嵌翻译仅限英文。

11/16/2015 MON
  [Machine Translation]
  * Changed to only support translation of Chinese/English/Korean from Japanese.
    Due to limited server-side resources, support for other languages are currently disabled.

11/15/2015 SUN
  [Bugfix]
  * Fixed a multi-threading bug that could crash Shared Dictionary.

  [Removed Features]
  * Remove regular expression tester.
  * Remove voice recognition.
  * Remove BBCode tester.
  * Remove YouTube downloader.
  * Remove game finder.

  [Machine Translation]
  * Add Thai language support.

11/8/2015 SUN
  [TAHScript](English, @riz)
  * Update TAH script for LEC and Atlas.
    The scripts are from @errzotl sensei, and you can say thanks to him/her at TAHscript@outlook.com.

  [Machine Translation]
  * Resume the machine translation that is trained from user-shared subtitles.
    It currently only supports en/zh/ko/vi/fr/es/ru, which has relative more subtitles in the database.
    You can also tested it here: http://tranzz.com/translate
    Due to copyright concerns, the translation is trained only from game subtitles instead of commercial dictionaries.
    The current translation quality is worse than before as the result.

    My eventual goal is to allow everyone to create his own translators where all settings/translation rules/corpus can be fully adjusted and managed.
    I hope combing our community's efforts, we can create our best domain-specific machine translators.

  Regarding the future of VNR, I might not have lots of time to work on it like before.
  Instead of adding more features, I might focus on making existing features more stable and removing features that are seldom used.
  And here are the directions that I am planning to go in case you are interested:
  1. Remove features that are not directly related to reading VNs (youtube, chatting, game information, etc.)
  2. Split non-VN translation support like OCR/TextReader out into separate applications.
  3. Move subtitles/shared dictionary management to the cloud. Loading translation rules only for the games that are being played. This will help limit memory usage of the shared dictionary that becomes larger and larger.
  4. Improve translation quality while minimizing local resource usage.

9/25/2015 FRI
  [JBeijing](Chinese, @najizhimo)
  * 更新了@najizhimo维护的J北京词库。

9/20/2015 SUN
  [Ehnd](Korean, @mireado)
  * Update Ehnd dictionary from @mireado sensei.
    It can also be downloaded independently if you don't want to use VNR:
        http://sakuradite.com/topic/898

9/18/2015 FRI
  [JBeijing](Chinese, @najizhimo)
  * 更新了@najizhimo维护的J北京词库。

9/12/2015 SAT
  [JBeijing](Chinese, @najizhimo)
  * 更新了@najizhimo维护的J北京词库。

9/8/2015 TUE
  [JBeijing](Chinese, @najizhimo)
  * 更新了@najizhimo维护的J北京词库。

9/5/2015 SAT
  [Shared Dictionary]
  * Fixed a bug that might crash the machine translator while applying rules.
    修正了一个可能会崩溃的问题。

8/30/2015 SUN
  [Embed Translation]
  * Add support for CatSystem2 engine.
    Tested with 果つることなき未来ヨリ, ゆきこいめると, グリザイアの果実 and カミカゼ☆エクスプローラー！.
    Scenario/name/choice/history/message texts can be translated.

    en: http://i.imgur.com/t5ip0az.png
    ko: http://i.imgur.com/LsHOAaj.png
    vi: http://i.imgur.com/DjbVhrj.png
    zh: http://i.imgur.com/gSrUdat.png

    为CatSystem2引擎的游戏添加了内嵌翻译的支持。

8/29/2015 SAT
  [Embed Translation]
  * Extend Pensil engine to support translating choices and translating games with 2RM adventure engine .
    为2RM引擎的游戏添加了内嵌翻译的支持。

  * Add support for minori games.
    Tested with 12の月のイヴ and ソレヨリノ前奏詩.
    It can also translate invisible voiced scenario texts that are not painted on the screen, and hence recommended for text extraction.

    en: http://i.imgur.com/OHRjvpy.png
    ko: http://i.imgur.com/hro9WJw.png
    vi: http://i.imgur.com/n4TB6p0.png
    zh: http://i.imgur.com/jZKc2Tt.png

    为minori的游戏添加了内嵌翻译的支持。

8/28/2015 FRI
  [Shared Dictionary]
  * Add a Priority property for all rules that will affect the order to apply these rules.
    If you seldom use Shared Dictionary and don't know what Priority is, it is OK to just leave it empty.

    When determine the order to apply translation rules, the number of characters in pattern is one of the major
    factors that will affect the order.
    Usually, the longer rules will be applied before shorter rules by default.
    Now, the new Priority property will override the default pattern size, and the larger the Priority value,
    the earlier the rule might be applied.

    For example, given the following three rules:
    #1. 椿姫 = 츠바키
    #2. お?姫 = 공주님, regex = true
    #3. 姫 = 공주

    By default, the three rules will be applied in order of #2, #1, #3, because #2 has the longest pattern.
    As the result, 椿姫 might be broken because of お?姫.

    Now, if I set the priority of #2 to 1.5, then the translation order will become: #1, #2, #3.
    This is because the default priority of #1 is "椿姫".length = 2, and that of #3 is "姫".length = 1, and
    user-specified 1.5 for rule #2 is smaller than 3 and larger than 1.

    If you want to change the priority of a rule, personally I recommend to make it around the estimated number of
    characters in the Pattern.
    For example, because "お?姫" can match either "お姫" (2 chars) or "姫" (1 char), I just chose "1.5" as its priority.
    But you don't have to obey this convention. You can set priority to any number if necessary.
    Rules with very large priority tend to be applied at first, and those with small negative priority tends to be applied at last.
    For example, I can set priority of #2 to -1, and then the translation order will become #1, #3, #2.

    If you want to delete a priority, you can just set it to zero.

    Note that priority is not the only factor that affects transformation order, which is determined in a complicated way.
    Even if you assign a very large/small priority to a rule, it is still not guaranteed to be applied before/after all other rules.

    为词条添加了一个【优先级】的属性，可以影响应用词条的顺序。
    如果你不常用共享辞书，那么可以忽略这个属性。
    优先级高的词条会被优先应用于翻译；反之优先级低的词条会被推迟应用。
    如果没有指定优先级，VNR默认会使用匹配文本的长度。
    所以如果需要，我个人建议大家约定估计的匹配文本的长度为这个属性的值。不过你也可以不遵守这个约定。

8/23/2015 SUN
  [Game Engine]
  * Add support for games from 玉藻スタジオ.
    Tested 閃光の騎士 ～カリスティアナイト～ and 冒険者の町を作ろう!2.
    为玉藻スタジオ社的游戏添加了提取文本的支持。

  [TAHScript](English, @riz)
  * Update TAH script for LEC and Atlas.
    The scripts are from @errzotl sensei, and you can say thanks to him/her at TAHscript@outlook.com.

8/22/2015 SAT
  [Embed Translation]
  * Add support for ge-sen18/a-unicorn games.
    Tested 三極姫4, 戦極姫6, and 天極姫. All texts can be translated.
    However, there are certain in-game texts that are not rendered using standard GDI fonts,
    where all non-Japanese and non-Chinese characters (English, Korean, ...) might not be properly displayed.

    en: http://i.imgur.com/bGKujRG.png
        http://i.imgur.com/M6xriQh.png
        http://i.imgur.com/wemChRV.png
        http://i.imgur.com/uHdc6bT.png
    ko: http://i.imgur.com/7CzC3qo.png
        http://i.imgur.com/sELiU5M.png
        http://i.imgur.com/Mhh3drZ.png
        http://i.imgur.com/EW58YcV.png
    vi: http://i.imgur.com/2zxE706.png
        http://i.imgur.com/149p2bm.png
        http://i.imgur.com/hTLiQmf.png
        http://i.imgur.com/hbzlQgJ.png
    zh: http://i.imgur.com/Jb6I7Dn.png
        http://i.imgur.com/o9HQLbX.png
        http://i.imgur.com/bfEt47H.png
        http://i.imgur.com/mlwmxa1.png

    为gesen18的游戏添加了支持。截图在上边。

8/21/2015 FRI
  [Text-to-speech]
  * Update the support of Google TTS, which was broken since the changes of Google APIs.
    修正了Google语音合成失效的问题。

8/19/2015 WED
  [Embed Translation]
  * Add support for Waffle games.
    Tested 完全時間停止, 漫喫ハプニング, and 巨乳ファンタジー2 if.
    Screenshots are as follows:

    en: http://i.imgur.com/hQr9yDK.png
    ko: http://i.imgur.com/wjejBXj.png
    zh: http://i.imgur.com/kuAzN0T.png

    为Waffle社的游戏添加了支持。截图在上边。

8/16/2015 SUN
  [Embed Translation]
  * Translate in-game texts for ウルスラグナ～征戦のデュエリスト～.

    en: http://i.imgur.com/iqHjV7M.png
    ko: http://i.imgur.com/0e2oHyL.png
    zh: http://i.imgur.com/BtQoAhb.png

    翻译「ウルスラグナ」游戏内的文本。截图在上边。

  * Add support for old GXP engine.
    Test working for 魔導書の司書 and デモニオンII 魔王と三人の女王.
    为老版本的GXP引擎的游戏添加了内嵌翻译的支持。

  * Add tentative support for Rance03.
    It only works for English.
    All texts were surposed to support translation. However, the logic to determine whether it is safe to translate
    without crashing the games and how to distinguish scenario/name/other texts is currently inaccurate.
    en: http://i.imgur.com/l1pwGWj.png
        http://i.imgur.com/52KJbKC.png
        http://i.imgur.com/FBEX15c.png

8/15/2015 SAT
  [Embed Translation]
  * Add support for GXP2 engine.
    Test working for 塔の下のエクセルキトゥス and ウルスラグナ～征戦のデュエリスト～.
    Scenario/name/history/choices/popup messages can be translated.
    It might not support old GXP games.

    en: http://i.imgur.com/MQPy95V.png
    ko: http://i.imgur.com/dS6xvav.png
    zh: http://i.imgur.com/LK0vtCr.png

    为GXP2引擎的游戏添加了支持。截图在上边。

8/12/2015 WED
  [Embed Translation]
  * You can disable embedding translation for a specific game by pressing "Edit" on the bottom of the SpringBoard.
    在SpringBoard下边点击【编辑】的选项中，可以只对某一个游戏禁用内嵌翻译。

  [Game Engine]
  * Add generic GDI+ hook to GdipAddPathString.
    Test working for all Rejet games. Game engine is not needed for Rejet games any more.

8/11/2015 TUE
  [Game Engine]
  * Update System43 engine to support ランス03.
    btw., embed translation support is broken for the new System43 engine.
    为「ランス03」添加了提取文本的支持。

8/10/2015 MON
  [Shared Dictionary]
  * Make sure the processing of Shared Dictionary is thread-safe to avoid possible crash caused by thread contention.
    加强了处理【共享辞书】的线程安全，修正了多线程快速翻译时可能的崩溃。

8/9/2015 SUN
  [Embed Translation]
  * Add support for the latest Malie3 engine.
    Tested working for シルヴァリオ ヴェンデッタ, 相州戦神館學園, 神咒神威神楽, Vermilion, and BRAVA!!
    It might not work for old Malie games though.
    All texts can be translated. Some screenshots are as follows:

    en: http://i.imgur.com/tATc6SL.png
        http://i.imgur.com/6TWdtSx.png -- with ruby for Shinigami (God of Death) in the Shared Dictionary
    ko: http://i.imgur.com/iVCwhQR.png
        http://i.imgur.com/HVaYOhQ.png
    zh: http://i.imgur.com/Pt6efBE.png
        http://i.imgur.com/v1LjadG.png
        http://i.imgur.com/gvBeeYC.png

    为最新版的Malie引擎的游戏添加了支持。截图在上边。

8/7/2015 FRI
  [Embed Translation]
  * Add support for LC-ScriptEngine.
    Tested working for 恋姫†無双, 春恋＊乙女, and 姦獄学園.
    Some screenshots are as follows:

    ko: http://i.imgur.com/wfscBjo.png
        http://i.imgur.com/uuFdV99.png
    zh: http://i.imgur.com/jTGaNbh.png
    en: http://i.imgur.com/OKwkjGY.png

    为LC-ScriptEngine引擎的游戏添加了支持。截图在上边。

8/6/2015 THU
  [TAHScript](English, @riz)
  * Update TAH script for LEC.
    The scripts are from @errzotl sensei, and you can say thanks to him/her at TAHscript@outlook.com.

  [Game Information]
  * Display the number of users that have played the game (unique IP visitors) in the game information page.
    在【游戏情报】中会显示玩过这个游戏的人数。

8/4/2015 TUE
  [Embed Translation]
  * Add support for Taskforce2 engine.
    Test working for 神様（仮） and オトメスイッチ.
    Screenshots are as follows.

    en: http://i.imgur.com/PfQnckO.png
    ko: http://i.imgur.com/LHghKA8.png
    zh: http://i.imgur.com/3DucwGh.png

    为Taskforce2引擎的游戏添加了支持。截图如上。

  * Add support for LunaSoft games.
    It only works for English. All texts can be translated.
    en: http://i.imgur.com/N8gR9mC.png
        http://i.imgur.com/dFV7laB.png
        http://i.imgur.com/TBTPsaV.png

8/3/2015 Mon
  [i18n](Korean, @mireado)
  * Update VNR's UI translation in Korean made by @mireado sensei.

8/2/2015 SUN
  [i18n]
  * Add translation languages of Filipino (Tagalog), Slovenian, Hebrew, Bulgarian, Belarusian, Estonian, Latvian and Lithuanian.

8/1/2015 SAT
  [Internet]
  * Fixed the broken proxy to ESG.
    修正了代理批评空间仍无法访问的问题。

  [Embed Translation]
  * Add support for Pensil engine.
    Some screenshots are as follows.
    Tested working for 大正×対称アリス, はにつま, and 星逢のプリズムギア.
    Scenario/Name/Choice/History can be translated.

    ko: http://i.imgur.com/7mvXy77.png
        http://i.imgur.com/tzmoi1u.png
    zh: http://i.imgur.com/RFKSyEn.png
        http://i.imgur.com/R8eYb5Z.png

    为Pensil引擎的游戏添加了支持加。截图在上边。

  * Update support for ShinaRio v2.5 to properly recognize Name thread.
    Some screenshots for ソーサリージョーカーズ are as follows.

    en: http://i.imgur.com/jy3cSQW.png
    ko: http://i.imgur.com/6tEYRYu.png
    zh: http://i.imgur.com/ozwf2wG.png

    修正了「ソーサリージョーカーズ」内嵌姓名翻译可能会出错的问题。

  * Add a button to Preferences/Embed to restore default settings.
    在【使用偏好/内嵌翻译】中添加了一重置内嵌设定的按钮。

7/31/2015 FRI
  [Embed Translation](CM3D)
  * Fix the issue that embedding Other text might cause CM3D 2 to be black out.
    Thanks for @mireado sama's report!
    修正了开启内嵌翻译可能会让CM3D 2黑屏的问题。

  * New lines are properly handled for CM3D 2.
    Word wrapping also works for embedded scenario text near line boundaries.

  [Game Engine]
  * Update Abel engine to support 不条理世界の探偵令嬢.
    为「不条理世界の探偵令嬢」添加了提取文本的支持。

7/30/2015 THU
  [Embed Translation]
  * Add support for NEXTON games.
    Name/scenario/choice/history can be translated.
    It does not have the issue of floating signatures and hence recommended also for text extraction.
    为NEXTON的伞下会社的游戏添加内嵌翻译的支持。

7/29/2015 WED
  [Game Information]
  * Fixed the broken youtube download module that was caused by the deprecation of youtube v2 api.

  [Embed Translation](CM3D)
  * Fix the issue that embedding Other text might crash CM3D 2.
    Thanks for @mireado sama's report!
    修正了内嵌翻译CM3D 2时可能会让游戏崩溃的问题。

  [Game Engine](CM3D)
  * Update the split logic to make it easier to select text threads from CM3D 2.
    Thanks for @xemnaseternal sama's report!

7/28/2015 TUE
  [Embed Translation]
  * Add support for FAVORITE games.
    Tested working for 星空のメモリア and 紅い瞳に映るセカイ.
    It can properly handle ruby in text, and hence recommended over getting text from ITH, which will be messed up by ruby.

        http://i.imgur.com/XXfG7cD.png

    为FAVORITE的游戏添加了内嵌翻译的支持。截图在上边。
    对FAVORITE的游戏推荐使用内嵌翻译提取文本。因为ITH的提取方式会被游戏文本中的Ruby扰乱。

7/27/2015 MON
  [Embed Translation]
  * Add support for Mono games.
    Currently, only tested working for Custom Maid 2, where most texts can be translated.
    Note that game text speed must be set to maximum.

    While translation in all languages can be embedded, there is a big known issue that long translation might be truncated.
    As the result, only language that is much more concise than Japanese (such as Chinese) can be properly displayed.
    Languages that are much more verbose than Japanese (such as English) will usually be truncated.
    You might have to turn off embedded translation for Scenario text if being truncated.

    ko: http://i.imgur.com/ri5Hnjo.png -- As you can see that the scenario translation is truncated
        http://i.imgur.com/C3434Gq.png
        http://i.imgur.com/ZdgYs5Z.png -- Maximize Text Speed here in the Message panel

    zh: http://i.imgur.com/sk7Obtg.png
        http://i.imgur.com/Fdu6vuA.png
        http://i.imgur.com/iujRDs5.png -- 这里，一定需要将Message里的【文本速度】调整为最快！
        http://i.imgur.com/ChJwS5K.png
        http://i.imgur.com/G6u7XuZ.png

    为Mono的游戏添加了内嵌翻译的支持。
    当前仅有测试Custom Maid 2，截图在上边。另外，内嵌翻译一定需要将游戏文本速度调整为最快！（参看上边的截图）

  * Add support for プレイクラブ.
    It suffers from the same problem as Custom Maid that long translation might be truncated.
    And the game text speed must be set to maximum.

    ko: http://i.imgur.com/2jXY6UE.png
        http://i.imgur.com/C8GYqR4.png
        http://i.imgur.com/VNY145m.png

    zh: http://i.imgur.com/I9IrCSF.png
        http://i.imgur.com/EHnhROb.png
        http://i.imgur.com/kQ1MrEp.png

    为「プレイクラブ」添加了内嵌翻译的支持。截图在上边。
    同样的，文本的速度一定要设定为最快才可以。

7/25/2015 SAT
  [Embed Translation]
  * Add support for Lucifen engine.
    Test working for プリズム・プリンセス and 猫撫ディストーション. Screenshots are as follows.

      ko: http://imgur.com/dJpfaIq,02M3ypB,tVyQokf,aXyP3IX
      zh: http://i.imgur.com/kqSp943.png

    为Lucifen引擎的游戏添加了支持。截图在上边。

  * Fix the issue that game window might blackout when Window text translation is enabled.
    Thanks for @王子夜礼服假面 and @mireado's report!

  * Add support for old SystemAoi games. Tested working for 「王賊」.
    为SystemAoi的老游戏添加了引擎。

  [Game Engine]
  * Add support for old SystemAoi games. Tested working for 「王賊」.
    为SystemAoi的老游戏添加了引擎。

  * Disable Mono Unity hook for CM3D, which might slown down the game.
    Thanks for @xemnaseternal sama's report!

7/24/2015 FRI
  [Game Engine]
  * Add support for Escu:de games, which does not require changing game font to "MS Gothic".
    为Escu:de社的游戏添加了支持。提取文字不再需要修改游戏的字体。

  [Embed Translation]
  * Add support for Esc:ude games. Screenshots are as follows.
    Test working for Re;Lord, パニカル・コンフュージョン, and 花嫁と魔王.
    If the translation's language is not English, please change the game's default font to "MS Gothic" in Configure.exe.

      ko: http://imgur.com/eoujHm7,sz5TemN
      zh: http://imgur.com/ncrMb0R,VvwBYVA

    为Esc:ude社的游戏添加了支持。截图在上边。
    内嵌翻译需要通过configure.exe修改游戏字体为MS Gothic。

7/21/2015 TUE
  [Embed Translation]
  * Embedded translation won't get truncated for "LORD of VERMILION ARENA:LoVA" at http://lova.jp. A screenshot is as follows.

      en: http://i.imgur.com/ItwyDrI.png
      zh: http://i.imgur.com/834xGe6.png

    "LORD of VERMILION ARENA:LoVA" (http://lova.jp) 内嵌的翻译不会被截断了。截图在上边。

  * Properly handle ruby for AMUSE CRAFT games.
    Thanks for @mireado sama's report!

7/20/2015 MON
  [Embed Translation]
  * Add support to translate "LORD of VERMILION ARENA:LoVA" at http://lova.jp. Screenshots are below.
    Almost all texts can be translated. But there are some known issues:
    + Due to technical difficulties, there is no way to create a ITH engine for this game.
      If you don't want to embed translation, you can just set Scenario/Name/Other/Window to Disable in Preferences/Embed.
    + Game font cannot be changed.
      - If the translation language is English, it should work fine.
      - If the translation language is Chinese
        In Preferences/Embed, please turn on the option to use Traditional Chinese and Japanese kanji as preferred Chinese variants instead of Simplified Chinese.
      - For any languages other than English/Chinese
        I don't know how to make it working. You might have to looking for ways to change the game font to that support the character set of your language.

    en: http://i.imgur.com/vMpdbV6.png
        http://i.imgur.com/2yDfgew.png
        http://i.imgur.com/fs3YZHm.png
        http://i.imgur.com/Yyy9yIi.png

    zh: http://i.imgur.com/i7MPagT.png
        http://i.imgur.com/J76tYBv.png
        http://i.imgur.com/Enya1CZ.png
        http://i.imgur.com/yQ0qQPF.png

    支持内嵌翻译LORD of VERMILION ARENA:LoVA (http://lova.jp). 截图在上边。
    游戏内几乎全部的文本都可以翻译。不过，有一些已知的问题：
    + 由于技术困难，无法通过ITH来翻译这个游戏。
    + 简体中文字体无法正常显示。
      请将用户语言设定为中文，并在【使用偏好/内嵌翻译】中指定优先的中文字符集为正体中文和日本汉字。

  [Text Settings]
  * There is always a Null thread in Text Settings.
    If you want to disable text extraction, just set scenario thread to Null.
    如果你要停止提取文本，可以在文本设定中设定对白文本为Null。

7/18/2015 SAT
  [Dictionary](Korean)
  * Add support to lookup hanja dictionary for Japanese kanji.
    The dictionary can be downloaded for free in Preferences/Downloads, and enabled in Preferences/Dictionaries.

  * Add an option to display hanja pronunciation for kanji in Preferences/Dictionaries.
    When enabled, for example, click a phrase containing "香" and VNR will popup the following:
        【香{향,incense}】[禾{화,grain}, 日{일,sun}]

  [Embed Translation]
  * Add support for AMUSE CRAFT games.
    It currently only works for English. Scenario/Name/Choice/Backlog can be translated.
    Tested working for 時計仕掛けのレイライン and ManguSta .

  [Game Engine]
  * Update AMUSE CRAFT engine so that text threads won't be floating and split.
    If you are playing AMUSE CRAFT games, please re-adjust Text Settings.

7/17/2015 FRI
  [Embed Translation]
  * Add support for old ShinaRio games (ver 2.40 ~ 2.47).
    Tested working for Vestige and 花と乙女に祝福を.

7/16/2015 THU
  [Embed Translation]
  * Update BGI engine to support handling ruby.

7/12/2015 SUN
  [Yomigana](Vietnamese)
  * For Vietnamese translation of Japanese names, VNR can display the Phiên âm Hán-Việt pronunciation above Yomigana as ruby.
    This behavior is disabled by default, and can be enabled in Preferences/Shared Dictionary.
    For example, when enabled, given "蓮花 = れんふぁ", VNR will display "Liên Hoa" above "Renfa".

  [UI]
  * The growl notification on the Desktop top-right corner can be disabled in Preferences/UI.
    在【使用篇好/界面】中可以停止在桌面的右上角显示提醒。

  [Game Engine]
  * The code bases for Windows XP and non-Windows XP are merged.
    vnrhookxp.dll is removed, and will no longer be recognized as virus.
    In the old version of VNR, the translated games were much more likely to crash on WinXP comparing to non-WinXP.
    And PPSSPP game engines did not work on Windows XP.
    Now, there should be no much difference between WinXP and non-XP. Game engines on Windows XP should be as stable as non-XP.
    And translation support for PPSSPP games also works on Windows XP now.

  * Fixed the issue that the game might crash on Wine when VNR is closed.

  * Properly handle UNC path when the game is launched from a remote network drive.

  [Embed Translation]
  * Fix a bug that name translation might not work when enabled.
    Thanks for @mireado sama's report!
    修正了一个内嵌姓名翻译有时会失效的bug。

  * Automatically-generated ruby for yomigana also works for certain game engines that supports Ruby.

        http://i.imgur.com/L9u4JUe.png

    部分游戏的内嵌翻译也会支持姓名罗马字注音的Ruby。
    截图在上边。"Taiyo" 是 "太陽=たいよう" 的读法词条生成的罗马字。

    btw., if you can read Hiragana, it is always recommended to use Yomigana instead of Name rules to define translation for Japanese names
    in the Shared Dictionary.
    Yomigana is shared across languages and can really help reduce duplicates.
    And it usually has more information than direct language-specific name translation, and hence might enable more features in the future.

    btw., 关于共享辞书中的姓名和读法词条，如果你可以看懂日文的仮名，希望可以尽量用【读法】定义日文人名的翻译。
    读法词条在不同语言之间共享翻译，并可以减少不同语言之间重复定义。
    另外，读法词条通常比直接的日中姓名翻译包含更多的信息，可以提供比如罗马字Ruby这样的额外的功能。

7/11/2015 SAT
  [Embed Translation]
  * Add support for ShinaRio (ver >= 2.48) games.
    Tested working for 3rdEye games.

      ko: http://i.imgur.com/4CQtrye.png
      zh: http://i.imgur.com/tVe2gaO.png

    为最近的ShinaRio引擎的游戏添加了内嵌翻译的支持。截图在上边。

  [Yomigana]
  * For Korean translation of Japanese names, VNR can display the pronunciation of Hanja above Yomigana as ruby.
    This behavior is enabled by default, and can be disabled in Preferences/Shared Dictionary.
    For example:
    - Given 悠真 = ゆうま, VNR will display 유진 above 유우마 as 悠 is 유 and individual 真 is usually 진.
    - Given 蓮花 = れんふぁ that is also a Korean phrase, VNR will display 연화 above 렌파 as 蓮花 is 연화 in Korean,
      although 蓮 can also be 련 when used individually.
    This only applies to the Yomigana definition of Japanese names that consist of Hanja.
    If the automatically-generated ruby is inappropriate, you can manually define a ruby to override the default one.

  * 在日中日文时，对于通过読み仮名定义的姓名翻译，VNR增加了一个选项可以在翻译的上方显示日文原始的罗马字读音。

    比方说，给定：悠真 = ゆうま，那么VNR会在翻译中"悠真"的上方显示Yuuma。

    这个选项可以在【使用偏好/共享辞书】中开启。选项默认是关闭。
    这个功能也许仅对想学习日文的同学有一点点帮助。

    比方说，很多人知道堀江由衣，但是并不知道在日文里怎么读这个名字(Horie Yui)。
    在游戏中，有时也会无法把翻译的中文姓名与日文的读音对应。
    如果你在学习日语，这个功能也许可以对熟悉罗马字的发音有些帮助。

  * Fix a bug that displaying ruby in the translation might sometimes break layout.
    修正了显示翻译Ruby有时会造成排版错误的问题。

7/8/2015 WED
  [i18n](Korean, @mireado)
  * Update VNR's UI translation in Korean made by @mireado sensei.

7/7/2015 TUE
  [Embed Translation]
  * Add support for old QLiE games.

        http://sakuradite.com/upload/image/899.jpg

    为QLiE1引擎的游戏添加了内嵌翻译的支持。截图在上边。

7/5/2015 SUN
  [Embed Translation]
  * Add support for QLiE2 games.
    Tested working for recent Navel games.

        http://i.imgur.com/4FXZxek.png

    为QLiE2引擎的游戏添加了内嵌翻译的支持。截图在上边。

7/4/2015 SAT
  [Embed Translation]
  * Add support for WillPlus games.
    Tested working with Re:BIRTHDAY SONG 恋を唄う死神 and ゴールデンマリッジ.
    Scenario/Name/Choice texts can be translated.
    It also supports embedding ruby definition in the Shared Dictionary.
    VNR will also fix the game encoding issue so that text can display properly without additional locale switcher on Windows with Japanese locale.

      ko: http://i.imgur.com/i0nzBZt.png
      zh: http://i.imgur.com/3ycnXxN.png

    为WillPlus的游戏添加了内嵌翻译的支持。截图在上边。

  [Game Engine]
  * Update WillPlus engine to support extraction of character names.

7/3/2015 FRI
  [Shared Dictionary]
  * Warm up Shared Dictionary after a game is launched.

  [Embed Translation]
  * The transcoding option for Windows translation is slightly changed.
    If your translation's language is English, transcoding is not needed.
    If your translation's language is Korean, Chinese, or any language that has non-ASCII characters
    and the Windows text is not properly displayed, you can try enabling the transcoding option.

    VNR by default won't modify UTF-16 text.
    When transcoding is enabled, VNR will instead first encode UTF-16 text using the system encoding,
    and then decode it using Shift-JIS (i.e. "transcode" wide characters from system encoding to Japanese).
    It might help fix the encoding issue of windows text.

    The transcoding option for scenario/name/other text is removed as it could crash certain games.
    Please use locale switcher such as Locale Emulator instead of replying on embedding translation to fix non-Windows text encoding.

    如果窗口的文字出现乱码，你可以尝试在【使用偏好/内嵌翻译】中打开【转码】的选项。

  * Add an option in Preferences to change the default machine translator for scenario text.
    添加了一个可以修改用来翻译内嵌对话文本的翻译器的选项。

7/2/2015 THU
  [Embed Translation]
  * Make sure that game font for SiglusEngine games can always be changed.
    修正了SiglusEngine的游戏的字体有时无法改变的问题。

7/1/2015 WED
  [Embed Translation]
  * Add support for CMVS engine.
    Tested working with クロノクロック, ハピメア, and 未来ノスタルジア.

        http://i.imgur.com/koWX7V9.png

    为CMVS引擎的游戏添加了内嵌翻译的支持。截图在上边。

6/30/2015 TUE
  [Embed Translation]
  * Fixed a bug that might crash 「Angel Beats」.
    修正了一个可能让「Angel Beats」崩溃的bug。

  * Add support for Cotopha engine.
    Tested working with キスと魔王と紅茶 and お兄ちゃん、右手の使用を禁止します！

        http://i.imgur.com/kpktJ5U.png
        http://i.imgur.com/lUoh6Fa.png

    为Cotopha引擎的游戏添加了内嵌翻译的支持。截图在上边。

  [Game Engine]
  * Update Cotopha engine to support recent games.

6/29/2015 MON
  [Embed Translation]
  * VNR will embed ruby defined in the Shared Dictionary into the game if possible.
    This only works for game engines that support ruby, currently only Leaf and Debonosu games.
    如果游戏引擎支持，VNR会内嵌共享辞书中的Ruby定义到游戏。

  * Update Debonosu engine to support translating all texts in アヤカシ散華.
    修正了「アヤカシ散華」内部分文本无法翻译的问题。

  [Shared Dictionary]
  * Add a property to each rule to specify whether the rule should be applied only to translate window/name/scenario/other thread texts.

    For example, if there are repetitions only in the name text thread.
    Then we can create a game rule to eliminate repeats with context set to Name so that it only applies to the name thread.

    Another example: "ロード" appearing in the Window menu is more common to mean "Load" than "Road".
    Now we can now create a "ロード" = "load" definition and only applies it to translate Window texts.

    English machine translation tends to prepend "A" or "The" before the translation of individual items.
    But for Window texts, for example, it is more common to translate "ゲーム" to "Game" instead of "A game" or "The game".
    Now we can create an output rule to delete leading "A" and "The" for window text translation.

    添加了一个语境属性可以指定词条是否仅仅适用于窗口、对话、姓名和其他文本的翻译。

6/28/2015 SUN
  [Shared Dictionary]
  * Add a new ruby syntax for displaying translation above the translation.
    For example, given the following definition in the Shared Dictionary:
    - Type: Translation
    - Pattern: 雪
    - Translation: Yuki
    - Ruby: Snow
    Then, VNR will translate 雪 to Yuki, while displaying Snow above yuki.
    This might be helpful when you want to translate a word both by pronunciation and by meaning,
    when you can define Translation = pronunciation and Ruby = its literal meaning.

    Alternatively, the above definition is equivalent to the following rule:
    - Type: Translation
    - Pattern: 雪
    - Translation: [ruby=Snow]Yuki[/ruby]

    This syntax might be helpful if you want to define multiple ruby in the same rule. Here's another example:
    - Type: Translation
    - Pattern: 雪ノ花
    - Translation: [ruby=Snow]Yuki[/ruby] no [ruby=Flower]Hana[/ruby]

    If you are familiar with HTML, you can expect [ruby=Snow]Yuki[/ruby] to be transformed to <ruby><rt>Snow</rt><rb>Yuki</rb></ruby>,
    (although it is not what is actually happening under the water. And it won't work if you use <ruby> tag directly in translation.)

    Ruby definition is only allowed when the definition type is Translation, Name, Yomigana, Prefix, Suffix, or Output.

    If you feel Ruby annoying, you can always disable displaying ruby definitions in Preferences/ShareDictionary.

    This feature is requested by @mireado sama and thanks for this suggestion!

    对共享辞书的词条添加了一个Ruby的定义。Ruby的定义会显示在被定义翻译的上边。

    比方说，更定如下定义：
    - 类型: 姓名
    - 匹配: アイリス
    - 翻译: 鸢尾花
    - Ruby: Iris
    那么VNR会把"Iris"显示在"鸢尾花"的上方（好像HTML中<ruby>的语法）。

    另外，上边的定义和如下的语法是等价的：
    - 类型: 姓名
    - 匹配: アイリス
    - 翻译: [ruby=Iris]鸢尾花[/ruby]

    当前Ruby只对翻译、姓名、读法、前缀、后缀和输出词条是有效的。
    如果你不喜欢看到Ruby，可以在【使用偏好/共享辞书】中禁用。

6/26/2015 FRI
  [Embed Translation]
  * VNR will do word wrap to the inlined translation if the game engine supports new lines
    (currently Leaf and Circus) so that a word will not break at new lines for languages having spaces.
    For other engines, word wrap might only work if you manually enable and specify the Maximum Text Width
    in Preferences/Embed.

6/25/2015 THU
  [TAHScript](English, @riz)
  * Update TAH script for LEC.
    The scripts are from @errzotl sensei, and you can say thanks to him/her at TAHscript@outlook.com.

  [Embed Translation]
  * Fixed the issue that embedded Korean text might be retranslated for SiglusEngine games.
    Thanks for @mireado sama's report!

6/24/2015 WED
  [Embed Translation]
  * Restore the support to embed English translations for CIRCUS games.
    Tested working with DC3PP and 水夏弐律, where scenario/name/choice/backlog can be translated.
    It currently only supports English.
    Here's a sample screenshot:
        http://i.imgur.com/DS0hj4q.png

  * Add support to embed English translations for Leaf games.
    It currently only supports English.
    Here's a sample screenshot:
        http://i.imgur.com/gDXlgN3.png

  * Text Settings will display if the game supported embed translation is for English-only.
    Currently, embed support for Circus, Leaf, and System43 games is for English only.

    文本设定会显示内嵌翻译是否仅限英文。
    当前Leaf、Circus和System43的游戏的内嵌翻译仅限英文。

6/22/2015 MON
  [Embed Translation]
  * Update ARCGameEngine to support translating old Eushully game 神採りアルケミーマイスター.
    Here are some screenshots:

        http://i.imgur.com/eSUJaZT.png
        http://i.imgur.com/4WwfSjW.png

    Thanks for @Reality sama's report!

    修正了内嵌翻译无法应用于神采的问题。

6/21/2015 SUN
  [Embed Translation]
  * Add support to translate games with Retouch engine.
    Tested working with らぶらぶプリンセス and 箱庭ロジック.

        http://i.imgur.com/KH5zpr8.png

    为Retouch的游戏添加了内嵌翻译的支持。截图在上边。

  [Game Engine]
  * Update Retouch engine to properly handle ruby texts that are missing in the scenario thread.
    If you are playing Retouch games, you will have to manually re-adjust Text Settings.
    修正了Retouch的游戏中带Ruby的文字跑到对白thread外边的问题。
    如果你在玩Retouch的游戏，请重新调整下文本设定。

6/20/2015 SAT
  [Game Engine]
  * Add an alternative engine for games from でぼの巣製作所 to extract character name,
    which might be important for the automatic TTS feature.

  [Embed Translation]
  * For games from でぼの巣製作所, fix the inconsistent game locale code so that the game can run
    on non-Japanese Windows with Japanese locale.

    I have an English version of Windows 7 that is switched to Japanese locale and UI.
    But to run Debonosu games, I still have to use Locale Emulator, etc. to launch the game even on Japanese locale.
    Now when embed translation is enabled on Japanese locale, Debonosu games will run properly without locale emulation.

    在已经转为日文区域的非日文Windows下启动「でぼの巣製作所」不再需要Locale Emulator等转码工具。

  * Update でぼの巣製作所 engine to translate most GDI+/Direct3D texts.
    Here are some screenshots from 神楽花莚譚:

    - ko: http://imgur.com/KLlV5vL,NCLE4OE,PkXwiB9,uspuxpb
    - zh: http://imgur.com/wm5GAtx,1nKZbEE,WhJuuKM

    几乎全部「でぼの巣製作所」最近的游戏内的文字都可以被翻译了。截图在上边。

  * Improve caching of Other thread translations to reduce possible slowdown caused by embedding Other thread translations,
    esp. for RPG games that might have a large number of Other thread texts.

6/19/2015 FRI
  [Embed Translation]
  * Add support to translate games from でぼの巣製作所.
    Test working for 神楽花莚譚 and 神楽道中記.

        http://i.imgur.com/oxLHPC2.png
        http://i.imgur.com/mXugkp2.png

    添加了内嵌翻译「でぼの巣製作所」的游戏的支持。截图在上边。

  [Game Engine]
  * Hook to GdipDrawString and GdipMeasureString functions for GDI+ games.
    These functions are discovered in Debonosu games. But I think they might also help other GDI+ games.

6/17/2015 WED
  [Game Engine]
  * Text extraction will be paused when either Control or Shift is pressed.
    按下Control或者Shift会暂停提取文本。

  * Add game engine for Silky's new games after leaving Elf.
    Comparing to GetGlyphOutlineA in old VNR, the new engine will not extract garbage configuration texts
    and does not have disordered name and scenario.

  [Embed Translation]
  * Add game engine for Silky's new games after leaving Elf.
    Scenario/Name/Choice texts can be translated.
    Test working with 根雪の幻影 and 堕ちていく新妻.

        http://i.imgur.com/CEnzaG8.jpg

    为Silky's离开Elf后的新游戏添加了游戏引擎。截图在上边。

6/16/2015 TUE
  [Game Engine]
  * Update SiglusEngine to extract text in 円交少女 without any garbage characters.
    Be careful that there will be several SigusEngine3/4 text threads and only ONE is correct.
    Thanks for @mireado sama's report!

    Although the game uses SiglusEngine, embed translation currently does not support 円交少女.
    Going to fix that soon.

    为「円交少女」添加了一个可以提取不带垃圾字符的文本的引擎。

6/13/2015 SAT
  [Embed Translation]
  * Update WolfRPG engine to translate most texts.

        http://i.imgur.com/4Ol75K9.png

    WolfRPG的游戏可以内嵌翻译几乎全部的文本。截图在上边。

    注：有些WolfRPG游戏默认的字体无法显示中文，需要在使用偏好中选定一个既支持中文，又支持日文的字体。
    比如像下边截图那样，设定Tahoma为字体才可以正常显示，因为Tahoma同时支持中文和日文。
    如果使用只包含中文的字体（如SimSun），那么文字会无法正常显示。
    - 正常显示(font family = Tahoma, 字符集 = 不修改): http://i.imgur.com/JP8RN65.png
    - 不正常(font family = SimSun, 字符集 = 简体中文): http://i.imgur.com/C0GkkXF.png

  [Shared Dictionary]
  * The location of the offline data of the Shared Dictionary is moved to Caches/Sync.

  [Network]
  * Improve the communication  mechanism to reduce the failure when fetching large amount of online data such as Share Dictionary and game database.

    In the old version of VNR, VNR's server will query the database and render the large response at runtime,
    which would drain lots of resources, and might cause VNR's server to be less responsive when busy.

    Now, VNR's server will cache the data in Shared Dictionary and Game Database every day (on 4:00am Japan Standard Time).
    Then, VNR will first fetch the old cached static data, and then query incremental changes in the database made within 1 day.
    This will save lots of server resources because serving static data files cost very low memory/CPU and does not require database access.
    And even when the SQL database is busy, users are guaranteed to get the data updated one day ago.

    I am going to shutdown the online services for runtime queries of very large amount of data of Shared Dictionary
    and Game Database at the end of this month, after most users have updated VNR at least to this version.
    After that, I would expect VNR's server to have less busy time.
    But the older versions of VNR will be broken and no longer able to update Game Database and Shared Dictionary after this month.

    Currently, large numbers of user-shared comments/subtitles are still rendered at runtime, and downloading them could still fail when VNR's server is busy.
    I am going to implement the similar caching mechanism to comments/subtitles later to solve this problem.

    改进了VNR在下载共享辞书、游戏数据库时的方式。
    新的通信方式可以大量节省VNR服务器的资源，即使重置数据重新更新，也不那么容失败了。
    但是，在大部分用户还没有更新到这版的VNR之前，VNR的服务器在周末可能还是会很忙。
    我打算在这个月底左右，关闭旧的更新方式。之后服务器就不会那么忙了，但是届时这个版本以前的老的VNR也就不能正常使用了。

6/12/2015 FRI
  [Game Engine]
  * Add hooks to CharNextA/CharNextW for unknown game engines.

  [Embed Translation]
  * Fixed a bug that might hang WolfRPG games when Korean translation was embedded.

6/11/2015 THU
  [Embed Translation]
  * Add support for games developed with Wolf RPG.
    Here are some screenshots from DRAGON SLAVE:

      http://i.imgur.com/wKb7Ova.png
      http://i.imgur.com/XcXtSYT.png
      http://i.imgur.com/2yg4qLu.png
      http://i.imgur.com/VjYOEPj.png

    为WolfRPG的游戏添加了内嵌翻译的支持。截图在上边。

6/9/2015 TUE
  [Embed Translation]
  * Add support for games developed with RPGツクールVX ACE RTP v3.
    Here are some screenshots:
      (魔鎧の少女騎士エルトリンデ)
      http://i.imgur.com/g1rPMgA.png
      http://i.imgur.com/VDxFrso.png
      http://i.imgur.com/tcLTNw6.png
      http://i.imgur.com/wlIa9sn.png

      (Mogeko Castle)
      http://i.imgur.com/r1fuHPJ.png
      http://i.imgur.com/e3QiTwQ.png
      http://i.imgur.com/TEblPCi.png

    为RPGツクールVX ACE RTP v3的游戏添加了内嵌翻译的支持。截图在上边。

6/7/2015 SUN
  [Embed Translation]
  * For ソフトハウスキャラ games, make sure the embed text is always outlined so that it is easier to read.

        http://i.imgur.com/7rnPIET.png

    修正了ソフトハウスキャラ的游戏有时内嵌文本字体没有被outline的问题。上边是截图。

6/6/2015 SAT
  [Embed Translation]
  * Restore the support for Elf/Mink games.
    Test working with 愛姉妹4, 麻呂の患者はガテン系, and SEXティーチャー剛史, where name/dialog/choice texts can be translated.
    Here are some screenshots:

    - en: http://i.imgur.com/crBqxtk.png
    - ko: http://i.imgur.com/Q9W8yAa.png
    - zh: http://i.imgur.com/3OxjgWd.png

    恢复了对Elf和Mink社游戏内嵌翻译的支持。上边是一些截图。

  * Add support to translate name/scenario/choice for games from ソフトハウスキャラ.
    Test working with BUNNYBLACK, アウトベジタブルズ, and 悪魔娘の看板料理.
    Here are some screenshots:
        http://i.imgur.com/AVh0EnP.png
        http://i.imgur.com/F75dGuk.png
        http://i.imgur.com/0iNKRXe.png

    添加了内嵌翻译到ソフトハウスキャラ社游戏的支持。

  * VNR will display if a game engine supports embedding translation in Text Settings.
    For all existing embed engines: System43 supports only English, while any other engines support English/Chinese/Korean on
    Windows Vista or above.

    Support for Windows XP and languages other than English/Chinese/Korean are NOT well-tested, which might or might not work
    properly depending on whether the game font for the embedded character set can be properly customized.

    如果一个游戏支持内嵌翻译，【文本设定】中会显示【支持内嵌】。
    当前支持内嵌的游戏引擎中，只有System43不支持中文；其他的引擎都可以内嵌中文。

6/5/2015 FRI
  [Yomigana]
  * The default romanization standard for Japanese name is slightly changed to be consistent with Wikipedia.
    Additionally, I added an option to Preferences/Translation to toggle whether display macron for Japanese
    names, which is enabled by default.

    Personally, I feel macron is ugly, but it might contain more information.
    If you don't like having macron displayed, you can always disable it in Preferences/Translation.

    Here are some example romaji for Japanese names when macron is enabled (first) or disabled (second):
    - 佐藤(さとう) = Satō, Satou
    - 佐藤(さとー) = Satō, Sato
    - 佐藤院(さとういん) = Satōin, Satoin
    - 曹操(そうそう) = Sōsō, Soso
    - 曹操(そーそー) = Sōsō, Soso
    - 龍神(りゅうじん) = Ryūjin, Ryujin
    - かーくん = Kākun, Kakun

    For the yomigana definitions in the Shared Dictionary, only hiragana will have macron added, and katakana won't.
    For example: さとう will be translated to Satō, while サトウ will still be translated to Satou.
    The reasons behind this behavior are:
    1. Hiragana is usually used for Japanese names, while katakana for English names. And macron does not exist in English.
    2. You can use katakana definition to always disable macron.

  [Embed Translation]
  * Restore the support for all BGI games.
    Tested working with 世界征服彼女, 世界と世界の真ん中で, 恋想リレーション, and ピュア×コネクト.
    Scenario, name, and choice texts can be translated.
    Here are some screenshots from ピュア×コネクト:
    - Korean
        http://i.imgur.com/Hys4wRh.png
        http://i.imgur.com/Q0gApLu.png
        http://i.imgur.com/N365rDE.png
    - Chinese
        http://i.imgur.com/78ASEUC.png
        http://i.imgur.com/nXuERbQ.png

    恢复了内嵌翻译到BGI游戏的支持。
    全部BGI游戏都可以支持才是。对话、姓名、和選択肢都可以翻译。上边是截图。

  [Game Engine]
  * Hook to more GDI functions below:
    - GetCharABCWidthsFloat
    - GetCharWidth32
    - GetCharWidthFloat
    - GetCharacterPlacement
    - GetGlyphIndices
    - GetTabbedTextExtent

6/4/2015 THU
  [Game Engine]
  * Add general hooks to GetTextExtentExPointA/W functions in GDI32.

  [Embed Translation]
  * Update Enshully engine to support embedding all languages.
    Here are some screenshots:
    - Korean
        http://i.imgur.com/wI2bv19.png
        http://i.imgur.com/H8YnZHi.png
        http://i.imgur.com/S7B5xqx.png
    - Chinese
        http://i.imgur.com/JriS8jT.png
        http://i.imgur.com/DJ4ye5p.png
        http://i.imgur.com/dFCPHb5.png
        http://i.imgur.com/BRxxAzj.png

    Eshully的游戏支持内嵌中文翻译了。上边是一些截图。
    下边是一些related的注意事项。

    - 要开启内嵌翻译，直接在【使用偏好/内嵌翻译】里选择打开就好了。所有设定保持默认就好了。

    - 打开内嵌翻译后，VNR会自动删掉Eshully游戏内产生弹窗的函数。游戏不会产出任何弹窗才是。

    - 打开内嵌翻译后，【文本设定】会变成只读的。
      内嵌翻译的过程可以完全自动化，并不需要手动调整文本设定。文本设定仅供debug用。

    - 要开启内嵌翻译，非常建议至少安装一个离线的日中翻译工具。
      如果只使用在线的翻译器如百度，游戏可能会会卡卡的。
      如果你同时打开百度和J北京，那么J北京的翻译会被内嵌，而百度的翻译会和以前一样外挂到游戏。

    - VNR默认会尽力去内嵌人工翻译，比如第一章截图就是。
      但是，如果游戏文本包含ruby，由于技术困难就没有办法内嵌人工翻译了。

    - 如果你只想看到内嵌翻译，而不想看到外挂翻译，那么在左边的dock里，关闭游戏文本、姓名和翻译就好了。

  * Update Eushully engine that its global font can be changed.
    Here are some screenshots for embedding Vietnamese with customized font (family = Tahoma, weight = Ultralight):

        http://i.imgur.com/zwSFlC4.png
        http://i.imgur.com/LicFTRe.png

    btw, regarding the embedded font settings, it might be different for different OSes/languages/games.
    Here are some observations I found mostly from 神のラプソディ and AngleBeats, which might be served as a reference for other games.

    + Changing font might have not effect, and might require restarting the game, depending on the game.
      For example:
      - Changing font for AngelBeats requires restarting the game.
      - Changing font for 神のラプソディ does not require restarting the game
      - Changing font for System43 currently has no effect

    + If the translation is English, you might always want to DISABLE font customization.
      There is no need to change font family or charset to embed English translation in most cases.
      But if the font is too fat, you could try reducing its scale and weight (such as changing weight to Ultralight).

    + If the translation is in Chinese or Korean
      - If the OS is Japanese and >= Windows Vista
        Usually, the font don't have to be changed.
        But we might need to adjust space settings manually.

      - If the OS is Windows XP or not Japanese
        Usually, the font family or charset has to be changed to the one that support both Japanese and the target language.

    + If the translation is not in English, Chinese, and Korean
      Usually, the font has to be changed to the one that support both Japanese and the target language.

    Again to Vietnamese users, as far as I known, JBeijing/FastAIT+HanViet is currently the only way to have offline Japanese-Vietnamese translation.
    If you want to embed Vietnamese translation, I strongly recommend you to unban Chinese in Preferences/i18n, and manually get JBeijing installed.
    Otherwise, if you rely on online translators like Excite instead of the offline ones, it could significantly slowdown the game.

    修正了Eushully的游戏自定义字体无效的问题。

6/3/2015 WED
  [JBeijing](Chinese, @djz020815)
  * 更新了djz大先生的J北京词库。

  [Embed Translation]
  * VNR will automatically disable any msgbox-like popups for Eushully games.

  * Update Eushully engine to support translating some in-game texts.
    Here are some screenshots:
      神のラプソディ
        http://i.imgur.com/4JV3bEc.png
        http://i.imgur.com/Fk52rvI.png
        http://i.imgur.com/QVrFpOa.png
      魔導巧殻
        http://i.imgur.com/ceWWhvF.png
        http://i.imgur.com/3HK0eKJ.png
        http://i.imgur.com/Dtr3u2w.png
      創刻のアテリアル
        http://i.imgur.com/OmW4ef0.png
        http://i.imgur.com/M37LyX9.png

6/2/2015 TUE
  [Embed Translation]
  * Restore the support for embedding translation for Eushully games.
    A screenshot of 神のラプソディ is as follows:

      http://i.imgur.com/7sWgSfr.png

    Known issues:
    1. It currently only supports embedding English translation
    2. Translation could go out of screen if being too long (since English is usually much more verbose than CJK languages)
    3. For Eushully games, when there are Ruby in the text, it will be broken into pieces, which will significantly downgrade
       machine translation quality because the sentence structure of Japanese and English is so different.
       I am going to check if it is possible to totally disable Eushully ruby in the future.

    Because of 2. and 3., I would suggest to turn on both embed and external subtitles at the same time.
    When the embed translation is too long or broken into pieces, you can check the external subtitle instead.

    btw, I recently changed the underlying hook implementation, and all previous embedded game engines were broken as the result.
    Currently, only SiglusEngine, System43, and Eushully(ARCGameEngine) support embedding translation.
    And only UTF16 engines support embedding all languages. SHIFT-JIS engines currently only support English.
    I will restore the support for other previous embed engines later, such as BGI, Circus, Elf, and Majiro.

6/1/2015 MON
  [Embed Translation]
  * Fix the issue that customized font with non-ascii family name might not work.
    Thanks for @mireado sama's report!

  * Fixed a bug in SiglusEngine that sometimes choice text is not translated.
    Thanks for @mireado sama's report!

  * Add options to adjust font size and weight.
    But depending on the game engine, the font settings might or might not work.
    Currently, it works for SiglusEngine, but has no effect to System43.

5/31/2015 SUN
  [TAHScript](English, @riz)
  * Update TAH script for LEC/ATLAS.
    The scripts are from @errzotl sensei, and you can say thanks to him/her at TAHscript@outlook.com.

  [Yomigana]
  * Fixed a issue that text might go out-of-screen when ruby is displayed below instead of above kanji.
    Thanks for @Onurtag sama's report!

  [Embed Translation]
  * Modify the System43 engine to support other AliceSoft games to embed English translation.
    Tested working with ランス9 and 武想少女隊.
    However, since English is usually more verbose than Japanese, the text might sometimes go out of screen.
    Here are some screenshots:

        http://i.imgur.com/vUxx9o0.png
        http://i.imgur.com/KhkOBCf.png
        http://i.imgur.com/E6R1GW2.png
        http://i.imgur.com/HCWdxuc.png

  * Add an option to limit the maximum scenario text width by inserting new lines so that it won't go out of screen.
    This option only works if "\n" can be interpreted as new lines in a game.
    It currently does not work for System43 where \n has no effect.

  * Update SiglusEngine to support translating choices and names for AngelBeats as well.
    Here's a screenshot:

        http://i.imgur.com/ZOFpgsN.png

    AngelBeats可以翻译姓名和选项了。截图如上。

5/30/2015 SAT
  [Embed Translation]
  * Add embed translation support for Evenicle.
    Currently, it only supports English, and might not work for other System43 games.
    Scenario/name threads, windows texts, and some in-game texts can be translated.
    Here are some screenshots:

      AVG part: http://i.imgur.com/aIM4dWN.png
      RPG part: http://i.imgur.com/1HIIwSR.png

    Note that the Text Settings for embedding translation is changed to be read-only and left only for debugging purposes.
    Since everything can be automated to embed translation, there is no need for manually adjusting Text Settings.

5/25/2015 MON
  [Game Engine]
  * System43+ engine is slightly modified to get rid of illegal characters from the text.
    But you will have to re-adjust Text Settings if you are using System43+.
    如果你在用System43+的文本，请重新调整下文本设定。

5/24/2015 SUN
  [Embed Translation]
  * Game is no longer required to be launched with AppLocale.
    There are no longer any requirements for launching the game to embed translation.
    But if the game is launched in Japanese locale, you might need to select a different font that support
    the character set of the embedded translation in Preferences/Embed.
    Tested working on Windows XP and Wine now.

    内嵌翻译不再需要用AppLocale运行游戏。
    如果游戏在日文环境中打开，那么会需要在【使用偏好/内嵌翻译】中修改游戏字体的编码为中文。
    另外，内嵌翻译可以在Windows XP和Wine上正常运行了。

  * Embedding translation is now working for all languages.
    Here's a screenshot for AngelBeats with JBeijing+HanViet offline Vietnamese translation embedded:

       http://i.imgur.com/ZjDpVkJ.png

    To display non-English language properly, it is critical to select a proper font.
    You might have to tune the font and space settings a little bit in Preferences/Embed.
    Changing font family might require restarting the game, which is currently painful to tune though.

    The best font should ideally support both the character sets of Japanese and the target language (such as Vietnamese),
    which, however, might not exist in Windows's default fonts.
    For example, to display Japanese-Vietnamese properly, I used SimSun (仿宋), which is indeed a Chinese font.

    If you don't want to manually specify the font, you can also enforce the character set of the font, and let Windows to
    automatically pick one for you.
    Here's a screenshot for embedded Thai translation from Bing without explicit font selection:

       http://i.imgur.com/itNhEeB.png

    There are weird spaces in the middle though, as I don't have a proper Thai font installed in my Japanese Windows.

5/23/2015 SAT
  [Game Engine]
  * Add Bootup engine for games containing Bootup.dat in the game folder.
    Tested working with 仏蘭西少女, 三国恋戦記, 神学校, and 絶対階級学園 from PIL/Daisy^2.
    为一些PIL和Daisy^2的游戏添加了提取文本的支持。

  [Embed Translation]
  * Create multiple communication channels so that concurrent translation requests won't hang the game.
    There should be no more hanging problem with user-shared subtitles or offline machine translation.

  * You can press SHIFT or CTRL to temporarily pause embedding translation.
    按下Shift或者Ctrl可以暂停内嵌翻译。

  * Add an option to change game's default font.
    If game's default font cannot properly display the characters of the embedded language, you can change it to another font.

    Note: If you want to select VNR's fonts in Library/Fonts as game's font (such as Nanum Barun Gothic),
    you have to manually install that font file in Library/Fonts to your $windir/Fonts directory first.

    添加了一个修改内嵌字体的选项。
    如果游戏默认的字体无法正常显示中文，可以用这个选项来强迫更换字体。

5/22/2015 FRI
  [Embed Translation]
  * Add an option to insert spaces between text to fix the text overlapping issue.
    Depending on different OSes/Locales/Languages/Fonts of the host system, sometimes certain
    characters might overlap with each other.

    When all characters overlap like the following one, it can be fixed by turning on the
    Insert Spaces After Every Character option.
        http://i.imgur.com/mUXTk6w.png

    When only a few characters overlap like the following one (覚 and め overlapped), it can be
    fixed by turning on the Insert Spaces Only Between Overlapped Characters option.
        http://i.imgur.com/m5MZDfk.png

  * Fixed the jittering issue.

    I removed the "alpha" tag for embed translation, as I feel it has no critical issues now (at least for SiglusEngine).
    Feel free to give it a try if you are speaking English/Chinese/Korean and NOT using Windows XP.
    More details could be found here: http://sakuradite.com/wiki/en/VNR/Embedded_Translation

    There are two issues left though that I am going to work on later:
    - Support changing game's fonts
      Currently, embedded non-Japanese characters might or might not be rendered well on Windows XP, because it's system
      default fonts do not support a wide range of character sets.
      Changing game default font might help fix this issue.

    - Support translating choices and other texts, which might be important esp to RPG games.

    Here are some related hints that might be helpful:
    - Even if embedded translation is enabled, VNR will still display external subtitles.
      If you want to disable external subtitles, just toggle off Text, Name, and Translation in the left option dock.
      And automatic TTS will not get affected by whether displaying subtitles or not.

    - Machine translation quality is usually not good for non CJK languages
      Both translation and original text can be displayed together by toggling Preferences/Embed
      in case the machine translation does not make sense.

    - To turn on Embed Translation, I strongly recommend to have at least one offline machine translator installed.
      Otherwise, the latency of online translation might cause game to get jittered and slowdown.

    修正了内嵌翻译会卡住的问题。

    我觉得内嵌翻译的功能已经没有什么大问题了。
    如果你没有在用Windows XP，那么也许可以尝试下打开这个机能。

    下边是关于这个功能的一些简单介绍。一些细节可以在这里找到：http://sakuradite.com/wiki/zh/VNR/内嵌翻译

    所谓内嵌翻译，其实就是把游戏中日文的文本用中文的人工或者机器翻译直接替换掉。
    不过当前，只有很少一部分游戏的对话可以被替换，游戏选项等文本和大部分游戏都不支持的。
    在只有SiglusEngine的游戏有很好的测试过，其他的支持内嵌的引擎（比如Eushully）我还没有测试。

    另外，内嵌的文字在日文的Windows XP上，可能无法正常显示，会变成点状乱码。
    我只有日文的Windows XP，没有中文的Windows XP，不清楚内嵌翻译在中文Windows XP上是否可以正常工作（估计不能）。
    在Windows Vista以上的操作系统没有这个问题。

    开启这个技能的方法如下：
    1. 在【使用偏好/内嵌翻译】中打开内嵌的选项
    2. a. 如果你在使用日文的Windows，那么在Spring Board中点击【编辑】，修改游戏的启动方式为AppLocale，并改区域为中文。
       b. 如果你在使用中文的Windows，那么在Spring Board中点击【编辑】，修改游戏的启动方式为禁止转区。
       推荐使用a方法，因为b方法很多游戏如果不转区根本不能启动。

    一些用处不大的tip：
    - 即使打开内嵌翻译，VNR默认还是会渲染外挂字幕。
      如果你只希望看到内嵌而不像看到外挂字幕，可以在左边的选项里关闭游戏文本、姓名文本、机器翻译、人工字幕四个就好了。
      另外，自动语音合成不会因为关闭外挂字幕而受到影响。

    - 由于机器翻译的准确度不高，你也可以在【使用偏好/内嵌翻译】里设定同时显示日文原文和中文翻译。

    - 如果要使用内嵌翻译，强烈推荐至少安装可开启一个离线的日中翻译器。
      由于在线翻译（比如百度）的延时，可能会然游戏一卡一卡的。
      如果你一定要用比如百度，那么可能会需要在【使用偏好/内嵌翻译】里增加最大翻译延时。

    - 如果你在使用正体中文，那么最好在【使用偏好/翻译/中文】中打开强制将简体字幕转换为正体中文的选项。

5/21/2015 THU
  [Yomigana]
  * The option to display ruby below instead of above kanji is restored in Preferences.
    A screenshot is as follows:

        http://i.imgur.com/L4Wkbp2.png

    恢复了上下颠倒振仮名的使用偏好的选项。
    截图在上边。

  [Fonts](Korean)
  * UI font changed to "Nanum Barun Gothic" when UI language in Preferences is Korean.

  [Embed Translation]
  * Add option in to display both original Japanese text and translation in separate lines.
    When enabled, the translation will be appended after Japanese, instead of replacing Japanese.
    Here's an example: http://i.imgur.com/u6uFyHu.png

5/20/2015 WED
  [Name Detection]
  * To be aware of more quotes while guessing speaker's name of a sentence.
    In the old version, VNR was only aware of 【】 and 「」.
    Now, the following pairs of quotes are added:
    - 「」
    - 『』
    - 《》
    - （）
    - ()
    - ＜＞
    - <>
    - 〝〟
    - “” (full-width)
    - ‘’ (full-width)

    Some features that get affected because of this:
    - Name guess accuracy for automatic Text-to-speech is improved
    - User-shared subtitle/danmaku matching accuracy is better
    - Sentence split for machine translation is slightly changed to be aware of quotes

    For example, given the following Japanese sentence:
        爽（悠真くんを攻略すれば２１０円か）
    It will be split into:
        爽, （, 悠真くんを攻略すれば２１０円から, ）

    However, the following two Japanese sentences will NOT get split by VNR.
        爽（悠真くんを攻略すれば２１０円か）なるほどなぁ
        悠真くんを攻略すれば２１００００円か（なるほどなぁ）
    Because VNR will think （） here are not sentence deliminators.
    - For the first sentence, it does not end with "）".
    - For the second sentence, the text before "（" is too long to be a Japanese name.

    改善了从日文文本中猜测姓名时，对各种引号的处理。

  * The assigned name for TTS is slightly changed when VNR failed to guess speaker's name.
    For example, given three sentences below.
    The assigned name for the first sentence will be "Aside", and that for the last two sentences
    will be "Unknown". Though being unknown, you can now select voices for unknown characters.

        悠真くんを攻略すれば２１０円か     -- aside
        「悠真くんを攻略すれば２１０円か」 -- unknown
        （悠真くんを攻略すれば２１０円か） -- unknown

    稍稍修改了下TTS配音时识别人物姓名失败时的行为。
    比方说，给定上边的三句话。
    那么第一句话的人名会被识别为“旁白”，而第二和第三句话为“未知”。

  [Shared Dictionary UI]
  * If you have either KanjiDic or Radical dictionary enabled in Preferences, VNR will display the
    decomposed radicals and translations of all kanji in the pattern (such as Japanese names).
    It might be helpful for learning CJK hanzi.

  [Embed Translation]
  * Update SigusEngine to support embedding translation for AngelBeats.
    Some screenshots are as follows:

      http://sakuradite.com/images/screenshots/angelbeats_ko.jpg (Korean translation made by created by @mireado)
      http://sakuradite.com/images/screenshots/angelbeats_zh.jpg (Chinese translation made by @直入哑然)

    The encoding issue for CJK is fixed for SiglusEngine. It might still not work for other languages/engines though.

    Some known issues:

    + When embedded translation is enabled, the game might periodically get jittered/hanged, which is very annoying.
      This jittering problem is very very very annoying.
      I am going to try to fix this problem soon.

    + Encoding issue for non-English languages
      - Chinese and Korean
        The game must be launched in Chinese/Korean locales instead of Japanese.
        This can be done by either using AppLocale to launch AngelBeats in Chinese/Korean locale on Japanese Windows,
        or switching Windows locale directly to Chinese/Korean.

      - Traditional Chinese
        When the game is launched in Traditional Chinese locale, the option of Traditional Chinese variants in
        Preferences/Translation/Chinese must be enabled.

      - Other languages
        I didn't test support for other languages myself. It might or might not work.

    + While choices can be translated, there is currently no way to add manual translation for choices.
      Only machine translations will be used.

    我在尝试改善对AngelBeats嵌入翻译的支持。
    现在还有一些问题，等改好了再说吧。

5/18/2015 MON
  [Shared Dictionary]
  * Output rules can have grammatic roles in it.
    For example, given two definitions:

    1. 悠真 => Yuuma, type = translation, role = m
    2. University of [[m]] => [[m]] University, type = output

    It will transform "University of Yuuma" to "Yuuma University".

    However, the "Role" column of an Output definition itself is currently unused.

  (Korean)
  * The roles of noun(n)/name(m) for Korean translation will be automatically changed to reflect
    the final hangul character of the last syllable.

    For example, given a name definition 悠真 = 유우마 with role = m, VNR will replace m by m$o,
    where $o indicates "유우마" ends with a vowel (ㅏ).
    Similarly, given a suffix definition 君 = 군 with role = m, VNR will replace m by m$x$n,
    where $x means "군" ends with a consonant, and $n means that consonant is ㄴ.

    Additionally, "$" is similar to "_" that implies the inheritance relation.
    For example, m$x$n inherits all rules for [[m]] and [[m$x]].

    Here are some output definitions that might illustrate the usage of this syntax:
    - [[m$x]]를 => [[]]을
      It will replace 를 after all names ([[m]]) ending with a consonant by 을.
    - [[m$o]]을 => [[]]를
      It will replace 을 after all names ([[m]]) ending with a vowel by 를.
    - [[m$x$l]]로 => [[]]으로
      It will replace 로 after all names ([[m]]) ending with ㄹ by 으로.
    - [[m$x,n$x]]를 => [[]]을
      It will replace 를 after both name (m) and noun (n) ending with a consonant by 을.

    A list of $ suffices that will be automatically added to n/m are as follows:
    - $o: the last hangul character ends with a vowel
    - $x: the last hangul character ends with a consonant
    - $x$g:  ᆨ
    - $x$gg: ᆩ
    - $x$gs: ᆪ
    - $x$n:  ᆫ
    - $x$nj: ᆬ
    - $x$nh: ᆭ
    - $x$d:  ᆮ
    - $x$l:  ᆯ
    - $x$lg: ᆰ
    - $x$lm: ᆱ
    - $x$lb: ᆲ
    - $x$ls: ᆳ
    - $x$lt: ᆴ
    - $x$lp: ᆵ
    - $x$lh: ᆶ
    - $x$m:  ᆷ
    - $x$b:  ᆸ
    - $x$bs: ᆹ
    - $x$s:  ᆺ
    - $x$ss: ᆻ
    - $x$ng: ᆼ
    - $x$j:  ᆽ
    - $x$c:  ᆾ
    - $x$k:  ᆿ
    - $x$t:  ᇀ
    - $x$p:  ᇁ
    - $x$h:  ᇂ

    Special thanks for @mireado sama's extensive help and ideas on this topic!

5/17/2015 SUN
  [Shared Dictionary]
  * Add some kind of implicit inheritance to the grammar roles.
    Given two rules, say, "abc" and "abc_de", then "abc_de" will automatic inherit all patterns of "abc".
    Basically, the role whose name like "baserole_somevariant" with a "_" in the middle will always inherit "baserole".
    Similarly, "a_b_c_1_2" will inherit "a", "a_b", "a_b_c", and "a_b_c_1" as well.
    This behavior is designed in order to solve Korean post-positioned particle problem, but might help other languages as well.
    For example, "adj_to" and "adj_na" will automatically inherit "adj".

    And here's what I mean by "inheritance", given two rules for example:
    #1 pattern = "兎", translation = "Rabbit", role = m_animal
    #2 pattern = "[[m]]さん", translation = "[[m]]-san", role = m
    Because m_animal can inherit m, "兎さん" will be translated to "Rabbit-san".
    i.e. #1's role m_animal will match #2's "[[m]]さん".

    Additionally, such inheritance relation is Partially Ordered.
    For example:
    #1 pattern = "兎", translation = "Rabbit", role = m
    #2 pattern = "[[m_animal]]さん", translation = "[[m_animal]]-san", role = m
    Then, "兎さん" will only be translated to "Rabbitさん" instead of "Rabbit-san".
    Because m will NOT inherit m_animal.

  (Korean)
  * Insert a space between name and suffix for Korean.
    For example: "悠真くん" will be translated to "유마 군" instead of "유마군".

5/16/2015 SAT
  [TAHScript](English, @riz)
  * Update TAH script for LEC/ATLAS.
    The scripts are from @errzotl sensei, and you can say thanks to him/her at TAHscript@outlook.com.

  [Text Settings]
  * Fixed a bug that selected Other Threads were not saved.
    Thanks for @mireado sama's report!
    修正了文本设定中的【其他】文本没有保存的bug。

  [Game Engine]
  * When Text Settings window is visible, VNR will always inject built-in engines, no matter H-code is set or not.
    When there is H-code available, VNR will not inject game engines unless H-code is deleted or Text Settings is opened.
    I am worried a wrong H-code might prevent VNR from injecting, and hence changed to this way.
    当文本设定的窗口打开时，不论是否有特殊码，VNR都会注入游戏引擎的。
    这样是为了防止错误的特殊码让VNR的游戏引擎失效。

  [Fonts](Korean)
  * VNR by default uses DFGirl (a multilingual lolita font) to render Korean texts.
    @mireado requested changing it to Nanum Barun Gothic, which is a free web font family made by Naver.com.
    Unlike Hanazono font (花園明朝), Nanum font is not required by VNR to work normally at all.
    But Korean texts might look better after switching to this font.

    VNR can automatically download NanumBarunGothic in Preferences/Downloads/Fonts.
    And the Font for Korean can be changed at Preferences/Fonts.
    Alternatively, you can get NanumBarunGothic manually in the following location:
        https://github.com/hiun/NanumBarunGothic
    And here's the set of all Nanum fonts:
        http://hangeul.naver.com/2014/nanum

5/14/2015 THU
  [Yomigana](Korean)
  * "っ" is handled slight differently while converting to hangul as requested by @mireado.
    For example: ゆりっぺ will now be translated to 유릿페 instead of 유맆페 in old VNR.
    When "っ" cannot be patched to the previous hangul character, it will be replaced by "ㅅ".
    For example: って => ㅅ테 and ゆりっっぺ => 유릿ㅅ페

  [Game Launch]
  * When VNR is not launched as Administrator, it will always force launching games as non-administrator,
    even if the game itself requires Administrator privileges.
    This applies to launching games with or without launchers like AppLocale, but except LocaleSwitch.
    It might or might not work for all games that require admin privileges though.
    当VNR不是以管理员身份启动时，会强制用非管理员的身份启动游戏。
    即使游戏本身需要管理员权限，VNR仍旧会无视权限，而以非管理员的身份强迫游戏启动。

  [Game Engine]
  * Update RealLive engine to support new games from 裸足少女.
    添加了对裸足少女社游戏提取文本的支持。

  * Fix the issue that BALDRSKY ZERO games might be spammed by mono_string functions.

  * If there are user-defined H-code for a game, VNR will not hook to any places other than the one defined by that H-code.
    VNR's entire built-in hooks/engines will not be injected when H-code is available.
    This will avoid potential issues caused by Lstr functions and outdated built-in game engines.
    当用户自定义的特殊码存在时，VNR就不会去hook游戏的其他地方了。

  btw., I noticed that text extraction is totally broken for certain games (such as ショコラ) on Windows 10.
  I haven't figured out the reason yet. But if you find other games not working only on win10, just let me know!
  btw., 注意到在win10上VNR无法从部分游戏（比如：ショコラ）提取文本了。
  如果你有发现其他游戏只在win10有无法提取文本的问题，可以让我知道！

5/12/2015 TUE
  [Game Engine]
  * Add an alternative hook for イブニクル.
    Unlike the old System43 hook, the new one has no garbage threads and can extract
    character names, which might be helpful for VNR's automatic TTS function.

5/9/2015 SAT
  [Shared Dictionary](Chinese)
  * 对于带正则表达式的读法词条，转换为中文时词首和词尾的括号和问号会被删掉。
    比方说：
    - "愛(?!情)" 会被转换为 "愛"
    - "愛{{bos}}" 会被转换为 "愛"
    - "愛(情)?" 会被转换为 "愛"
    - 然而，"愛(情)?君" 不会被转换为 "愛君"，因为括号不在句首、句尾。

  [Dictionary]
  * Add options to lookup KanjiDic in French, Spanish, and Portuguese.

5/8/2015 FRI
  [Game Engine]
  * Add text detection support for イブニクル的 with AliceRunPatch.dll.
    为イブニクル的1.0.1版添加了提取文本的支持。

    btw, I am gradually moving game engines written in C to Python.
    This allows me to directly use regular expressions to search memory, which is so expressive and convenient.
    The instruction pattern for AliceRunPatch is just expressed in a simple regex instead of a while-loop in C.
    I am thinking maybe I can create another independent app for developers just for memory debugging with regex.
    Additionally, the current memory search implementation in ITH does not work well for emulators like PPSSPP
    with huge memory space, which is very slow, not scalable, and will crash in WinXP.
    Switching to Python to search outside of the game process will fix this issue.
    This will also allows me to scriptify game engines maybe in javascript and allows users to edit in the future,
    since altering engines does not require compilation like in C.

5/7/2015 THU
  [Dictionary]
  * Add an option to display decomposed radicals of kanji.
    For example, "香" can be split into "禾(grain)" and "日(sun/day)".

    To display the radical properly, additional Hanazono font (花園明朝) is needed to be
    installed in Preferences/Downloads.

    btw, I wrote a topic on how Chinese hanzi are being designed and combined, which might
    be helpful to understand how kanji are made from these decomposed radicals.

        http://sakuradite.com/topic/826

    添加了一个显示汉字偏旁部首的选项。
    如果你的中文超过了小学水平，那么无视这个选项好了。
    另外，在【使用偏好/下载】中添加了一个花園明朝的字体。
    这个字体主要是用来显示偏旁部首的，大家也无视好了。

  * Add an option to display individual kanji translation using KanjiDic.
    KanjiDic can be downloaded for free in Preferences/Downloads.
    When enabled, combining with radical dictionary, a kanji might be rendered like this:

       戦{war}: [単{simple}, 戈{spear}]

5/3/2015 SUN
  [i18n](Korean, @mireado)
  * Update VNR's UI translation in Korean made by @mireado sensei.

  [MeCab]
  * Add option to highlight Japanese phrases based on their grammatic roles.
    It is enabled by default, and can be turned off in Preferences/Translation/Dictionaries.
    A screenshot is as follows:

        http://sakuradite.com/images/screenshots/ex_role.png

    Here's the current set of grammar roles (if you click the role, VNR will popup explanation):
    - m: 名前, name, probably human's
    - mp: 地名, place name
    - n: 名詞, noun
    - pn: 代名詞, pronoun
    - v: 動詞, verb
    - a: 形状詞, stem of adjective/adverb
    - adn: 連体詞, adnominal
    - adj: 形容詞, adjective
    - adv: 副詞, adverb
    - p: 助詞, particle
    - aux: 助動詞, auxiliary verb
    - suf: 接尾辞, suffix
    - pref: 接頭辞, prefix
    - int: 感動詞, interjection
    - conj: 接続詞, conjunction
    - w: 記号, word in latin or other special characters
    - punct: 補助記号, punctuation
    - x: other common phrases

    And here's the current color theme:
    - noun-based phrase: green
    - verb-based phrase: purple
    - adjective-based phrase: yellow
    - name and pronoun: red
    - conjunction: blue
    Currently, I haven't added an interface to change these colors.

    添加了对日文词组做语法加亮和显示日文词性的选项。
    这个选项默认是打开的，在【使用偏好/翻译/辞书】中可以关闭。
    下边是截图：

        http://sakuradite.com/images/screenshots/ex_role.png

5/2/2015 SAT
  [Shared Dictionary](Russian, Ukrainian)
  * English name definitions will be converted to Russian/Ukrainian alphabet.
    For example, given a name definition ヘルマン => Helman in English, VNR
    will translate ヘルマン to Хелман in Russian and Гелман in Ukrainian instead.

  * Russian name definitions will be converted to Ukrainian alphabet.

  [Yomigana](Korean)
  * Properly handle "っ" while converting Japanese kana to Korean hangul.
    For example, ゆっき will now be converted to 윸키 instead of 유키.

5/1/2015 FRI
  [Yomigana](Greek)
  * Support generating translation from yomigana in Greek alphabet.

4/30/2015 THU
  [Dictionary]
  * Add an option in Preferences to use OVDP to provide English translation.
    OVDP (Open Vietnamese Dictionary Project) developed a set of open-source dictionaries for Vietnamese.
    Though originally for Vietnamese, OVDP also provides a short English explanation before each entry.
    It could be used together with EDICT to provide more English translations.

  * Add option in Preferences to display Dutch/French/Russian translations above Japanese phrases.
    JMDict is needed to be installed.

    Since the vocabulary of JMDict is relatively small, you can combine JMDict with EDICT/OVDP.
    When both non-English and English translations are enabled, VNR will lookup non-English dictionaries (JMDict) first.
    If there is no match, it will then fallback to English (such as EDICT).

  Note to Russian users:
    If you would like to enable displaying Russian translation, I would strongly recommend to change the Japanese font
    in Preferences/Fonts from "MS Gothic" to "Tahoma", or any other fonts that include both Japanese and Cyrillic characters.
    Otherwise, Russian characters will look ugly in VNR and might sometimes go out of screen.

    VNR by default uses MS Gothic to render Japanese, which always shows Cyrillic characters in full-width.
    This will break VNR's assumption that non-CJK characters are all in half-width, and might break how VNR calculates text width.
    Changing the font to "Tahoma" will fix this issue.

  [Machine Translation](Russian, Ukrainian, Greek)
  * Add an option in Preferences/Translation to convert English in the translation to the alphabet of the user language,
    including Greek letters, Russian Cyrillic letters, and Ukrainian Cyrillic letters.

    Since many machine translators use English as the intermediate language, there are usually untranslated English words leaving
    in the result translation. And in the Shared Dictionary, there are also a lot of translations that are for English only.
    This option when enabled will force converting these untranslated words to the letters in the target language's alphabet.

  [Yomigana](Ukrainian)
  * Support generating translation from yomigana in Ukrainian.

  [Game Engine]
  * Add hooks to TabbedTextOutA/TabbedTextOutW in GDI.
    It is intended to support extracting texts for games from らすこう,  but it might support some other games as well.

    为「らすこう」社的游戏添加了提取文本的支持。
    感谢@lambl sama的报告！

4/29/2015 WED
  [Language]
  * Add translation support for Norwegian, Swedish, Finnish, Danish, Hungarian, Czech, Slovak,
    Greek, Romanian, Ukrainian, and Turkish.
    Additionally, Ukrainian is sharing vocabulary with Russian in the Shared Dictionary.

  [TAHScript](English, @riz)
  * Update TAH script for ATLAS.
    The scripts are from @errzotl sensei, and you can say thanks to him/her at TAHscript@outlook.com.

  [JBeijing](Chinese, @djz020815)
  * 更新了djz大先生的J北京词库。

4/27/2015 MON
  [Dictionary](German)
  * Add option to display German translation directly above Japanese phrases.
    It requires Wadoku EPWING dictionary to be installed in Preferences/Downloads.
    When enabled, a Japanese sentence will be like this:

     ich     Ichijō Akiram
   「 俺   は  一条    彰   、  デュエリスト だ」

4/26/2015 SUN
  [Dictionary](Vietnamese)
  * Add option to display Vietnamese translation directly above Japanese phrases.
    It requires OVDP Japanese-Vietnamese dictionary to be installed.
    When enabled, the Japanese will be look like this:

      forget well   memory   inside  shell  nghi vấn    quiet   shed hair
    「 忘れた まま、  記憶  の   中    から    疑問    は 静かに  抜け落ち た。」

    The translation displayed is usually English, and sometimes Vietnamese (such as nghi vấn).
    Also, the translation is not guaranteed to be correct, such as: から => shell.

  * OVDP dictionary support is changed to use StarDict format to save disk space.
    OVDP dictionary now requires only 40MB.
    If you have old OVDP dictionary installed, VNR will delete it on the startup.
    It can be redownloaded for free in Preferences/Downloads.

    If VNR's download script is slow (it currently picks a DL mirror in US), you can also manually
    get the dictionary from the following location:

        http://sourceforge.net/projects/ovdp/

    And then extract the downloaded NhatViet.zip to:

        Caches/Dictionaries/OVDP/NhatViet

    btw, VNR now supports dictionaries in StarDict format.
    If you need more StarDict dictionaries support, feel free to let me know. Thanks!

  [Game Engine]
  * Update GXP engine to support 「ウルスラグナ」.
    And don't forget to maximize the game text speed.

    The issue that old GXP games had floating split is also fixed.
    If you are playing GXP games (such as Astronauts's), you might have to re-adjust Text Settings.

    添加了对「ウルスラグナ」提取文本的支持。
    不要忘记将游戏文字的速度调整为最快。

    另外修正了以前的GXP引擎的游戏有浮动签名的问题。
    如果你在玩以前的GXP游戏（比如Astronauts社的），会需要重新调整下文本设定。

4/25/2015 SAT
  [Dictionary]
  * If you have blocked English, VNR will no longer show EDICT-related options in Preferences.

  * Add option to display Chinese/Korean translation directly above Japanese phrases.
    It requires at least one Japanese Lingoes dictionary to be installed for these languages.
    When enabled, the Japanese will be rendered like this:

     =そうして  생각하기 시작하다   말     울다   영원    정원  기계    놓치다
   「  そして        思い出す      こと は なく 、永遠 に その  機会 を  逃す のだった。 」

    Here, "=そうして" means "そして" is an alias of "そうして" in spoken Japanese.

    VNR currently simplify picks the first meaning it has got in the dictionary, which could be wrong.
    For example, "なく" here should not be "울다", which means "泣く"(verb) instead of "無く"(adj).

    In the future, I plan to use UniDic's role (verb, noun, adj, etc.) to filter dictionary entries,
    which might help disambiguate phrases having different meanings.

    可以在日文上方直接显示中文或韩文的翻译，也许对学习日文的同学有些帮助。
    比如，开启后日文可能会显示成这样：

      与其…莫如  那  周围       ぼろぬの      充分    那么  喂
   「  むしろ  、その 辺 にある  ボロ布  でも 充分 なんじゃ ねえの」

    开启需要安装至少一本Lingoes日中字典。
    不过VNR只会从辞书中选择第一个解释来显示，翻译可能是错的。

4/20/2015 MON
  [TAHScript](English, @riz)
  * Update TAH script for ATLAS/LEC.
    The scripts are from @errzotl sensei, and you can say thanks to him/her at TAHscript@outlook.com.

4/14/2015 TUE
  [MeCab]
  * Fixed a bug that UniDic could not be automatically downloaded.
    修正了无法正常下载UniDic的问题。

  * Restore the feature to display EDICT translation directly above Japanese phrases.
    It requires EDICT to be aligned with UniDic.
    VNR will re-align EDICT after first launch if you have EDICT installed by old version of VNR.

    For example, given a Japanese sentence:

        「努力に世界が応えるのよ」

    It will be rendered by VNR like this:

         great effort     the world    respond
      「     努力      に    世界   が   応える  のよ 」

    And the yomigana translator will translate the entire sentence like this when "English" is selected:

       「great effort ni the world ga respond no yo」

    If you click 努力, the MeCab feature will be like this:

        努力,どりょく,doryoku,n,vs,EDICT,great effort

    The columns immediately before EDICT (n and vs) are the roles of the phrase, which means it is both
    a noun and a 基本形(s) verb.

    VNR currently simply pick the first short meaning of an entry in EDICT as its translation, which,
    however, might not be always correct.
    And the definition collision between EDICT and UniDic is not well-handled.

    恢复了通过查询EDICT直接在日文上边显示翻译的选项。
    开启后，游戏的文本可能会渲染成好像这样子：

         great effort     the world    respond
      「     努力      に    世界   が   応える  のよ 」

4/13/2015 MON
  [TAHScript](English, @riz)
  * Update TAH script for ATLAS/LEC.
    The scripts are from @errzotl sensei, and you can say thanks to him/her at TAHscript@outlook.com.

4/12/2015 SUN
  [Ehnd](Korean)
  * Fixed the issue that external native Ehnd plugin did not work.
    However, due to technical difficulties, toggling the Ehnd option now requires restarting VNR.
    The logic that which version of the dll will be loaded is as follows:
    - Enable the Ehnd option in Preferences
      Use VNR's built-in dll, no matter whether you have installed Ehnd in ezTrans directory.
    - Disable the Ehnd option in Preferences
      Use the native Ehnd plugin you put in the ezTrans directory.

  [Yomigana]
  * Add option in Preferences/Translation to display ONLY the yomigana (such as romaji) as subtitles.
    在【使用偏好/翻译】中添加了显示日文比如罗马字为字幕的选项。

  * Conversion support from Japanese kanji to Vietnamese Phiên âm is restored.

4/11/2015 SAT
  [Dictionary]
  * Speedup dictionary lookup.
    I rewrote the implementation for looking up EDICT and Lingoes dictionaries, which is now extremely fast
    that the lookup time is less than 0.1 sec, even for some very large dictionaries, such as OVDP for Vietnamese.
    改善了查询日中辞书的速度。

  [MeCab]
  * Japanese segmentation implementation using MeCab is now switched to that used by VNR's SMT vtrans.
    This will allow me to integrate Shared Dictionary with statistical machine translation in the future.
    There are a couple of changes caused by the switch of the implementation.

    + Removed features
      - IPAdic support is removed. UniDic is now the ONLY MeCab dictionary supported by VNR.
        UniDic must be installed in Preferences/Downloads to enable Japanese word segmentation.
      - CaboCha highlight support is removed.
        I will change to highlight phrases according to their roles (name, noun, verb, etc.) instead later.

    + Broken features that I haven't got time to implement
      - Displaying Vietnamese Phiên âm above Japanese kanji is broken, and temporarily disabled.
      - Displaying EDICT translation directly above Japanese phrases is broken, and temporarily disabled.
      - Displaying Furigana for web page is broken, and temporarily disabled.

    + New features
      - Dictionary alignment for EDICT
        For example, given a Japanese sentence:
            ごめんなさい、先生！
        Without EDICT alignment, VNR by default will segment it into:
            ごめん + なさい + 、+ 先生 + ！

        With EDICT alignment, because there is a translation entry for ごめんなさい = Sorry in EDICT,
        VNR will now segment the sentence into:
            ごめんなさい + 、+ 先生 + ！

        Now if you click ごめんなさい, VNR will popup the "Sorry" translation in EDICT.
        This methodology is borrowed from vtrans' code to learn word segmentation rules from dictionary entries.

        Whether enabling EDICT alignment really depends on your need.
        Without EDICT alignment, VNR will segment ごめん out, and when you click ごめん, VNR will display its
        UniDic feature like this:
            名詞,普通名詞,一般,ごめん,御免,漢
        This means 御免 is a "general noun" (普通名詞), and its pronunciation is borrowed from Chinese (漢)
        (and hence it sounds similar to Chinese).
        However, after EDICT alignment is enabled, you cannot easily observe such information anymore.
        VNR will instead display the English translation for the entire ごめんなさい.

        Basically, if you cannot read Chinese such as 名詞, and you are an English speaker,
        it might be better to enable EDICT alignment.
        Otherwise, enabling alignment or not depends on whether you are more comfortable with Chinese or English.

    In the future, I will use yomigana/name entries in Shared Dictionary to align MeCab as well.
    And I will add support to align MeCab for other languages, such as:
        Naver for Korean, OVDP for Vietnamese, and Wadoku for German

    修改了VNR中使用MeCab分词的实现。
    这造成关于分词选项的一些比较大的变更。

    1. 删除了对IPAdic和CaboCha的支持。要使用分词功能，只要在使用偏好中下载UniDic一个就好了。
    2. 添加了一个使用EDICT矫正MeCab分词的选项。
       这个选项主要是针对英文读者的。
       如果你的英文不好，那么其实不用下载EDICT和打开这个选项。

  btw, 关于VNR从人工字幕学习的翻译器，由于VNR服务器的内存不足以长时间的支持这个翻译器，我暂时在
  服务器端关闭了对这个翻译器的服务。我在以后会购买额外的服务器，再来deploy这个翻译器的。
  当前在VNR的使用偏好中打开这个翻译器or not，对翻译是不会有影响的。如果给你带来误解，很抱歉！

  [Machine Translator]
  * Add online translation support for Babylon, SYSTRAN, and @nifty.
    + Babylon: Multilingual, support all languages in VNR.
      btw, I also tested SDL, which had the same translation as Babylon, and hence not added to VNR.

    + SYSTRAN: Support English-focused translation.
      One critical problem is that the IP might get banned when submitting a couple of translation very quickly.
      I haven't got a solution for this issue yet.

    + @nifty: Support translation between Japanese/Chinese/Korean/English.
      It is using the same translation engine as the famous Fujitsu ATLAS.
      Additionally, @nifty is set to shared the same TAH script and Shared Dictionary rules as ATLAS.

    If you would like to add alternative translation support, feel free to edit the following page:
        http://sakuradite.com/wiki/en/Machine_Translators

    Here are some tests if you are interested:

    - Japanese: まあね♪スカートとはおさらばだし。ハーフパンツなんて久しぶり。

      LEC (original): Oh, I sleep, and half underpants are after a long absence ♪ skirt とはおさらばだし
      LEC (VNR+TAH): Oh♪Skirt とはおさらばだし. Half underpants are after a long absence

      ATLAS (original): Good bye [maane] ♪ skirt is [dashi] . The half pants are after a long time.
      ATLAS (VNR+TAH): Well♪ Good bye the skirt is [dashi]. The half pants are after a long time.

      Infoseek (original): まあね ♪ skirt とはおさらばだし. Half underwear is after a long absence
      Infoseek (VNR+TAH): Oh♪ Skirt とはおさらばだし. Half underwear is after a long absence

      SYSTRAN: Don't you think? well, the ♪ skirt the reed mule it puts out. The half underpants how long separation
      Babylon: Well. My skirt and a farewell. Half-pants long time!
      @nifty: Good bye [maane] ♪ skirt is [dashi] . The half pants are after a long time. // the same as ATLAS

  添加了一些新的翻译器的支持，不过对中文翻译的帮助不大。

4/9/2015 THU
  [Bing](Arabic)
  * For Japanese-Arabic translation, fix the issue that Shared Dictionary rules get messed up by Bing.

4/7/2015 TUE
  [Yomigana](Arabic)
  * Yomigana definitions in the Shared Dictionary will generate name translation for Arabic as well.
    If you find errors in the yomigana, please edit the following page, and I will update VNR to add your patch later.

        http://sakuradite.com/wiki/en/Furigana

    Now, yomigana will generate name translations for all languages in VNR.

  * Arabic alphabet can be selected to display yomigana for Japanese.

  * Baidu translator is no longer blocked in Preferences, even if you have blocked Chinese language in Preferences/i18n.
    Because Baidu can be used to translate non-Chinese languages as well, such as Arabic and Russian.

4/6/2015 MON
  [Machine Translator](Chinese, Korean)
  * Translation using JBeijing and ezTrans are done in parallel to be faster.
    VNR tends to split input text into sentences and translate each sentence independently.
    When that happens, VNR now will translate all sentences in parallel.
    This is not enabled for other translators such as Atlas and LEC, which are tested not thread-safe.

    并行处理JBeijing断句后的翻译来提高翻译速度。
    由于近期大量使用&eos;的词条分割句子，造成JBeijing翻译的时间越来越长。翻译一句有很多逗号的话要几秒钟。
    现在，分割后的从句会并行的送入JBeijing进行翻译，来成倍减少翻译的时间。
    在使用JBeijing时，左下角线绿色spinner会转动并显示线程的个数。

    另外，如果在同时使用比如JBeijing和Baidu，那么两者也会并行的翻译来overlap掉网络延时。
    但是，这样代价是造成JBeijing的翻译有时会出现在Baidu的后边。

  [Ehnd](Korean)
  * Fixed an encoding bug that caused Ehnd scripts not properly applied.

4/5/2015 SUN
  [i18n](Korean, @mireado)
  * Update VNR's UI translation in Korean made by @mireado sensei.

  [Shared Dictionary](Chinese, Korean)
  * JBeijing and ezTrans are aware of the roles of m (name), n (noun), and x (unknown phrases).
    As you might have noticed, for example, after defining a noun syntax:
       n ||| 露西亜 ||| Russia
    VNR will send ZNAZ to the underlying machine translator (JBeijing/ezTrans), which, however,
    does not know that ZNAZ is a noun.

    So, I simply added ZNAZ to the user-defined dictionaries of JBeijing and Ehnd script, after which,
    I expect, the translator should now be able to recognize ZNAZ as a noun, i.e. 露西亜 as a noun.

    Some details about the mapping from the roles to the translator's user dict are as follows:
    - Ehnd, see: Dictionaries/ehnd/UserDict_@jichi_role.txt
      role pattern   noun  properties
      x    ZX[A-N]Z  0
      m    ZM[A-N]Z  1     VHn
      n    ZN[A-N]Z  1     VHn

    - JBeijing, see: Dictionaries/jb/@jichi/JcUserdic
      role pattern   input    => output
      x    ZX[A-G]Z  成語     => 成語
      m    ZM[A-G]Z  人名     => 人名
      n    ZN[A-G]Z  普通名詞 => 普通名詞

    Currently, only m/n/x are recognized.
    Any other roles that are neither m(name) nor n(noun) are categorized as x (unknown phrase).
    If you have suggestions for other role mapping such as adj and verb, you can create a topic on it
    at http://sakuradite.com/topic

    Regarding English translation, I expect similar things could be done by adding definitions to
    ATLAS/LEC's user-defined dictionaries.
    However, VNR currently does not support reading ATLAS/LEC dictionaries.
    I might investigate on ATLAS/LEC support when I have time later.

    JBeijng可以识别共享辞书中的部分role了。
    简单来说，m（名字）会被识别为JBeijing辞书中的【人名】；
    n（名词）会被识别为JBeijing辞书中的【普通名词】；
    而任何其他的role比如x（未知词组）会被识别为JBeijing辞书中的【成语】。

4/4/2015 SAT
  [ezTrans](Korean)
  * Add built-in support for Ehnd plugin, which is enabled by default.
    No settings are needed to be changed, unless you want to manually edit Ehnd scripts.

    - Ehnd scripts are enabled by default.
      But you can disable it in Preferences/Translator below the ezTrans toggle.

      And in the Test Machine Translation window, Ehnd can be toggled by the Translation Script button.

    - However, if you have already manually put Ehnd scripts in the ezTrans directory, VNR will NOT load them.
      To enable manual Ehnd scripts, you must DISABLE the Ehnd option in VNR's Preferences.

      VNR's Ehnd scripts are in the Dictionaries/ehnd folder, version 20150402, which I got from mireado.
      Please DO NOT directly edit those files, which will be reverted back after VNR's update.
      If you want to manually set up Ehnd, please follow the guide below, and then DISABLE VNR's Ehnd option.

        Tutorial: http://blog.naver.com/waltherp38/220286266694
        Binary: http://blog.naver.com/waltherp38/220267098421
        Dictionary: http://sokcuri.neko.kr/220301117949

    I modified the source code of Ehnd to better integrate with VNR, and the source code is as follows:
        https://github.com/jichifly/ehnd-vnr
    For example, it does not require msvc2013 to be installed, hooking to eztrans is changed to be non-intrusive,
    logging is disabled for better performance, and building system changed to CMake (I am a Visual Studio hater).
    It might also allow me to compile Share Dictionary rules to Ehnd dictionary in the future.
    But currently, there is NO difference for how the Ehnd scripts are applied.
    So, it is OK to set up manual Ehnd if you like, which will act the same way as VNR's Ehnd mod.

    Special thanks to @mireado sensei's extensive help on this topic!

4/3/2015 FRI
  [Shared Dictionary](Chinese)
  * Yomigana rules will also be used to generate names for Chinese translation.
    读法词条的匹配的文本会被用于生成日中姓名的翻译。
    比方说，给定：悠真 => ゆうま
    那么VNR会对【悠真】做日中汉字的变换来生成姓名，而【ゆうま】的读音会被忽略掉。

    生成的姓名可以在共享辞书下边的读音中观察到。
    如果日文没有办法全部转化为汉字，会显示【无】，日中翻译时VNR会忽略这个词条。
    如果正体中文和简体中文的汉字变体相同，那么会显示1个中文姓名。
    如果汉字不同，会显示两个姓名。

    如果姓名词条和读法词条同时存在，那么姓名词条会override掉读法词条。
    由于历史原因，共享辞书中有大量的读法词条。这样可以减少辞书中重复定义的姓名。

  [Game Engine]
  * Fix the issue in Malie engine to make sure texts are extracted sentence-by-sentence in 「シルヴァリオ ヴェンデッタ」.
    修正了「シルヴァリオ ヴェンデッタ」提取文本时断句错误的问题。

4/2/2015 THU
  [JBeijing](Chinese, @djz020815)
  * 更新了djz大先生的J北京词库。

  [TAHScript](English, @riz)
  * Update TAH script for ATLAS/LEC.
    The scripts are from @errzotl sensei, and you can say thanks to him/her at TAHscript@outlook.com.

  [UI]
  * Remove the option to change global UI font in Preferences.
    删掉了【使用偏好】中修改界面字体的选项。

3/14/2015 SAT
  [Game Engine]
  * Update Malie engine to correctly capture text annotated with furigana.
    修正了light的游戏可能无法提取到带振仮名的文字的问题。

3/13/2015 FRI
  [Game Engine]
  * Add alternative ShinaRio engine for Guilty games as reported by @jessecf sama.
    修正了部分Guilty游戏无法正常提取文本的问题。
    感谢@jessecf sama的报告！

  [Performance]
  * Reduce memory usage to process subtitles and danmaku.

  * Reduce memory usage by half to show and edit Shared Dictionary entries.
    减少了浏览和编辑共享辞书时的内存。

  [Machine Translator](Chinese)
  * 修正了百度翻译无法正常进行的问题。
    由于金山在线翻译无法正常运作，改为使用百度翻译的API了。

3/12/2015 THU
  [Shared Dictionary]
  * Set of roles can be represented by, for example, [[m,n,v]], which will match any m,n,v roles.
    And when there are multiple sets, the role name can be omitted in the translation.
    For example, all the following rules are equivalent:

      [[m,n]]を[[v]] => [[v]] [[m,n]]
      [[m,n#1]]を[[v#2]] => [[v#2]] [[m,n#1]]
      [[m,n#1]]を[[v#2]] => [[#2]] [[#1]]
      [[m,n#1]]を[[v]] => [[v]] [[#1]]

    And if there is only one role, the role names in the translation can be omit.
    For example, all the following rules are equivalent:

      [[m,n]]の => [[m,n]]'s
      [[m,n#1]]の => [[m,n#1]]'s
      [[m,n#1]]の => [[#1]]'s
      [[m,n#1]]の => [[]]'s
      [[m,n]]の => [[]]'s

  [Game Engine]
  * Update Malie engine so that it won't crash「シルヴァリオ ヴェンデッタ」.
    修正了「シルヴァリオ ヴェンデッタ」提取文本可能会崩溃的问题。

3/11/2015 WED
  [JBeijing](Chinese, @djz020815)
  * 更新了djz大先生的J北京词库。

  [TAHScript](English, @riz)
  * Update TAH script for ATLAS/LEC.
    The scripts are from @errzotl sensei, and you can say thanks to him/her at TAHscript@outlook.com.

  [Machine Translator]
  * (Russian) Fix translation support for translate.ru , which stopped working.

  * (Chinese) Restore translation support for Youdao.com, since the new translation encoding system
    for Shared Dictionary can penetrate Youdao now.
    恢复了对有道在线翻译的支持，由于新的共享辞书的机制可以穿透有道翻译了。
    不过有道翻译的质量和百度、J北京是没有办法比的。

  [Shared Dictionary]
  * Guest users are no longer allowed to create Prefix/Suffix/Macro/Proxy typed translation rules any more.
    I feel these typed rules are either dangerous or kind of complicated to understand by new users that
    most rules in these types submitted by guest are wrong.
    匿名账户不可以直接提交前缀、后缀、宏，以及新加的代理类型的词条了。
    因为这些类型的词条一般比较难理解，而要么非常重要，要么很少会被用到。

  * Macros can be applied to not only the pattern, but also the translation.
    宏类型的词条可以被应用到替换的翻译中。

  * Macros can also be applied to non-regex terms.
    The regex option for for macros is no longer locked. But it has NO effect at the moment.
    If a macro is for representing regex, you can just check that option, to make it more readable.
    宏类型的词条会被应用到所有的词条上，而不再仅限于正则表达的词条。
    宏类型词条本身的正则表达的选项可以调整了，但是那个选项当前是没有作用的。
    不过，如果宏类型词条本身是表达正则表达的，那么做好把那个正则的选项打开，这样可以更readable些。

  * I made some fundamental changes for how to apply Name/Prefix/Suffix/Yomigana/Translation rules.
    If you are actively using Shared Dictionary, I think it might be helpful to check the following topic:

       http://sakuradite.com/topic/724

    In short, I changed to apply Shared Dictionary in a new grammar similar to VTrans for Chinese.
    The grammar is basically the same as SynCFG for SMT, except there is no statistical probability and word segmentation.
    Here are some major advantages:
    - The new grammar is implemented 10x faster to apply, and use half memory.
    - It can be used to describe interaction of translation rules.
    - There is no more issue of garbage digits.
    - Name translation etc. can be applied in non-intrusive manner with the help of the new mechanism of "translation delegation".
    - The name translation is now very cheap to implement.
      Assume there are N names, S suffices, and P prefices, and the time/space complexity to process Name is reduced
      from O(N*(S+P)) => O(N+S+P).
      I would suggest to remove series-specific flags for all names that do not have ambiguity.

    我修改了共享辞书翻译词条的机制。
    新的机制采用了和VTrans SMT相同的语法（除了没有概率统计和分词的支持）。
    如果你经常使用共享辞书，那么非常建议你查看下下边的topic。

       http://sakuradite.com/topic/724

    另外，新的机制下，姓名词条的处理几近完美了，不论是速度、内存、还是翻译质量。
    如果一个姓名的翻译绝大部分情况下没有歧义，那么我建议就不需要打开【系列专用】的选项了。

3/4/2015 WED
  [Performance]
  * Reduce memory usage when writing large xml/yaml data (games/subtitles/dictionary) to disk.

3/1/2015 SUN
  [Proxy]
  * Update proxy to ErogameScape and Google, which stopped functioning.
    更新了对批评空间和Google的代理，因为以前的代理可能不能用了。

  [Machine Translation](Korean)
  * Add translation support for TransCAT JKKJ suggested by @mireado sama.
    I cannot tell if it is better or worse comparing to EzTrans, but I feel you could give it a try.

    Here are some notes and minor issues about it:
    - TransCAT's developer ClickQ has disappeared, and I cannot find any place to purchase this soft.
      If you would like to try it, you might have to ask your friends or @mireado sama where to get it.

    - TransCAT project was dropped in 2002, which was newer than ezTrans XP (2001) though.

    - TransCAT's path must not have non-ASCII characters.

    - VNR must have write permission to TransCAT's directory.
      For example, on Windows 7, if you have installed TransCAT to $PROGRAMFILES as Administrator.
      Then, VNR by default might not be able load TransCAT. And it will keep popping up warning messages
      like "Cannot write to the location".

      There are at least three ways to fix such issue:
      + Solution 1 (recommended): Move TransCAT out of $PROGRAMFILES to a location where non-administrator has write permission.
      + Solution 2 (not recommended): Always launch VNR as administrator.
      + Solution 3: Use cacls to grant write access to the TransCAT folder in $PROGRAMFILES.

    - TransCAT might conflict with JBeijing (a Japanese-Chinese translator).
      When TransCAT starts after JBeijing, it might crash VNR.
      In order to make both work, TransCAT must be loaded BEFORE JBeijing is loaded.
      VNR internally will try to initialize TransCAT always before JBeijing if possible, but there are
      loop-holes when the user is toggling Preferences.
      Anyway, if you have both JBeijing and TransCAT installed, and if you toggled both JBeijing and TransCAT
      in Preferences, you might have to restart VNR to make both work.

      If you don't use JBeijing for Japanese-Chinese translation, you can forget the above text.

    Here are some comparisons regarding the translation quality with ezTrans and Naver.
    Japanese texts are from 「大正×対称アリス」.

      Japanese: あなた「ここはどこなの……？歩いても歩いても、出口が見つからない」
      TransCAT: 당신「여기는 어디다……? 걸어도 걸어도, 출구가 발견되지 않는다」
      EzTrans: 당신「여기는 어디야……? 걸어도 걸어도, 출구가 발견되지 않는다」
      Naver: 당신「여기는 어딘데……?걸어도 걸어도, 출구가 없다」

      Japanese: あなた「私……どうしてこんな所にいるの？ 私は……誰なの？」
      TransCAT: 당신「나……어째서 이런 곳에 있는 것이다? 나는……누구다?」
      EzTrans: 당신「사……어째서 이런 곳에 있는 거야? 나는……누구야?」
      Naver: 당신「나……왜 이런 곳에 있니?나는……누구니?」

      Japanese: 自者名前
      TransCAT: 自 자이름
      EzTrans: 차자 이름
      Naver: 차자 이름

      I feel the overall EzTrans translation is similar to either EzTrans or Naver.

      However, when there are unrecognized phrases, TransCAT will leave it in the translation,
      while Naver tends to convert untranslated Kanji to Hangul of the corresponding Hanja in Korean,
      and EzTrans tends to delete the unrecognized sounds or acts like Naver to convert Kanji to Hanja's Hangul readings.
      As a result, it will be easier to use Output rules in Shared Dictionary to fix TransCAT's translation.

2/28/2015 SAT
  [JBeijing](Chinese, @djz020815)
  * 更新了djz大先生的J北京词库。

  [TAHScript](English, @riz)
  * Update TAH script for ATLAS/LEC.
    The scripts are from @errzotl sensei, and you can say thanks to him/her at TAHscript@outlook.com.

  [Game Engine]
  * Update Pensil engine to support 大正×対称アリス with Primula's 2XT engine.
    修正了「大正×対称アリス」无法提取到文本的问题。

2/18/2015 WED
  [Script]
  * Add a ld2db script in the Scripts folder that can be used to convert Lingoes
    dictionary file to SQLite database.
    For example:
        ld2db "Vicon Japanese-English Dictionary.ld2" utf16 utf8
    will output a SQLite3 db file for Vicon dictionary where Japanese is encoded
    in UTF-16 and English is encoded in UTF-8.

  [Machine Translation]
  * I made a statistical machine translator from user-contributed subtitles for VNR.
    It currently only supports Japanese => Chinese translation, which can be enabled in Preferences.

    I named it as VTrans, standing for VNR's translator, or WeTrans (our translator), since it is
    really based on and counted on our subtitles and translation rules for VNs.

    Its current average translation quality is usually worse comparing to other online translators
    such as Baidu, though.
    But I think this might open a new area for VNR in the near future to have our own fully-customized
    machine translator to improve the translation in whatever ways we like.

    Here are some advantages that it has and I can am expecting:

    - Translation quality will be gradually improved from user-submitted subtitles.
      The current translation is trained from 220k sentences.
      96k are user-shared subtitles, and other 120k are sample sentences from JC dictionaries in VNR.

      Currently, if a user's total subtitle count is > X, all of his/her subtitles will then be used to
      train the machine translator.
      X is a large integer. I would like to keep this number X secret to prevent people from adding a
      large number of garbage texts in order to be included to the machine translation.

      Basically, if you see a translation is wrong in VTrans, just submit a better subtitle for it, and
      then VTrans will be better soon later when I update it's translation rules from user subtitles.

    - Open and easy to customized
      The translator is implemented in Python and Java. And I have the access to all the source code
      of the libraries and dictionaries being used.
      This will allow us to modify the translation in whatever degree we like.
      For example, I am now able to apply a suffix rule [[N]]さん to all names recognized by the translator.
      I can know how the input sentence is segmented, and which word is untranslated.
      And I can directly modify the grammar of the machine translation in a non-intrusive way.

      I will add interfaces to expose all internal settings of the translator in the future.

    - Domain-specific to VN
      It is from users' subtitles, the vocabulary will be more close to 二次元 and oral Japanese.
      And there is no censorship of certain hentai words.

    - Possibility for training true-bilingual translation
      Currently, say, Japanese => Russian is done by Japanese => English => Russian, which might downgrade
      overall translation quality.
      If you are speaking an European language, I can instead train the translation directly between Japanese
      and your language.
      However, the translation quality might be affected by how many user-shared subtitles are in your language.

    - Feasibility for offline translation
      Currently, the trained grammar data is about 400MB.
      I can add an offline translator with these data in VNR, which will require users to install Java, though.

    However, I think there will be a few critical disadvantages about this approach:

    - Smaller vocabulary
      Though being close to VNs, the amount of data used to train the translator is far less than the others.
      If you use VTrans to translate, say, Wikipedia articles, the quality will be too bad to understand.
      I plan to instead rely on users to submit instant rules to fix the mal-translated sentences.

    - Slow access speed
      VTrans is currently set up on the same server that holds VNR's service.
      I would expect it to stop functioning when lots of users are using VNR ....

    - Less machine resources to tune the translation quality
      The statistical machine translation quality is highly affected by tuning.
      Currently, I don't have powerful machines or cloud clusters to tune all the user-shared subtitles.
      For the current 220k sentences, I only tuned 500 sentences for the best BLEU score, which took
      about 2 hours to accomplish on my macbook air.
      I might not have machine time to tune large data, which will surely downgrade translation quality.

    Note: Currently, please do not add translator-specific rules for VTrans to the Shared Dictionary.
    I will change how to integrate Shared Dictionary rules with VTrans in the near future.

    Regarding how subtitles are trained, there are certain requirements for the subtitles to meet, or the
    subtitle might confuse VTrans and even downgrade translation quality.
    I will talk about that after I have finalized Japanese-Chinese support and added Japanese-English support.

    Anyway, I am going to explore the approaches to integrate user-specified domain knowledge to improve
    translation quality. If you have suggestions, feel free to let me know!

    添加了一个基于统计的在线机器翻译的功能。
    翻译的内容主要是有大家提交的日中翻译的字幕来训练的。
    不过，当前翻译的质量和Baidu等比起来，还有很大的差距的。还是JBeijing+Baidu才是最佳组合。
    另外，当VNR的服务器很忙时，翻译也可能会变得很慢的。

    关于共享辞书，大家先不要添加针对这个翻译器的词条。
    因为我有翻译器的全部代码，可以在很底层的位置来应用翻译规则。我在以后会针对这个翻译器来改变应用词条
    的方法和机制。在此之前，先不要为这个翻译器添加词条。

    关于机器翻译训练，当用户总共的字幕数量大于一个阈值时，那么VNR就会使用他或她的字幕来训练机器翻译了。
    Guest账户的字幕不会被用于训练。这样做的目的是为了减少不良字幕的数目从而降低翻译质量。
    由于使用大家的字幕训练，造成翻译上可能会更加贴近口语。
    而且基本上，如果你发现翻译出的质量不佳，在提交新的翻译后，翻译以后就会慢慢变好了。
    但是有时候不同的游戏之间会串词。
    比如：因为有同学在A游戏把「スプリング」翻译成了（弹簧）床，结果B游戏里 「スプリング」就被翻成床了。。。
    另外由于翻译样本不足而且局限在这个领域，翻译器对长句字以及非二次元的生词的翻译还很差。
    翻译口语还好。当前翻译比如wiki之类的文章很多都没法看了。

    另外，在提交人工翻译时没什么要求，除了：
    1. 希望大家在日文原句里没有主语时，不要添加游戏人名为翻译的主语。（否则可能会像上边那样“串词”）
    2. 另外就是如果可能的话，翻译最好能够和原句的标点对齐。

    比如，如果日文原句是：「A，B。C？」
    那么人工翻译最好也是：「x，y。z！」
    标点可以不相同，但是断句最好一致。否则VNR的服务器可能会无法判断如何对齐分句。

    具体来说，VNR在断句时分为三个层次：
    - 段落(paragraph)： 用【】「」等分割
    - 句子(sentence)： 用。？！等分割
    - 分句(clause)： 用、『』等分割。
    如果1或2没有对齐，那么VNR就会忽略而不训练这个字幕。
    如果3没有对齐，那么VNR仍然会去训练句子。比如：

        だから、ごめんなさいっ。 => 所以对不起。

    因为翻译中缺少逗号而无法对齐从句。然而，VNR仍然会用「だから、ごめんなさいっ。」去训练「所以对不起。」。
    特别的，如果翻译中有逗号，比如： 所以，对不起。
    那么，VNR会自动训练下边所有的翻译：

        だから、ごめんなさいっ。 => 所以，对不起。
        だから、 => 所以，
        だから => 所以
        ごめんなさいっ。 => 对不起。
        ごめんなさいっ => 对不起

    总之，如果翻译的标点可以和原文对齐，那么VNR的在线翻译可以学到更多的关系的。
    但是，如果分句句子次序大幅改变，比如：

        だから、ごめんなさいっ。 => 对不起，所以。

    那么，这样可能会让VNR的翻译变差，因为这会造成：

        だから、ごめんなさいっ。 => 对不起，所以。
        だから、 =>  对不起，
        だから =>  对不起
        ごめんなさいっ。 => 所以。
        ごめんなさいっ => 所以

    这样的话，取决于这种对应关系出现的概率，如果其他游戏都没有出现过「だから」，那么「だから」就看能会被
    错误的判定为「对不起」了。

2/17/2015 TUE
  [Internet]
  * Certain Internet requests, such as query game database when adding new games,
    query online machine translation, etc, will timeout after 7 seconds so that
    VNR will not hang waiting for the request to finish.
    想查询数据库和在线翻译等操作，会在7秒钟之后自行终止。
    来防止因为网络问题而让VNR卡在比如添加游戏等操作中。

  [UI]
  * Add an option in Preferences/UI to change VNR's default font.
    在【使用偏好/界面】中，可以修改VNR默认的字体。

2/14/2015 SAT
  [Game Engine]
  * Modify ApRicoT engine so that the scenario thread won't split and variate on each launch.
    Be careful that there are usually two threads for ApRicoT, and only one of them is correct.
    The other one sometimes is right, but sometimes has repetition.
    Thanks for @Reality sama 's report!

  [Shared Dictionary]
  * You can use HTML escaped entities in the pattern and translation.
    For example, VNR by default will trim spaces for the pattern and translation.
    You can use &nbsp; to force prepending/appending space.

    You can also use it to express unprintable characters without enabling regex.
    For example, ASCII 13 (Carriage Return, or CR) can be expressed as "&#13;".

    可以用HTML的转义语法来插入空格(&nbsp;)什么的。
    另外，也可以使用&#d的语法来插入如法输入的字符，而不必再使用打开正则表达的\u语法，
    比如：ASCII 13 (Carriage Return, or CR) 可以使用"&#13;"来表示。

  * Add a "&eos;" (end-of-sentence) special symbol, which can be used to force VNR to break input text
    into sentences and translate them independently.
    For example, given:

        みおちゃん、スラマッパギ！

    If define the following rule:

        Type: input
        Pattern: 、
        Translation: 、&eos;

    Then VNR will translate "みおちゃん、" and "スラマッパギ！"  independently.

    Note: Under the water, VNR will replace "&eos;" by "…eos…", so that {{bos}}/{{eos}}/{{boc}}/{{eoc}}
    macros won't be broken (because :bos:/:eos: also contains "…").

    可以用&eos;的符号来强制VNR断句，分别翻译分断后的句子。
    比方说，给定：

        みおちゃん、スラマッパギ！

    如果给定如下词条：

        类型: 输入
        匹配: 、
        翻译: 、&eos;

    那么VNR将会分开翻译「みおちゃん、」和「スラマッパギ！」。

  Note: Using escaped symbols such as &nbsp; or &eos; will break translation for all old versions of VNR.
  Let's wait for one or two days until people update VNR before adding rules containing these special symbols.

  注：使用这些符号将会破坏使用老版本VNR同学的翻译。
  让我们等待一两天，大家都更新过VNR了，再来使用这些符号吧。

2/13/2015 FRI
  [Shared Dictionary]
  * Add a Phrase Boundary option to the translation rule.
    When enabled, VNR will try to only apply the translation when it is at the boundary of a phrase.
    For example, given a yomigana definition:

        愛 => あい

    Then, it will be applied to 愛ちゃん, but won't be applied to 恋愛、愛情, etc.
    i.e. 愛 will only be applied if the left of 愛 and right of 愛 are at the word boundary (like \b).

    My plan is to utilize MeCab to find word boundaries in the future.
    However, this is not what is happening at the current version.
    The detailed logic about how pattern is affected is as follows:

    - If @sourceLanguage is NOT Japanese # i.e. for non-Japanese games
      - If @type is macro
        Phrase boundary option is not allowed.
      - Else if @type is suffix
        @pattern = @pattern + "\b"
      - Else if @type is name or yomigana
        @pattern = "\b" + @pattern
      - Else # For all other types including translation, pattern will be wrapped with \b
        @pattern = "\b" + @pattern + "\b"

    - Else if @sourceLanguage is Japanese # i.e. for Japanese games
      - If @type is macro
        Phrase boundary option is not allowed.
      - Else if @type is suffix
        @pattern = @pattern + eow(@pattern)
      - Else if @type is name or yomigana
        @pattern = bow(@pattern) + @pattern
      - Else
        @pattern = bow(@pattern) + @pattern + eow(@pattern)

    Here, bow (beginning of word) will return the negative category of the first character of @pattern.
    And eow (end of word) will return the negative category of last character of @pattern.

    For Japanese games, for example, when the phrase boundary is enabled,

        愛 => あい

    is almost equivalent to:

        {{?<!kanji}}愛{{?!kanji}} => あい

    Except that the new approach will also be applied to, say, 愛様, but old {{?<!kanji}}愛{{?!kanji}}
    won't be applied to 愛様.

    Similarly, コロエ will be almost equivalent to {{?<!kata}}コロエ{{?!kata}}.
    And ハル子 will be almost equivalent to {{?<!kata}}ハル子{{?!kanji}}.

    For English games, for example, when the phrase boundary is enabled, "tight" is equivalent to "\btight\b"
    for translation type.

    Currently, since MeCab is not used, the word boundary is not accurate.
    For example, given 愛 => あい, when phrase boundary is enabled, it won't mess up 愛情、恋愛.
    But it will still mess up 愛しさ.

    Additionally, checking phrase boundary is as expensive as enabling regex.
    Unless really needed, please don't extensively turn this option on.

    For example, given a yomigana definition: 雫 => しずく
    Since 雫 is seldom used in a kanji phrase, there is no need to turn on the phrase boundary option for it.

    为词条添加了【短语边界】的选项。
    如果要翻译的名字很短可能有歧义，那么可以打开这选项。

    对于非日文游戏（比如英文），那么，比方说： "tight"将会等价于"\btight\b"。
    也就是说，在tight的前后都是【单词边界】时才会被翻译。
    这样的话，tight会被翻译，而tightly就不会被翻译了。

    对于日文游戏，那么，比方说：
    - "愛"将会等价于"{{?<!kanji}}愛{{?!kanji}}"。
      这样，彼方说："愛ちゃん"会被替换，而"愛情"、"恋愛"等就不会被替换了。
    - "コロエ"将会等价于"{{?<!kata}}コロエ{{?!kata}}"。
    - "ハル子"将会等价于"{{?<!kata}}ハル子{{?!kanji}}"。

    开启短语边界相当于打开了正则表达式，相对来说比较expensive。
    除非有必要（比如原单词有歧义），否则不要大规模的开启才好，否则应用词条的速度可能会变慢。

  * The name suffix now support changing the translation order.
    For example, given the following definitions:

        Type: Name
        Pattern: クロエ
        Translation: Chloe

        Type: Suffix
        Pattern: 姫
        Translation: Princess [[N]]

        Type: Suffix
        Pattern: 将軍
        Translation: General [[N]]

    Then, "クロエ姫" will be translated to "Princess Chloe".
    And, "クロエ将軍" will be translated to "General Chloe".
    The idea is motivated by Ehnd scripts for EzTrans, which VNR currently does not support, though.
    Here, "[[N]]" is used as a placeholder for the name/yomigana translation.

    btw, the "[]" symbol is selected, as in the future, I might add other variables such as [[n]] to represent
    a noun, and [[Nnv]] to represent a set of any Name/noun/verb where the grammar is similar to regex [] class.

    Such approach currently has some limitations.
    For example, you can define the following suffix:

        Type: Suffix
        Pattern: を殺す
        Translation: kill [[N]]

    Then, "クロエを殺す" will be translated to "kill Chloe".
    However, "クロエちゃんを殺す" will NOT be translated to "kill Chloe-chan".
    Because [[N]] only contains bared name (クロエ), without other suffices (-ちゃん).

    In the future, I am plan to allow adding more generic rule such as "[[n]]を殺す", where [[n]] represents any noun
    with the help of MeCab.
    But currently, my suggestion is that let's not add rules like を殺す as suffix at the moment, and use suffix as
    just name suffix such as ちゃん、さま, rather than complicated phrases such as を殺す.

    添加了后缀的语法来支持改变翻译至于姓名的位置。 比方说，给定：

        类型: 后缀
        匹配的文本: 姫
        替换的文本: Princess [[N]]

    那么，"クロエ姫"就会被翻译为"Princess Chloe"。

    不过，当前的approach还有很多局限性。比方说，给定如下定义：

        类型: 后缀
        匹配: 殺す
        翻译: 杀死[[N]]

    那么，"クロエを殺す"会被翻译为"杀死Chloe"。
    然而，"クロエちゃんを殺す"暂时却无法被翻译为"杀死Chloe酱"。
    由于[[N]]]仅仅可以匹配原声的姓名（クロエ），而并不包含其他的后缀（ちゃん）。
    我的建议是，在我解决这个问题前，先不要添加好像「を殺す」这样的短语词条作为后缀才好。

  * Add prefix type, which is similar to suffix. Here's an example:

        Type: Prefix
        Pattern: ミスター
        Translation: Mr.

    添加了前缀的类型。下边是一个英中前缀词条例子：

        类型: 前缀
        匹配: Mr.
        翻译: [[N]]先生

  * Translation rules specific for JBeijing is now shared with Excite.
    Because Excite has the same engine as JBeijing, whose translation are 99% the same,
    this might help reuse large numbers of JBeijing rules to enhance Chinese translation on Excite.

    JBejing和Excite会共享词条。

  [Proxy]
  * Update proxy to ErogameScape.
    更新了对批评空间和Google的代理。

2/12/2015 THU
  [Game Engine]
  * Add SystemAoi5 text engine for 「悪魔娘の看板料理」.
    为「悪魔娘の看板料理」添加了提取文本的支持。

  [Danmaku]
  * You can vote plus/minus a danmaku/comment if you agree/disagree for non-guest account.
    在弹幕、评论的旁边，可以点击+/-来赞成/反对它的内容。这个仅对非guest的账户有效。

2/11/2015 WED
  [Game Engine]
  * Update old WillPlus engine which might crash 「Re:BIRTHDAY SONG」 on Windows XP.
    修正了「Re:BIRTHDAY SONG」 在Windows XP上读档是可能会崩溃的问题。
    感谢@柒号线 sama的报告！

  [Machine Translation]
  * The Ellipse character (…) will be used to split clauses to force preserving the order of the clauses.

  * VNR will also capitalize non-English characters (Vietnamese, Russian, etc.) in the beginning of a sentence
    if the language's character set does have capital letters.

  [Shared Dictionary]
  * When VNR is processing the Shared Dictionary after the game is changed, VNR will ignore the game text.
    This will help stop displaying garbage game texts on the startup.
    在游戏刚刚启动后，在VNR完成处理共享辞书之前，前一两句游戏对话会被VNR忽略掉。
    这样可以避免在游戏刚开始时，显示各种垃圾文本。

2/10/2015 TUE
  [Machine Translation]
  * Add options in Preferences/Translation for concatenate different translations

    For example: If I select Bing as secondary translator of Baidu, and select Chinese as
    the intermediate language.
    Then, when translate Japanese => English, VNR will first translate Japanese => Chinese
    using Baidu, an then Chinese => English using Bing, like this:

                  (first mt)              (second mt)
       Japanese => Baidu.com => Chinese => Bing.com => English
                            (intermediate lang)

    Here are some special scenario that might be benefit or affected from this feature.

    - Extend LEC output languages.
      LEC is by far the best Japanese-English translator, and @riz sensei is actively maintaining
      translation scripts for LEC to further elevate its translation quality.
      But VNR currently only supports English/Russian as output language.

      If you want to translate Japanese to, for example, Spanish, using LEC, then you can now
      select Bing as the secondary translator of LEC, and select English as Intermediate language.

      Note: LEC won't show up if you have blocked English in Preferences/i18n.

    - Translation alignment
      Translation alignment can only be enabled for the second translator.
      If enabled, the intermediate translation can be observed from the ruby.
      Here's an screenshot of the translation through:

         Japanese => (LEC) => English => (Google.com) => Spanish

         http://i.imgur.com/4kLn0lv.png

    - Shared Dictionary
      Shared Dictionary will be applied to the first and second translators independently.
      For example, given:

         Japanese => (LEC) => English => (Google.com) => Spanish

      VNR will first apply Japanese => English rules to LEC, and then English => Spanish
      rules to Google.

      An exception is Chinese. When the intermediate language is Chinese and the source language
      is Japanese, then VNR will also apply name/yomigana rules in Japanese to Chinese translation
      to the second translator.
      This will turn the translation of these names to Romaji instead of Pinyin.

    - Debugging machine translation
      There is current lack of support to debug the entire cascaded translation process.
      The underline mark will always be disabled for the first translator.
      And in the Test Machine Translation window, only the second translator can be debugged.

    - Offline Japanese => Vietnamese translation.
      You can combine a Chinese offline translator with HanViet in VNR to produce offline
      Vietnamese => Japanese translation.
      Here are some screenshots for JBeijing, Fastait, and Baidu plus HanViet.

          http://i.imgur.com/KJibAwM.png

      Lots of text are underlined, which means the translation from Chinese => Vietnamese
      is ambiguous according to VietPhrase.
      The underline option can be disabled in Preferences/Shared Dictionary.

      Additionally, VNR also supports offline English-Chinese translation through Dr.eye.
      Combining Dr.eye with HanViet might produce offline English-Vietnamese translation.

      Note: If you have blocked Chinese in Preferences/i18n, no Chinese translators would show up.

      + State-of-art of Chinese translators
      If you would like to try using Chinese as the intermediate language, here are a summary
      of Chinese translators supported by VNR:
      1. Baidu.com: The best online Japanese-Chinese translator.
      2. JBeijing: The best offline Japanese-Chinese translator, but it is not free.
      3. FastAIT: The best free offline Japanese-Chinese translator, but it is slow.
      4. Dr.eye: The Japanese-Chinese translation quality is not good.
         But it supports offline English-Chinese translation.

      + About Chinese variants
        In VNR, zh means Chinese (because 中's reading is Zhong).
        zh+t means Chinese Traditional or Chinese Taiwan, and zh+s means Chinese Simplified.
        Basically, zhs is mostly used by Mainland China, while zht in Taiwan, Hong Kong, and all over the world.

        VNR will automatically convert different Chinese variants (traditional, simplified, Japanese kanji) internal.
        So, when select Chinese as the intermediate language, it does not matter a lot whether to use Traditional
        Chinese or Simplified Chinese.

      Comparison of some sample translations:

      Japanese:      【爽】「悠真くんを攻略すれば２１０円か。なるほどなぁ…」

      Google(vi):    【Shuang】「¥ 210 hoặc nếu chụp các Yuuma-kun. Naa tôi thấy...」
      Infoseek(vi):  【Shuang】「Tôi chụp 210 Yuuma-kun có sẵn. Tôi hiểu?…」
      Bing(vi):      【Shuang】「Tôi chụp 210 Yuuma-kun có sẵn. Tôi thấy bây giờ...」

      LEC(en):       【It's refreshing】「If it captures Yuuma-kun, is it 210 yen? I see.」
      + Bing(vi):    【Nó được làm mới】「Nếu nó bắt Yuuma-kun, là nó 210 yên? Tôi hiểu.」
      + Google(vi):  【Đó là làm mới】「Nếu nó bắt yuuma-kun, nó là ¥ 210? Tôi hiểu rồi.」

      Baidu(zh):     【爽】「悠真君攻略的话，210日元吗？原来如此啊……」
      + HanViet(vi): 【Sảng】「Yuuma-kun tiến công chiếm đóng nói, 210nhật nguyên mạ? thì ra là thế a……」
      + Google(vi):  【Sáng】「Yuuma-kun Raiders sau đó 210 ¥ nó? Vì vậy, đó ah......」
      + Bing(vi):    【Mát mẻ】「Yuuma-kun Raiders, 210 yên? Oh, Ah......」

      JBeijing(zh):  【爽】「如果攻略悠真君210日元？原来如此啊……」
      + HanViet(vi): 【Sảng】「Nếu như tiến công chiếm đóng Yuuma-kun 210nhật nguyên? Thì ra là thế a……」
      + Google(vi):  【Sáng】 「Nếu Raiders Yuuma-kun 210 trong yên? Vì vậy, đó ah......」
      + Bing(vi):    【Mát mẻ】「Nếu các cướp Yuuma-kun 210 yên? Oh, Ah......」

      FastAIT(zh):   【爽】「攻下悠真君的话，210 元吗。原来如此啊。…。」
      + HanViet(vi): 【Sảng】「đánh hạ Yuuma-kun nói, 210 nguyên mạ. thì ra là thế a.….」
      + Google(vi):  【Sáng】「Yuuma-kun nắm bắt nó, 210 nhân dân tệ bạn. Vì vậy, đó ah. ....」
      + Bing(vi):    【Mát mẻ】「Yuuma-kun bị tấn công, tại 210 Yuan. Oh, Ah.…。」

      btw, JBeijng is not free.
      But you might be able to get some help here:

          http://tieba.baidu.com/f?ie=utf-8&kw=%E5%96%B5%E7%BF%BB

    添加了级联不同翻译器来扩展翻译语言的选项。这个和中文没什么关系，大家无视好了。

2/9/2015 MON
  [Translation Scripts]
  * VNR will enable TAH script made by @riz sensei by default to all Japanese => non-CJK-language translation.
    This behavior can be disabled in Preferences/Translation.

    If you are playing non-Japanese game, or if your language is Chinese/Korean, then you can ignore that option.
    VNR will NEVER apply TAH script if the source language is not Japanese, or if the target language is Chinese
    or Korean, even if the translation script option is enabled.

    The translation script tends to normalize Japanese by removing emotional sounds which usually cannot be
    recognized by English translators anyway.
    For example, it will turn:
        なるほどなぁ…
    To:
       なるほど。
    Where the trailing なぁ… is deleted.

    This is never enabled for Chinese/Korean, because なぁ… can affect the emotion of the C/K translation and
    usually downgrades translation quality if deleted.

    在【使用偏好/翻译器】的下边添加了使用日英翻译脚本的选项。大家无视那个选项就好了。
    不论那个选项开启还是没有，都不会对中文翻译产生任何影响。

2/8/2015 SUN
  [i18n]
  * VNR UI's language can be different from user language, which can be adjusted in Preferences.
    在【使用偏好】中可以选择界面语言与翻译语言不同。

  [Translation Scripts](@errzotl)
  * Update TAH script for LEC from @errzotl sensei.

  [Shared Dictionary]
  * The priority of rules is slightly changed that when the pattern have the same length,
    the language that is more special will be applied first.
    For example, given:

      1. Yomi (ja=>*):  クロエ => クロエ
      2. Name (ja=>en): クロエ => Chloe
      3. Name (ja=>ru): クロエ => Хлоя

    Then 3 will be applied before 2, and 2 will be applied before 1.
    If the user want to translate Japanese to Russian, then rule#3 will be used,
    because 'ru' is more "special" than 'en' and '*'.

    当两个词条的匹配文本一样长时，那么语言更加特殊的词条会被优先使用。
    比如，如果A词条的语言是【全部】，B是【中文】，那么B词条会被优先使用。

  * For name/yomigana rules, VNR will deal with 's (en), の (ja), 的 (zh), 의 (ko) suffices
    for CJK and English translations.

    For example, given a name definition: Chloe (en) => 克洛伊 (zh)
    VNR will also translate: Chloe-chan's => 克洛伊酱的 for English-Chinese translation.

    And given a name definition: 克洛伊 (zh) => Chloe (en)
    VNR will also translate: 克洛伊酱的 => Chloe-chan's for Chinese-English translation.

    And given a name definition: 克洛伊 (zh) => 클로이 (ko)
    VNR will also translate: 克洛伊酱的 => 클로이짱의 for Chinese-Korean translation.

    etc.

    英中翻译时，VNR会在把姓名词条后边的「‘s」翻译为「的」。

2/7/2015 SAT
  [Text Settings]
  * Add more text encodings for games.
    The underlying encoders being used for different languages are as follows.
    - Japanese (Shift-JIS): CP932
    - Traditional Chinese: BIG5
    - Simplified Chinese: GBK
    - Korean: CP949

    - Thai: TIS-620
    - Vietnamese: Windows-1258
    - Arabic: Windows-1256

    - Latin (All Western European languages): Windows-1252
    - Central and Eastern Europe (Polish, etc.): Windows-1250
    - Cyrillic (Russian, etc.): Windows-1251

    I don't have games to test these encodings.
    If the texts are not displayed properly in the encoding, just let me know!

  [Shared Dictionary]
  * Translation rules can be specific to more than one translators.
    词条可以选择仅限多个翻译器。

2/6/2015 FRI
  [Game Engine]
  * Add FocasLens engine to get text in 「幻想人形演舞」.
    为「幻想人形演舞」添加了提取文本的支持。

  * Add Syuntada engine for games made by 平安亭.
    Note: You might need Ntleas to run the game on Windows 7, including Japanese Windows.
    LocaleEmulator might not work.

    为平安亭制作的游戏添加了提取文本的支持。.
    注：即使在日文编码的Windows 7上，仍然会需要Ntleas来启动游戏，不然会有乱码的。

  * Text Settings will warn if the scenario thread in the VNR's online database is unknown
    to the current VNR. When it happens, an update of VNR might be needed to support the game.
    当在线数据中的对话文本VNR不知道如何提取时，文本设定中会显示红色的警告。
    这时，也许需要更新VNR才可以正常的提取文本。

  [Game Information]
  * Allow to associate the game with the app on Steam.

  [i18n](Korean, @mireado)
  * Update VNR's UI translation in Korean made by @mireado sama.

2/5/2015 THU
  [Machine Translation](Vietnamese)
  * Add an option to display Phiên âm above Japanese kanji in Preferences/Translation.

  * When there multiple definitions for a Chinese phrase in VietPhrase.txt, VNR will
    underline the translated text. Clicking the translation, and VNR will popup the
    alternative Vietnamese translation.

    The underline behavior can be disabled in Preferences/Shared Dictionary.

  * Add option to display translation alignment between Chinese and Vietnamese
    for HanViet translation in Preferences.

2/4/2015 WED
  [JBeijing](Chinese, @djz020815)
  * 更新了djz大先生的J北京词库。

  [Game Settings]
  * Game text language can be adjusted by clicking Edit on the SpringBoard.
    It should be Japanese for a Japanese game, English for an English game, etc.
    在SpringBoard上点击【编辑】，可以变更游戏文本的语言。
    如果是日文的游戏，那里应该选择日文。如果是英文游戏，那里应该选择英文，etc.

  [Machine Translation](Vietnamese)
  * VNR's HanViet translator will use VietPhrase.txt from QuickTranslatorTAO
    to translate Chinese to Vietnamese.

    A screenshot is as follows:

        http://i.imgur.com/kL6cxUv.png

    Note: If you are playing a traditional Chinese game such as NEKOPARA, the language
    in Text Settings must be set to Chinese instead of Simplified Chinese so that
    VNR will convert Traditional Chinese characters to Simplified Chinese.
    Otherwise, Traditional Chinese characters might not be recognized by HanViet.

  * HanViet translator will also apply translation rules in the Shared Dictionary.
    As a result, a Japanese name in the Chinese translation will be translated to Romaji
    instead of Phiên âm if there are name/yomi rules defined in the Shared Dictionary.

  * Add an option to display Phiên âm above Chinese texts in Preferences/Translation.

2/3/2015 TUE
  [Windows 10]
  * Fix the issue that VNR would crash on Windows 10 build 9926.
    修正了VNR在win10上可能会崩溃的问题。

2/2/2014 MON
  [Game Engine]
  * Add new 5pb text engine for 「超次次元ゲイム ネプテューヌ Re;Birth1」.
    Note: If you are playing an English version, don't forget to change the
    language in Text Settings to English.

    为「超次次元ゲイム ネプテューヌ Re;Birth1」添加了提取文本的引擎。
    注：如果你在玩英文的版本，要在【文本设定】中修改语言为【英文】才好。

  [Machine Translator](Korean)
  * Support English-Korean translation alignment for Naver.com.

2/1/2015 SUN
  [Shared Dictionary]
  * Add a case-insensitive option to the translation rules.
    词条添加了【不区分大小写】的选项。

  [Game Launch]
  * Fix an issue that VNR sometimes is not able to recognize the game when launched
    with Locale Emulator, or in a symbolic link directory, or from a network location.
    修正了启动游戏后，VNR有时无法立刻识别游戏的问题。

  * Game can be launched in non-Japanese locale.
    This might be helpful if you want to play a non-Japanese game.

    For half-translated games with hybrid languages, I am not sure which locale to use.
    According to my experience:
    - If it is a Japanese game half-translated to English, Japanese locale might be used.
    - If it is a Japanese game half-translated to Chinese, Chinese locale might be used.
    For other language pairs, I am not sure.

    For Chinese games, be careful if it is in Traditional Chinese or Simplified Chinese.
    Usually, fan-patched games are in Simplified Chinese;
    while officially translated games are in Traditional Chinese.

    可以选择指定非日文的语言区域来启动游戏。

    特别的，对于翻译了一半的游戏：
    - 如果是日文游戏翻译为中文，那么启动时也许应该选择中文区域。
    - 如果是日文游戏翻译为英文，那么启动时也许还是应该选择日文区域。
    对于其他的语言的搭配，我不太清楚该使用何种语言。

1/30/2015 FRI
  [OCR]
  * Fix a bug that HTML tags could mess up the OCR translation popup.
    修正了OCR翻译中有时会出现HTML标签垃圾的问题。

  [Shared Dictionary]
  * There are now two language properties for a translation rule:
    - Source language (From):
      The language of the original text, i.e. Japanese for a Japanese game.
    - Target language (To):
      The language the user want to translate to.

    The target language is the same as the old language property.
    If you are playing a Japanese game, just put source language as Japanese, and
    everything is the same as before.

    If you are playing a non-Japanese game (English, or Chinese, etc.), you can
    create translation rules specific for that source language.

    共享辞书中的词条现在有两个【语言】的属性了。
    - To: 目标语言。这个和以前版本VNR中的【语言】是一样的。
    - From: 游戏的语言。如果是日文游戏，那么这个属性总是【日文】。

    如果你在玩日文游戏，那么什么都不需要变更。
    如果你在玩英文的游戏，那么可以添加From为英文的词条。

  [Game Engine]
  * Update KiriKiriZ engine to work with 「サノバウィッチ」.

    btw, since this version, KiriKiri stopped using GDI function to draw text by default.
    The traditional way to find KiriKiri hooks by backtracking callgraph to GDI APIs no longer works.
    As a result, I do not have a portable way to hook to KiriKiriZ games anymore.
    VNR's game engine might keep becoming outdated whenever KiriKiriZ implementation is changed.

    修正KiriKiriZ来支持「サノバウィッチ」。
    感谢djz020815 sensei的报告！

1/28/2015 WED
  [Wine]
  * Fixed a bug that caused LEC translation fail to work on Wine.

1/26/2015 MON
  [Machine Translation]
  * Google/Bing/Infoseek translation can also display the alignment between the translation
    and the original text.
    With Google/Infoseek, the alignment works for any supported language pairs.
    With Bing, only Japanese to English/Korean translations can be aligned.

  [i18n](Korean, @mireado)
  * Update VNR's UI translation in Korean made by @mireado sama.

1/25/2015 SUN
  [Machine Translation]
  * Add an option to display mapping of translations for Baidu.com/Naver.com.
    VNR will display the original text above the translation except for those
    modified by the Shared Dictionary.
    A screenshot is as follows. It can be enabled/disabled in Preferences/Translation.

        http://i.imgur.com/6Zf5XTw.png

    VNR默认会显示Baidu和Naver的对照翻译。截图在上边。
    如果翻译没有被共享辞书修改，那么VNR会在中文翻译的上边显示被翻译的日文。
    如果你不想看到，可以在【使用偏好/翻译】中禁用这个选项。

  * I temporarily disabled Japanese syntax-based translation.
    I will enable it later after I finish implementing this feature.
    暂时禁止开启基于的语法翻译了。

1/24/2015 SAT
  [Translation Scripts](English, @errzotl)
  * Update TAH script for LEC from @errzotl sensei.

  [Machine Translation](English)
  * Share translation rules (Shared Dictionary and TAH script) between offline LEC
    and online LEC translators.

  * Handle jittering for non CJK languages (such as English) as well.
    For example, given:
        すみません！ => I am sorry!
    Then:
        すっ、すみません！ => I, I am sorry!

    You might not observe such translation for LEC/ATLAS though, since @errzotl's
    TAHScript tend to delete dangling sounds such as "すっ、".

  * I dropped the old translation mechanism for non-CJK languages (such as English),
    and changed to use the same mechanism as CJK.
    Using the new system for English, it is now possible to observe changes made
    by the Shared Dictionary for ouput/translation/name/yomi/suffix rules.

    A screenshot is as follows, where the changes are marked with underline.
    Click the underlined text and VNR will show the term that causes the changes.

        http://i.imgur.com/uWnRBkD.png

    If you are speaking Chinese/Korean, you can ignore the following long texts,
    as it is already how CJK translation works since the first version of VNR.

    For example, given a yomigana definition in the Shared Dictionary:

        悠真 => ゆうま (ID=12345)

    If I want To translate the following sentence to English using LEC:

        悠真くんを攻略すれば２１０円か。

    In the old VNR, the translation pipeline is like this:

        悠真くんを攻略すれば２１０円か。

        => Apply Shared Dictionary
        Yuuma-kun を攻略すれば２１０円か。

        => Send to LEC
        If it captures Yuuma-kun, is it 210 yen?

    The new translation process is like this, which I called "translation escaping":

        悠真くんを攻略すれば２１０円か。

        => Apply Shared Dictionary
        SN12345 を攻略すれば２１０円か。

        => Send to LEC
        If it captures SN12345, is it 210 yen?

        => Apply Shared Dictionary again
        If it captures {id=12345}Yuuma-kun{/id}, is it 210 yen?

    There are a couple of advantages for the new mechanism.

    1. It can hide the translation contents from the machine translators.
       A machine translator cannot see Yuuma-kun but SN12345.

       This prevents translation from messing up the original Japanese text,
       which is critical to for Japanese-Chinese translation, because Chinese
       translation also consists of kanji.

       This will also enable re-translating text where the translation's language
       is not the same as the machine translator's output language.

       For example, if I want to use ATLAS to translate Japanese to Russian,
       I can first use ATLAS to translate Japanese to English, and LEC to re-translate
       English to Russian.
       Given a yomigana definition: 悠真 => ゆうま => Юума
       I can hide non-English word Юума from being visible to ATLAS in this way.

       I will add retranslation support to VNR soon.

    2. It can hide non Shift-JIS characters in the translation.
       Certain translators such as ezTrans require the input Japanese text to be Shift-JIS,
       which makes it impossible to use simple TAH-like replacement for translation having
       characters not in the Shift-JIS character set.

    3. It allows us to track the changes made by Shared Dictionary like in the screenshot.

    While applying translation escaping, VNR currently will avoid escaping full-width
    Japanese punctuations at the beginning/ending of the translation.
    For example, given a translation definition in the Shared Dictionary:

        はい、 => Yes。 (ID=5678)

    And to translate the following sentence to English using LEC:

        はい、そうですよ。

    VNR's translation pipeline will be like this:

        はい、そうですよ。

        => Apply Shared Dictionary
        SN5678。そうですよ。

        => Send to LEC:
        SN5678. It is so.

        => Apply Shared Dictionary again
        {id=5678}Yes{/id}. It is so.

    As you can see, VNR will avoid escaping "。" in the end of "Yes。".

    For details on how it works, please try Test Machine Translation on the SpringBoard.

  [Shared Dictionary]
  * VNR will automatically translate の after a name or name+suffix.
    For example, given a yomigana definition: 悠真 = ゆうま
    And some suffix definition:

        English: くん => -kun
        Korean:  くん => 군

    Then, VNR will translate "悠真くんの" to:

        English: 悠真くんの => Yuuma-kun's
        Korean:  悠真くんの => 유우마군의

1/23/2015 FRI
  [Shared Dictionary]
  * You can right click the translation subs to add an Output term to the Shared Dictionary.
    可以右键点击翻译字幕中的单词来添加输出词条。

  [Game Management]
  * VNR does not require valid Text Settings to add a new game to VNR.
    To add a game, you can simplify drag/drop the game's executable or shortcut file,
    i.e  *.exe or *.lnk, to the SpringBoard like before.

    But even if VNR is offline or the game does not exist in VNR's database, VNR will still add
    the game and won't open the Game Wizard anymore.
    i.e. You can add WHATEVER game/exe to VNR in this way no matter text hook can extract texts or not.

    This might be helpful if you want to use OCR to extract game text instead of text hook.

    You will have to re-adjust Text Settings if you still need VNR's text hook to extract text.

    Please DO NOT add non-game Windows system process (such as Explorer.exe) to VNR.
    If you do, I might block your IP to access VNR's database depending on the processes added.

    I might totally remove the GameWizard in the future.

    添加新游戏时，VNR不再要求有效的文本设定。
    你可以把游戏程式的exe或者快捷方式（lnk）文件直接拖入SpringBoard来添加新游戏。

    即便游戏不在VNR的数据库中，或者VNR是offline的，VNR也仍然会添加游戏而不再打开【游戏向导】。
    也就是说，即使是VNR不可以提取文本的游戏，你也可以通过这种方式添加到VNR中。

    如果你想要使用OCR来提取文本，而VNR又不支持从该游戏提取文本，也许可以通过这种方式来添加游戏。

    如果你仍然需要VNR来提取文本，那么还是要在启动游戏后重新调整【文本设定】。

    但是，请不要添加好像explorer这样的非游戏的系统进程到VNR。
    否则取决于添加的程式，我可能禁止你的IP来访问VNR的数据库。

    我在以后也许会删掉【游戏向导】的功能。

1/22/2015 THU
  [Shared Dictionary]
  * VNR no longer downloads entries in the Shared Dictionary that has been disabled
    for more than 6 months, which might help reduce same some memory and time.
    If you still want to find these disabled entries, you can search them at sakuradite.com/dict.
    共享辞书中被禁用六个月以上的词条不会再被下载。
    如果你一定要看到这些被禁用的词条，可以到VNR的网站上去搜索。

  * Input/output/translation/name/yomi entries can be translator-specific.
    By default, a translation rule will be applied to all machine translators.
    You can now change it to be enabled on specific translator instead.
    用于改善翻译的词条可以只对某个翻译器开启。

  [Machine Translator]
  * Google translation speed improved.
    提高了Google翻译的速度。

  [i18n](Korean, @mireado)
  * Update VNR's UI translation in Korean made by @mireado sama.

  [Machine Translator](Korean)
  * Add Naver.com online translation support for Korean as suggested by @mireado sama.
    Naver can be enabled in Preferences/Translation.

  [TTS]
  * Add Naver.com online TTS support.
    If you are using Online Japanese TTS while playing games, maybe you can try Naver TTS.

    Naver TTS supports less languages (only CJK and English).
    But Naver Japanese TTS sounds better, has higher bitrate, voice pitch can be adjusted,
    and it supports both Male/Female voices.

    For example, in Voices Settings, if you assign a Male gender to a character,
    VNR will use Naver's male TTS to speak out the text.

    添加了对Naver在线语音合成的支持。
    如果你在用百度的日文TTS来读出游戏对话，那么非常建议你尝试下Naver的日文TTS。

    和Baidu比起来，Naver的TTS更清晰，bitrate更高，可以调整音调，并且同时支持男声和女声。
    比方说，如果在语音设定中，指定某个角色的性别是男性，那么VNR会用Naver的男声来读出日文。

1/21/2015 WED
  [Shared Dictionary]
  * Slightly modified the jitter pattern to eliminate xtsu in the middle.
    An example is as follows:

        すっ、すみません！

        => Chinese: 对，对不起！
        => Korean: 미, 미안합니다!

    稍微修改该了下处理口吃的逻辑来删掉中间的xtsu。例句如上。

1/20/2015 TUE
  [Yomigana](Russian)
  * Support converting Japanese kana to Russian alphabet.
    The current mapping could be found in the following page:

        http://sakuradite.com/wiki/en/Furigana

    If you find errors in the mapping, please let me know!

  * Add an option to display ruby in Russian for Japanese in Preferences/Translation.
    When selected, for example, VNR will display каваий instead of kawaii above 可愛い.

  * For yomi typed terms in the Shared Dictionary, VNR will generate names in Russian
    instead of English when a Russian translator is used.

    For example, given a yomi term: 悠真 => ゆうま
    VNR will then translate 悠真ちゃん => Юума-Чан instead of Yuuma-chan.

  btw., If you want to add name translation to the Shared Dictionary, I hope you can use
  Yomi type instead of Name type, so that different languages don't have to have duplicate
  translations for the same set of Japanese names.
  On the bottom of the Game Information, there is an Import Name widget that might help make
  creating Yomi names easier.

  [Yomigana](Thai)
  * I disabled generating names for Thai since the current kana mapping for Thai
    seems to be totally wrong.

    If you are using VNR to translate Japanese games to Thai, I hope if you could
    give me a hand to fix the mapping on the following wiki page:

        http://sakuradite.com/wiki/en/Furigana

  [Translation Scripts](English/Russian, @errzotl)
  * Update TAH script for LEC from @errzotl sensei.

  [Machine Translator](Russian)
  * Support using LEC to provide offline Japanese to Russian and English to Russian translation.
    LEC will translate to English by default.
    You can enable Russian translation by selecting Russian as VNR's language in Preferences.

    Finally, I managed to get this work, which has been obsessing me for two years ...
    I am using the same method as my old post on hongfire two years ago. How time flies.
    After reading assembly for many games, I finally could understand the logic behind LEC's assembly.

    LEC also supports a couple of European languages as well as Chinese and Korean.
    I am going to add translation support for other languages supported by LEC when I have ime.
    And I will add an option to use LEC/Google/Bing as secondary translator to re-translate
    LEC/ATLAS English translation/subtitles to other languages, such as Russian and Vietnamese.

  btw., I created a page below for browsing the Shared Dictionary online.
  It could be used to look up dictionary entries without opening VNR.
  Currently, all entries are read-only on that page.

      http://sakuradite.com/dict

  创建了一个可以浏览和检索共享辞书词条的网页，在上边。
  不过，网页上的词条是只读的，还不可以修改的。

1/19/2015 MON
  [Game Engine]
  * Update old WillPlus engine to work with new Honeybee games.
    修正了WillPlus引擎失效和无法提取部分Honeybee游戏文本的问题。

  [Command Line]
  * As request, add command line options to minimize VNR to system tray after launch.
    You can do it this way:

        Library\Frameworks\Sakura\bin\reader.exe --minimize --nosplash

    运行上边的命令，那么VNR启动后会最小化到system tray。

1/17/2015 SAT
  [Shared Dictionary]
  * 如果你在【使用偏好/国际化】中屏蔽了英文和韩文，那么更新共享辞书时就不会下载
    【读法】词条了。因为这类词条对中文翻译是没有用处的。
    如果你屏蔽了英文和韩文，那么，在这次更新共享辞书的时候，可以先点击下【重置】
    来删掉本地的读法词条。

  * When generating names from yomigana, VNR will remove う after the o-column hiragana.
    For example, given 佐藤院 = さとういん, the generated names will be Satoin/사토인
    instead of Satouin/사토우인.

    The removal will only be applied if there are at least 4 characters in the yomigana.
    For example, 章(しょう) will still be translated to Shou instead of Sho because
    the original yomigana has only 3 characters (< 4).

    If you don't want VNR to remove う, you can use katakana instead of hiragana as yomigana.
    For example, if the yomigana of 佐藤院 is defined as サトウイン instead of さとういん,
    then VNR will not remove ウ in the middle.

1/16/2015 FRI
  [Game Engine]
  * Fix the issue that text hook might stop working for games for Black Cyc, MIO, etc.
    修正了Black Cyc、MIO等会社的游戏提取文本一段时间后会失效的问题。

  * Fix a bug existing for a long time that certain game engine (Malie, PPSSPP, etc.)
    that generating large numbers of text threads might crash VNR with vnrsrv.dll exception.
    修正了一个存在很久的Malie，PPSSPP等产生大量文本thread时会崩溃的问题。

1/15/2015 THU
  [Shared Dictionary]
  * Fixed a bug that sometimes not all name entries are applied.
    Thanks for @djz020815 sensei's report!

  * VNR will try to handle jittering Japanese sentences for Chinese/Korean, such as:

        す、す、すみません！

        => Chinese: 对，对，对不起！
        => Korean: 미, 미, 미안합니다!

    Note that this only works for Chinese/Korean.
    For English, I don't have a way to handle this pattern.
    So, I add a rule to the Shared Dictionary to delete leading "す、す、" instead.

    For Chinese/Korean, VNR will identify the jitter in the following pattern:

        {{boc}}({{kana}})[、…]\1

    As a result, VNR cannot identify, for example:

        す、済みません

    Because す and 済 are different.

    VNR会处理口吃那样的日文。
    比如说，如果已知「すみません！」会被翻译为「对不起！」。
    那么VNR会自动将 「す、す、すみません！」 翻译为「对，对，对不起！」。

1/14/2015 WED
  [Web Browser]
  * Aero effect is removed which is not portable to different Windows.

1/12/2015 MON
  [UI]
  * Texts in the inspector at the bottom of views (SpringBoard, Shared Dictionary, etc.)
    are selectable by mouse and copyable using CTRL+C.
    SpringBoard、共享辞书等下边的inspector中的文本可以用鼠标选定和CTRL+C来复制。

  [Shared Dictionary]
  * Reduce the time and memory to process large numbers of name entries for machine translation.
    减少了处理姓名词条占用的内存和时间。

  * Fixed a regression that newly submitted rules might not be immediately applied.
    修正了新创建的词条可能会无效的bug。

  * Append a space after English translation term just like Korean.
    For example, given two translation rule:
        かわいい = cute
        女の子 = girl
    Then,  "かわいい女の子" will be translated to "cute girl" instead of "cutegirl",
    where a space will be inserted in the middle.

1/11/2015 SUN
  [Shared Subtitle]
  * Avoid showing duplicate subtitles.
    The first-created subtitle will overshadow later duplicates.
    Thanks for @s793016 sensei's report!
    不显示重复的字幕。
    第一个同学创建的字幕会禁止后边重复的字幕。
    感谢s793016 sensei的报告！

  [Shared Dictionary]
  * VNR will validate correctness of the entries in Shared Dictionary.
    There is a new Check column which shows the possible errors in for the entry.
    - When the check value is in green, the entry seems to be OK.
    - When the check value is in orange, it is a warning and the entry might be inappropriate.
    - When the check value is in red, it is an error and the entry is definitely wrong.

    The detailed error message can be find the bottom of the Shared Dictionary.
    Some sample error messages are as follows:
    - Useless error: the entry has no effect and should be deleted
    - Parenthesis warning: the regular expression might have mismatched parentheses/brackets
      (This check is not accurate)

    You can find all incorrect entries by sorting the Check column.

    VNR会检查辞书词条的正确性。
    在共享辞书的table中添加了一个【验证】列。
    - 当列值是绿色的，那么词条大概是正确的。
    - 当列值是orange（表示警告），那么词条可能是有问题的。
    - 当列值是红色的（表示错误），那么词条一定是有问题的。

    错误的信息可以在共享辞书下边找到。
    一些比较重要的错误如下：
    - 无用：词条是没有作用的，应该删掉。
    - 括号：正则表达式中的括号可能不匹配（不过这个检查并不准确，可能会错）。
    - 中文：语言是中文的词条中不应该包含函简体字。
    - 简中：不包含简体字的词条的语言应该设定为正体中文。

    可以点击【验证】列来显示所有被警告的词条。

1/10/2015 SAT
  [Word Dictionary]
  * Display term ID in Shared Dictionary.
    The ID is a number used by VNR internally to uniquely identify a dictionary entry.
    This number can also be found in the popup when click an underlined translation text.

    If you search an integer, such as 1234, VNR will show the ID=1234 entry.

    When create new entry, before saved online, the ID column will display "Unsaved" in red.

    共享辞书会显示词条的ID。
    这个ID在点击下划线的词条后出现的窗口里也可以找到。

    如果在共享辞书中检索整数，比如1234，那么VNR会显示ID=1234的词条。

    在创建词条后，当词条还没有成功保存时，ID栏会用红字显示未保存。

  * In the machine translation test, click the underlined text and VNR will popup the
    dictionary entry that causes the change.

    测试机器翻译中，点击下划线的文字后，VNR会显示造成变更的相应的词条。

  [Shared Subtitle]
  * Javascript can be used in [url] for subtitles.
    Some examples are as follows. It is still useless, though.
    - [url=javascript://growl.msg('hello world")]Click to growl a "hello world" message[/url]
    - [url=javascript://main.showSpringBoard()]Click to open SpringBoard[/url]
    - [url=javascript://main.showUser('jichi')]Click to display user information of @jichi[/url]
    - [url=javascript://main.searchDictionary("jichi", "user")]Click to search dictionary entries made by @jichi[/url]

1/9/2015 FRI
  [Word Dictionary]
  * Improve dictionary rendering to make it more readable.
    改进了对日文单词字典的渲染。

  [Shared Dictionary]
  * When click the underlined machine translation text, VNR will popup to show
    the dictionary entry that causes the changes.
    Due to technical difficulties, the underline trick only works for the
    entries with the follow types and languages:
    - Output      (all languages, including English)
    - Translation (Chinese/Japanese/Korean only)
    - Name        (Chinese/Japanese/Korean only)
    - Yomi        (Chinese/Japanese/Korean only)

    点击机器翻译字幕的下划线的文字，会填出显示是哪一条规则导致了这个变更。
    不过这只对如下类型和语言的词条造成的变更有效，对其他类型和语言的词条无效：
    - 输出词条（任何语言）
    - 翻译词条（仅限中日韩）
    - 姓名词条（仅限中日韩）
    - 读音词条（仅限中日韩）

  [Shared Subtitle]
  * This is kind of useless, but you can now use [url] bbcode in subtitles/danmaku.
    For example, given the following subtitle, it will render 茶道 with underline.
    And if user clicks that underlined word, VNR will open the wiki link in the web browser.

        [url=http://ja.wikipedia.org/wiki/茶道]茶道[/url]

    在弹幕、人工字幕中可以使用[url]的标签了。
    比方说，给定上边字幕或者弹幕，那么VNR会为【茶道】下划线。
    如果其他同学点击【茶道】，那么VNR会用浏览器打开对应的wiki的链接。

    btw., I am thinking to expose Python/Javascript API though danmaku with bbcode.
    For example, maybe, given the following danmaku:

        [script=python]environ['hentai'] = 1[/script]

    It could be used as a trigger to change the translation environment or whatever
    properties of VNR at specific game scene.
    i.e. the script will only be executed when the game reaches at specific scene
    where the danmaku is submitted.

    Or, the script could also be used to create animated danmaku/subtitle, like this:

        [script=javascript]
           var self = this;
           setInterval(1000, function() {
             self.x += 100;
             self.color = Qt.rgb(self.x % 255, 0, 0);
           });
        [/script]

    And it might also be possible to use [url] to simulate clickable buttons:

        [url="javascript://this.speed=10"]Speedup[/url]

    Enabling Python/Javascript in danmaku is quite simple to implement.
    But I feel it is still kind of useless.
    If you have suggestions to make use of it, feel free to discuss with me!

    我在想，也许，可以在弹幕中内嵌Javascript或者Python的代码。
    比如说，当游戏进入到一定的情节，那么，可以用如下的弹幕来告诉VNR打开hentai词条：

        [script=javascript]environment.hentai = true[/script]

    这样，这个script就只有在游戏进入到发弹幕的那个scene的时候才会执行。
    这个其实很好实现，不过感觉还是用处不大。
    如果你有其他的建议，可以让我知道！

1/7/2015 WED
  [ezTrans](Korean)
  * Preserve "『』" in the translation.
    Prevent ezTrans XP from replacing "『』" with "「」".

  [Ruby](Chinese)
  * Display tone for Pinyin.
    拼音注音会显示声调。

1/6/2015 TUE
  [Translation Scripts](English, @errzotl)
  * Update TAH script for LEC from @errzotl sensei.

  * I wrote some scripts to enable macro support while composing TAH scripts.
    I wrote these scripts originally for @riz sensei to improve English translation quality.
    You can ignore the following text if you have never manually written a TAH script.

    The basic idea is that instead of directly writing a TAH script manually,
    first write translation rules in one or several files, and then use a Python
    script to combine them together to generate a legal TAH script.

    My script could be found at Scripts/tahcompile.sh.
    It will take several translation scripts with a new macro syntax and generate
    a single TAH script.
    It will also do syntax checking to the regular expressions in the translation scripts.
    An example could be found at Library/Examples/TAHScript.

  [Chinese Variants](Korean)
  * Add a toggle in Preferences to use Korean Hanja as Chinese variants.
    【使用偏好】中添加了使用朝鲜汉字为默认中文汉字变体的选项。

  [Ruby](Korean)
  * Add an option to recover hanja for hangul text in Preferences.
    For example, given a sentence as follows (which is picked from Korean Wikipedia):

        자유 콘텐츠는 저작권이 소멸된 퍼블릭 도메인은 물론, 저작권이 있지만 위 기준에 따라 자유롭게 이용이 허락된 콘텐츠도 포함한다.

    VNR is able to recover hanja like this, which mixes hangul with hanja just like Japanese:

        自由 콘텐츠는 著作權이 消滅된 퍼블릭 도메인은 勿論, 著作權이 있지만 위 基準에 따라 自由롭게 利用이 許諾된 콘텐츠도 包含한다.

    In this way, it might make it easier to understand for Korean learners who already know Chinese/Japanese.
    A screenshot with hanja and romaja as ruby is as follows:

        http://i859.photobucket.com/albums/ab155/jichi/hanja_zps0638299d.png

    However, the hanja might not be 100% correct, because the meaning of hangul could be ambiguous,
    whose meaning is usually context-sensitive.
    For example, "이용이" in the above sentence can be either "利用이" or "이容易".
    When that happens, VNR will pick the hanja at beginning of the word (i.e. 利用이) over the others,
    which might be right or wrong depending on the context.
    Additionally, due to ambiguity, VNR currently will not guess hanja for individual hangul.

    I will add support of displaying romaja and hanja for Korean to Website Reader later when I have time.

    在【使用偏好/翻译/读音】中添加选项来恢复韩文中的汉字。
    比方说，给定下边的韩文Wikipedia上的一句话：

        자유 콘텐츠는 저작권이 소멸된 퍼블릭 도메인은 물론, 저작권이 있지만 위 기준에 따라 자유롭게 이용이 허락된 콘텐츠도 포함한다.

    VNR可以将其中的部分汉字恢复出来，变成好像假名和汉字混合的日文一样：

        自由 콘텐츠는 著作權이 消滅된 퍼블릭 도메인은 勿論, 著作權이 있지만 위 基準에 따라 自由롭게 利用이 許諾된 콘텐츠도 包含한다.

    这样，也许可以帮助学习韩文的同学来阅读。
    下边是用汉字和罗马字为韩文注音后的截图：

        http://i859.photobucket.com/albums/ab155/jichi/hanja_zps0638299d.png

    不过，由于韩文本身很容易有歧义，标注的汉字并不能保证100%正确。
    比方说，在上边的例句中，「이용이」既可能是「利用이」又可能是「이容易」。
    这时，VNR会选择位置在单词左边边界的汉字，即：「利用이」。
    不过，这种策略并不一定都是正确的。
    另外，由于单个韩文字母可能对应的汉字太多，VNR不会对单个韩文恢复汉字。

    我以后有时间的话，会把对韩文的支持添加到Website Reader中。

1/5/2015 MON
  [Korean]
  * Add KS_C_5601 encoding to Text Settings for translating Korean games.
    文本设定添加了韩文的文字编码（KS_C_5601）。
    如果要翻译韩文化的游戏，可以选择这个编码。

  [Ruby]
  * Add an option in Preferences/Translation to display romaji as ruby for non-Japanese texts.
    This is useless unless you want to play non-Japanese games using VNR.
    A screenshot of translation with ruby for Chinese Pinyi and Korean Romaja is as follows:

        http://i859.photobucket.com/albums/ab155/jichi/Ruby_zps6c4331ff.png

    在【使用偏好/翻译】中添加一个对非日文语言显示注音的选项。
    这个选项是没有用的，除非你打算用VNR来玩非日文的游戏。
    上边的是包含中文拼音和韩文罗马字注音文本的截图。

1/4/2015 SUN
  [Shared Dictionary]
  * If you have Microsoft Japanese IME installed, when create new dictionary entry,
    the popup dialog will display the guessed kanji of Japanese kana.
    如果有安装微软日文输入法，那么在创建词条时，会显示猜测的假名对应的汉字。

  * In the bottom of Game Information window, there is a new "Import Name" button,
    which might help you add names to Shared Dictionary.
    In the name wizard window, it will display all guessed names for the game.

    - For non-Chinese languages
      You can press "Yomi" buttons to add yomi entries to Shared Dictionary.
      As mentioned before, Yomi names will be automatically converted to English/Korean/Thai
      translations.

    - For Chinese
      You can press "Name" buttons to add name entries to Shared Dictionary.
      VNR will automatically guess the Chinese kanji for Japanese names.

    在【游戏情报】的下边，添加了一个【导入名字】的按钮，可以用来帮助创建姓名词条。
    打开后，弹出的窗口会显示猜测的名字。

    - 对于中文语言
      可以点击【名字】来添加人名词条。VNR会自动猜测日文对应的正体中文或者简体中文的。

    - 对于非中文的语言
      可以点击【读法】来添加读法词条。这里就不细说了。

  * At the bottom of Shared Dictionary, VNR will display Romaji of translation for all languages
    (such as Chinese Pinyin and Korean Romaja) except Japanese and English.
    This is useless unless you want to understand dictionary entries in foreign languages like me.
    在共享辞书的下边，会显示除去英文和日文外全部语言的翻译的罗马字（比如韩语）。

1/2/2015 FRI
  [Forum]
  * Display topics of questions and reviews  per-game.
    VNR会显示与游戏有关的问题和感想。

  [Proxy]
  * If you are blocked by ErogameScape, you can turn on proxy in Preferences/Internet.
    Due to technical difficulties, it currently only works in VNR, not the Website Reader.
    如果你无法访问批评空间，可以在【使用偏好/Internet】中打开代理。
    不过当且只对VNR有效，而对Website Reader无效。

  * If it is very slow to access Baidu.com, you can turn on proxy in Preferences/Internet.
    如果你不在中国大陆地区居住，而造成百度翻译很慢很慢，那么你也许可以尝试打开
    【使用偏好/Internet】中对百度的代理。

  * 恢复了大陆地区对Google翻译的访问。
    但是速度比直接访问Google会慢很多。

  [Shared Dictionary]
  * Add a "private" toggle in the Create Dictionary Entry dialog as requested by @Venomg3 sama.

12/31/2014 WED
  [JBeijing](Chinese, @djz020815)
  * 更新了djz大先生的J北京词库。

12/30/2014 TUE
  [i18n](Korean, @mireado)
  * Update VNR's UI translation in Korean made by @mireado sensei.

12/28/2014 SUN
  [Game Engine]
  * Do not hijack Lstr functions for games made by Chartreux Inc. (Rosebleu, MORE, etc.)
    It might cause text hook to stop working.
    修正了Chartreux旗下的Rosebleu、MORE等社的游戏提取文本一段时间后会失效的问题。

  [Online TTS](Korean)
  * Fixed a bug that Baidu TTS did not speak Korean text.

    btw., if you are learning Korean, you could try ezTrans to translate Japanese eroge to Korean.
    Due to the similarity of the two languages especially the pronunciation, combining with TTS
    for Japanese and Korean, it might give you a hand to learn Korean at the same time.

    修正了百度TTS无法读出韩文的bug。

    btw., 如果你在学习韩语，也许，可以尝试下载ezTrans XP来将日文的游戏翻译成韩文。
    ezTrans是最流行的日韩翻译程式了。
    由于日韩语言极度的相似性（尤其是单词的发音），结合在线日语和韩语的TTS，
    也许可以帮助大家学习韩语。

12/27/2014 SAT
  [Game Engine]
  * Add LunaSoft engine for 「悪堕ラビリンス」.
    为「悪堕ラビリンス」添加了提取文本的引擎。

  * Add new YU-RIS engine for 「鯨神のティアスティラ」.
    The old engine might not work and will crash the game on Windows XP.
    为「鯨神のティアスティラ」添加了新的YU-RIS引擎。

  * Fixed a bug in Leaf engine which might crash White Album.
    修正了一个可能会让White Album崩溃的bug。

12/26/2014 FRI
  [Machine Translation](English)
  * VNR will capitalize the first letter of a sentence for machine translation.

  [Game Engine]
  * Add game engine for 「ハーレムめいと」.
    However, the Text Settings have to be re-adjusted every time the game is restarted.

    VNR now will hook to several functions in mono.dll, which might also work for non-eroge C# games:

        MonoString*    mono_string_from_utf16     (gunichar2 *data);
        mono_unichar2* mono_string_to_utf16       (MonoString *s);
        char*          mono_string_to_utf8        (MonoString *s);
        gchar*         mono_utf8_from_external    (const gchar *in);
        gunichar2*     mono_unicode_from_external (const gchar *in, gsize *bytes);
        gchar*         mono_unicode_to_external   (const gunichar2 *uni);

    为「ハーレムめいと」添加了提取文本的引擎。
    不过这个提取方法不太好，每次游戏重新启动，都需要重新调整文本设定。

12/25/2014 THU
  [Game Engine]
  * Add Leaf engine for 「WHITE ALBUM2 ミニアフターストーリー」.
    为「WHITE ALBUM2 ミニアフターストーリー」添加了提取文本的引擎。

  [Yomigana](Korean, @Reality)
  * Fix the errors in the mapping from Furigana to Hangul.
    Thanks for @Reality sensei's help!

12/23/2014 TUE
  [Game Engine]
  * Remove garbage text in HorkEye engine for 「結城友奈は勇者である」.
    去除「結城友奈は勇者である」文本中的垃圾字符。

  * Add new CatSystem engine for FrontWing games.
    The old engine has been broken for a long time.
    修正了CatSystem引擎提取文本会分裂的问题。

  * Add Mink engine for 「しすたー・すきーむ3」.
    My current hook is kind of crappy that it contains a large number of garbage threads.
    If you have a better way to handle Mink games, feel free to let me know!
    为Mink的游戏添加了提取文本的引擎。

  [Yomigana]
  * Add an option in Preferences/Translation to change position of kanji's yomigana (such as romaji).
    By default, VNR will render big kanji on the bottom, and small yomigana as ruby on the top.
    When that option is toggled, VNR will instead show big yomigana on the bottom, but kanji as ruby.

    This option might be helpful if you are uncomfortable with Kanji but only want to see Romaji.
    Here's a sample screenshot:

        http://i859.photobucket.com/albums/ab155/jichi/yomigana_zps1dd31f9f.png

    在【使用偏好/翻译】中添加了一个选项来颠倒显示的汉字和振仮名（比如罗马字）的位置。
    VNR默认会在下面用大字显示日文，在上方用小字显示注音。
    这个选项开启后，VNR会改为用大字在下边显示注音，用小字在上边显示注音。
    截图在上边。

12/21/2014 SUN
  [i18n](Korean, @mireado)
  * Update VNR's UI translation in Korean made by @mireado sensei.

12/20/2014 SAT
  [Translation Scripts](English, @errzotl)
  * Update TAH script for LEC from @errzotl sensei.

  [Shared Dictionary](Korean)
  * Fixed a bug that might cause translation to become floating numbers.

  * Append a space after each Korean translation.
    For example, given two names:

        桜小路 = 사쿠라코우지, ルナ = 루나

    Then, 「桜小路ルナ」 will be translated to "사쿠라코우지 루나",
    where a space will be inserted in the middle.

  [Shared Dictionary]
  * Name suffices now support regular expressions and macros.
    But please do not use back references in regex suffices, such as:

        (abc) => \1

    Because this might break the regex names that also use back references.
    And if you need regex groups, please use "(?:)" instead of "()".
    For example, please use "(?:さま|サマ)" instead of "(さま|サマ)".

    I am going to clean up the existing suffices in the Shared Dictionary using regex and macros.
    Then, I will delete old non-regex suffices after Two Weeks when most users have updated VNR.

    后缀词条可以使用正则表达和宏定义了。

    不过，请不要使用好像\1、\2、\3这样的表达式作为后缀。
    因为这些表达式可能会破坏正则表达的名字词条。

    使用新的表达方式，可以提高处理名字词条的速度和减少内存的使用量，以及便于管理。
    我在两周后，等大部分同学都更新过VNR了，会删掉共享辞书中以前的非正则的后缀。

  * Add a new Yomi type to the Shared Dictionary for specifying furigana of Japanese names.
    VNR will automatically generate name translation from the furigana into Romaji, Hangul, or Thai.
    Yomi terms have no effect for Chinese translation.

    I notice that there are duplicate character names for various languages, esp. English and Korean.
    Such terms might help share name translations between different languages,
    and allow me to import character names on Getchu in the future.

    For example, given a yomi term in either katakana or hiragana:

        桜小路 = さくらこうじ

    VNR will automatically generate the following three names depending on the language to translate to.

        桜小路 = 사쿠라코우지   -- for Korean
        桜小路 = สะขุหละโขะอุจิ    -- for Thai
        (ignored)               -- for Chinese
        桜小路 = Sakurakouji    -- for any other languages including English

    I am going to create an UI to let us selectively import Yomi names on Getchu later,
    which might save us from manually adding character names.

    添加了一个新的【读法】词条。
    这类词条对中文是没有意义的。VNR在进行中文翻译时会忽略此类词条。
    当前版本的VNR中，大家无视这种词条就好了。

    我在以后会添加一个从Getchu导入人物姓名的界面，这类词条到时候再说吧。

12/17/2014 WED
  [Subtitle Sharing]
  * Add an alternative way to import/export/edit offline subtitles.
    The idea is motivated by the offline subtitles made by @bayooooo sensei for several games.
    For example, you can find the uploaded subtitles for「プリンセスラバー」here, where the subtitles
    are converted from the XML format offline subtitles made by @bayooooo sensei for VNR.

         http://sakuradite.com/game/PRINCESS_LOVER

    The new subtitles are expressed in YAML format.
    If you don't know YAML, please check: http://en.wikipedia.org/wiki/YAML
    YAML is selected as VNR's subtitle format, because it is easy for human to read.
    Here's an example subtitle file to create new subtitles:

        # The root item in YAML file is a list of dictionaries.
        # The first dictionary describes the global options
        - subLang: en
          textLang: ja
        # The following dictionaries are the subtitles.
        - text: こんにちは！
          sub: Hello!
        - text: お花の匂い
          sub: Smell of flower

    The web server will compare the uploaded subtitles with the existing ones in the database.
    If there are no existing subtitles for 「こんにちは！」 and 「お花の匂い」in the online DB,
    the web server will create two new subtitles for them.
    Otherwise, if there are existing subtitles, it will create new *revisions* of the subtitles,
    instead of overwriting the existing ones.

    After uploading, the subtitles can be redownloaded, which might look like this:

        - subLang: en
          textLang: ja
        - id: 101
          text: こんにちは！
          sub: Hello!
        - id: 102
          text: お花の匂い
          sub: Smell of flower

    For example, if I want to replace "Smell" by "Fragrance", I can create the following file
    and re-upload it to the server.

        - subLang: en
          textLang: ja
        - id: 102
          text: お花の匂い
          sub: Fragrance of flower

    Here, the "id: 102" part is optional. The following file also works.
    But keeping the id will help the server speed up the subtitle comparison process.

        - subLang: en
          textLang: ja
        - text: お花の匂い
          sub: Fragrance of flower

    Note that VNR will create a new revision of the subtitle, instead of simply replacing the string.
    The subtitles are saved in a wiki-like way.
    In the future, I am going to create UI to allow people to revise/revert to previous revisions.

    Currently, there is a limit of 200 changes that each upload can made to the existing subtitles.
    It is intended to prevent malicious/by mistake sabotage to the existing subtitles.

    After upload, the server will categorize the subtitles into five groups:
    - total: it contains all subtitles that are processed
    - create: it contains new subtitles that do not exist in the database
    - update: it contains subtitles that have modified existing subtitles
    - ignore: it contains subtitles that are the same as the existing subtitles
    - error: it contains the subtitles that are rejected, and the reject reasons

    After uploading the subtitles, VNR will render the them in game in the old subtitles.
    The new subtitles is implemented in very efficient way, which is faster and takes few memory.
    For examples, all Chinese subtitles of PRINCESS LOVER takes only 15MB RAM.

    Currently, I haven't finished implementing the support to submit/edit new subtitles in VNR.
    The only way to add/edit subtitles is to upload YAML files.
    I am going to implement a new subtitle editing interface to expose revisions of subtitles later
    allowing people to revise and revert changes.
    And I am also going to add support to record game text into YAML files to allow users to create
    or edit subtitles offline without opening VNR.

    btw., I also created some scripts to manipulate YAML subtitles, which you can find in Scripts.
    - Script/sublint.cmd
      This script can check if there are syntax errors in the YAML subtitle file.
    - Script/subx2y.cmd
      This script can convert existing XML subtitle file to YAML format.
      It is intended to help @bayooooo sensei convert his external XML subtitles to new YAML format.
      Please don't use it to convert subtitles already existing in VNR.

    I plan to change the subtitle sharing mechanism in VNR to a new wiki-like way.
    Because I don't want to break the existing subtitles in VNR, I will first finish implementing
    the new sharing mechanism and then port existing subtitles to the new system.

    There are some major differences comparing the organizations of the new and old subtitles.
    - Old subtitle sharing mechanism
      Multiple subtitles are allowed for the same text.
      One subtitle is saved with one text.
      Each subtitle is owned by a user.

      Illustration example:
        User1 (lang1): text1 = sub1
        User2 (lang1): text1 = sub2
        User3 (lang2): text2 = sub3

    - New subtitle sharing mechanism
      Only one subtitle is allowed for the same text per language.
      The editing history of each subtitle is saved.
      Each change made to a subtitle is owned by a user.

      Illustration example:
        text1
        - lang1
          - user1: sub revision 1
          - user2: sub revision 2
        - lang2
          - user3: sub revision 1

      Here's an example translation in XML format that might help illustrate the organization:

        <texts lang="ja" gameId="425">
          <text time="1418887452">
            <content>こんにちは！</content>
            <sub lang="en" version="3">
              <revision version="3" userName="bayooooo" time="1418887533">
                <content>Hello!</content>
              </revision>
              <revision version="2" userName="jichi" time="1418887826">
                <content>Hello</content>
              </revision>
              <revision version="1" userName="jichi" time="1418887819">
                <content>Good morning!</content>
              </revision>
            </sub>
            <sub lang="zh-CN" version="1">
              <revision version="1" userName="jichi" time="1418887533">
                <content>你好!</content>
              </revision>
            </sub>
          </text>
        </texts>

    It defines two subtitles in two languages (en and zh-CN) for the same text 「こんにちは！」
    for game 425 (game ID of PRINCESS LOVER is 425).
    For the en subtitle, there are 3 versions.
    User "jichi" first created an initial translation "Good morning!" on 1418887533.
    Then, the subtitle was changed to "Hello" on 1418887819.
    Finally, another user "bayooooo" modified the subtitle to "Hello!" on 1418887533.

    If you have suggestions or concerns for the new subtitle sharing system,
    feel free to let me know!

    我在修改保存和编辑人工字幕的方式。
    当前，只支持上传和下载YAML格式的人工字幕。
    这个想法是收到 @bayooooo sensei制作的VNR的离线字幕的启发的。
    比方说，在下边可以找到导入到PRINCESS LOVER中的字幕。
    新的字幕采用YAML格式保存，转换自 @bayooooo sensei以前制作的XML格式的字幕。

         http://sakuradite.com/game/PRINCESS_LOVER

    新的字幕保存机制采用类似Wiki的方式。
    新的字幕保存机制和老的字幕保存机制的最大的区别在于：
    - 老的机制
      每字幕都被一个同学拥有。
      同一个文本可能出现多个同学的多个字幕。

    - 新的机制
      对同一个文本，同一种语言，只允许有一条字幕。
      保留每条字幕的全部编辑历史。允许revise和revert到不同的revision。
      对字幕的每个修改都被一个同学拥有。然而，整条字幕不再被一个同学拥有。

    另外，VNR对新版本字幕的处理更加有效率。字幕的更新采用增量更新。
    新版的字幕不会像老版的字幕那样占用很多内存和带宽了。
    比方说，载入全部PRINCESS LOVER的字幕只需要15MB的内存。

    不过，VNR端对于新版字幕的编辑和提交还没有写完。
    字幕在下载到VNR中后，是只读的。
    我在以后会添加新的字幕编辑的界面，好像Wiki那样可以显示字幕编辑的历史和允许revert changes。
    另外，我也会添加将游戏的文本提取出来并保存为YAML的格式，来便于大家离线修改字幕。

    btw, 在Script文件夹中有一些字幕格式有关的工具。
    - sublint：检查字幕中是否有语法错误
    - subx2y：将xml格式的字幕转换为yaml
    如果你要生成yaml的字幕，也许可以参考这两个脚本的源码。
    源码在Library/Frameworks/Sakura/py/scripts中可以找到。

    如果你有建议或者担心，可以让我知道！

12/13/2014 SAT
  * Proxy to ErogameScape no longer works.
    对批评空间的代理失效了。
    看起来，VNR服务器的ip被批评空间屏蔽了。
    查看了下批评空间11月的流量统计，VNR代理的访问排在所有访问的第47位，也许被站长发现了吧。

12/10/2014 WED
  [Machine Translator]
  * Fix Bing online translator, which stopped working due to the changes of Microsoft website.
    修正了Bing在线翻译失效的问题。由于微软网站的变更，老版本VNR的Bing无法使用了。

12/9/2014 TUE
  I put VNR's recent changes in the following page.
  If you don't like updates, you can check the changes to determine whether update VNR.

      http://sakuradite.com/app/vnr/changes

  我把VNR最近的变更放在上边的地方了。
  如果你不喜欢经常更新程式，也许可以查看下上边的变更来决定是否值得更新VNR。

  [JBeijing](Chinese, @djz020815)
  * 更新了djz大先生的J北京词库。

  [Translation Scripts](English, @errzotl)
  * Update TAH script for ATLAS/LEC from @errzotl sensei.

  [Shared Dictionary]
  * VNR now will do incremental update to the Shared Dictionary by default, which is
    much faster and uses less memory and network bandwidth.
    VNR更新共享辞书时改为增量更新，这样可以大幅减少更新所用的时间、内存和带宽。

    But if the local Shared Dictionary is corrupted for whatever reason,
    you can press "Reset" in the update prompt to discard local data and
    redownload the entire Shared Dictionary (which will be slower).
    但是如果由于未知的原因，本地的共享辞书损坏了，那么在更新时可以选择【重置】
    来重新下载辞书的数据（这样会慢些）。

12/4/2014 THU
  [OCR]
  * As requested, add a keyboard shortcut to start/stop monitoring game window to OCR.
    The shortcut can be adjusted in Preferences/Shortcuts.
    添加了一个快捷键来开启、停止监视要OCR的游戏窗口。

  [Speech Recognition](Windows XP)
  * Selecting audio devices for speech recognition is always disabled on Windows XP,
    as it might hang VNR on startup on certain hardware.
    在Windows XP上，禁止选择内录的音频设备来语音识别。
    否则因为在个别的Windows XP的机器上会让VNR无法启动。

  [Game Engine]
  * The logic of Majiro2 engine is changed so that it can remove 振仮名 from game text,
    as these 振仮名 would mess up machine translation.

    If you are playing Majiro2 games such as 残念な俺達の青春事情 and 流され妻 released
    this month, you will have to re-adjust Text Settings.
    Sorry for the inconvenience!

    修改了Majiro2引擎的逻辑来删掉文本中的振仮名。
    因为这些振仮名会扰乱机器翻译。

    如果你在玩本月的Majiro2的游戏，比如：「残念な俺達の青春事情」和「流され妻」，
    那么你将不得不重新调整【文本设定】。
    带来不便很抱歉！

  P.S. 看到有同学将「残念な俺達の青春事情」的文本设定的编码修改为了BIG5。
    所谓的文字编码，就和Chrome、Safari、Firefox等浏览器中网页的文字编码的含义是一样的。
    但是BIG5和GBK都是中文的编码。
    除非是汉化的游戏，否则绝对不要选择这两个编码，不然提取的文本会变成乱码的。

    在【文本设定】每个提取文本的右边，都用黑色的字写着文本的编码的。
    除非是汉化的游戏，否则【文本设定】的编码一定要与选择的【对话】文本右边的编码相同才可以。

12/2/2014 TUE
  [Game Engine]
  * Add 5pb engine for「CROSS+CHANNEL Final Complete」.
    It might also work for other 5pb PSP/PS3 games ported to PC.
    为「CROSS+CHANNEL Final Complete」添加了提取文本的引起。
    这个引擎也许还会支持其他的移植到PC版的5pb PSP/PS3的游戏。

  * 屏蔽添加CalendarMain.exe为游戏。

11/28/2014 FRI
  [Game Engine]
  * Add text engine for new Majiro game「流され妻、綾乃の"ネトラレ"報告」.
    The old Majiro engine cannot extract text any more and will crash the game on Windows XP.
    为「流され妻、綾乃の"ネトラレ"報告」添加了新的Majiro引擎。
    感谢@天音老师 sama的报告！

  [Preferences]
  * As requested, add an option to select the location to save game screenshot in Preferences/Recordings.
    在【使用偏好/录制】中可以选择保存游戏截图的位置。

  [Shared Dictionary]
  * As requested, add a combobox to select the column to search the Shared Dictionary.
    在共享辞书中添加了一个可以选择搜索列的选项。

11/24/2014 MON
  [Game Engine]
  * Fixed a bug that might crash KiriKiriZ games such as「VenusBlood HYPNO」.
    修正了一个可能会让「VenusBlood HYPNO」崩溃的bug。

11/22/2014 SAT
  [Preferences]
  * Add an option to disable auto-hiding the left dock.
    This might be useful if you are running VNR on a tablet.
    在左边Dock的右键菜单中可以禁止自动隐藏Dock。
    如果你在平板电脑上使用VNR，这样也许会方便些。
    感谢@青穹牧云 sama的建议。

11/20/2014 THU
  * Automatic speech recognition (ASR) is temporarily disabled.
    Going to re-enable it after adding offline ASR support.
    因为性能太差，暂时禁用了自动语音识别（ASR）。

  * Allow uploading images in the messages.
    在留言板可以上传图片。

11/16/2014 SUN
  * Update LocaleSwitch to the latest version 1.0.1.1.
    Thanks for @867258173 sama's report!

  * In Website Reader, make sure Japan-only pages will not be blocked by DMM.
    确保Website Reader的网页不会被DMM屏蔽。

  * Add alternative KAGParserEx hook engine for KiriKiriZ games.

11/15/2014 SAT
  * Add very primitive support to translate online galgame 「対魔忍アサギ～決戦アリーナ～」
    using Website Reader. A screenshot is as follows:

         http://i.imgur.com/kkVo36l.png

    The subtitles can be turned on by clicking the 遊 button on the toolbar.

    Currently, only machine translation is supported.
    Any other features in VNR such as TTS, MeCab, and Shared Dictionary have not been implemented.
    And 対魔忍アサギ is the only supported game.
    I am planning to allow users to specify the location of the text to translate using simple
    jQuery selectors in the future.
    If you would like to have other online games supported, feel free to let me know!

    Note：VNR is using Apple's WebKit to access Internet, which requires QuickTime to play multimedia.
    The online game might not have sound if Apple's QuickTime is not installed.

    添加了对翻译在线日文游戏的非常简陋的支持。
    下边是「対魔忍アサギ」的截图。

        http://i.imgur.com/kkVo36l.png

    这个机能可以在Website Reader点击工具栏中的【遊】按钮来开启。

    当前仅支持机器翻译。TTS、分词、共享辞书什么的全都不支持。
    而且VNR只支持从「対魔忍アサギ」提取scenario的文本，并不能翻译全部文本。
    我在以后会添加界面来让大家可以用非常简单的jQuery的语法来指定要翻译的文字的位置。
    如果你希望添加其他在线游戏的支持，也可以让我知道！

    注：VNR内部使用的是苹果的WebKit，需要QuickTime来播放在线媒体。
    如果没有安装QuickTime的话，在线的游戏可能会没有声音。
    QuickTime可以在苹果的官网免费下载到的，安装完成后需要71MB。

11/14/2014 FRI
  * Add text hook engine for 結城友奈は勇者である from みなとそふと.
    为「結城友奈は勇者である」添加了提取文本的引擎。

11/5/2014 WED
  * Update TAH script for LEC from @errzotl sensei.

  * 更新了djz大先生的J北京词库。
    by djz，针对10月的新作有很多修正。如果你希望添加新词到J北京，可以到下边向先生反馈：

        http://sakuradite.com/topic/220

  * Fixed a bug that VNR might crash when EDICT is enabled while clicking Japanese words to lookup very fast.

11/4/2014 TUE
  * Enable context menu for full screen Adobe Flash 10 games.
    Adobe Flash Player 10的游戏在全屏后仍然可以使用右键菜单。

11/2/2014 SUN
  * Support using Google Speech Recognition (SR) online service to extract text from game audio.
    There is a Speech Recognition Tester on the SpringBoard.
    You can also enable periodical recognition on the left dock after a game is launched.
    There is also a keyboard shortcut (Alt+R) that can trigger the SR.

    By default, the sound is recorded through Microphone, where the quality is low.
    If you want to record audio in games, it is better to specify which device to use in Preferences/SR.
    However, on Wine or Virtual Machines (such as Parallels Desktop) where the emulated sound card
    does not support recording, only Microphone can be used to record speech.

    The current support is very primitive.
    - It requires high-speed Internet access to Google.

    - There are no OCR-like customized filters to eliminate BGM behind speech.
      The accuracy of the recognition can not adjusted.

    - VNR's algorithm is not clever enough to detect when a sentence has finished.
      Currently, an audio is divided into sentences by "silence".
      But if there is no silence, VNR will keep recording and never do recognition.
      You might usually have to manually trigger the recognition (Alt+R) before/after a sentence.

    添加了通过Google语音识别(Speech recognition, or SR)来提取文本的功能。
    在SpringBoard上有一个测试的app。
    在游戏启动后，在左边的Dock里也可以打开自动语音识别。
    另外，在【使用偏好/快捷键】中可以指定快捷键（默认是Alt+R）。

    默认时，VNR会录制麦克风的声音（所谓的外录，质量会很差）。
    如果要对游戏使用语音识别，那么最好在使用偏好里选择声卡支持的录制设备（内录）。
    但是，如果在Wine上或者虚拟机中（比如Parallels Desktop），声卡不支持录制，那么
    只好通过麦克风来录制声音。

    当前的支持还很原始的。
    - 语音识别需要和Google之间的高速的网络连接。
      如果你暂时居住在大陆地区，那么需要在【使用偏好/Internet】打开中国大陆选项。
      但是即使打开，速度还是会很慢。

    - 现在还没有OCR的过滤器那样可以手工过滤掉声音背后的BGM的功能。

    - VNR不能够很聪明的检测到一句话何时完成。
      VNR当前只是简单地检查声音的强度是否很低，来分割录制的声音。
      但是，当录制的声音一直都没有停止（比如有背景音乐），那么VNR会一直录制而不开始识别。
      当前暂时只好手动的点击【识别】（或者Alt+R）来告诉VNR一句话何时开始何时结束。

11/1/2014 SAT
  * Fix a bug that the mouse/keyboard shortcuts might stop working after a while.
    修正了快捷键有时会失效的问题。

10/31/2014 FRI
  Since so many users were using VNR simultaneously this weekend, VNR's server was overloaded.
  You might experience failure to update VNR's Shared Dictionary and game database
  around JST 10:00pm this Friday.

  VNR's services are written in Python and Java. I temporarily shut down the Java server so that
  the Python server could serve the large amount of queries to the game database the Shared
  Dictionary normally. But you are no longer to post or register new accounts online like before.
  I am going to fix scalability issue of the current service implementation when I have time.
  Sorry for the inconvenience!

  因为这个周末使用VNR的同学太多了，造成服务器超负荷了。
  VNR在周五晚上可能出现了无法登陆，无法更新辞书等问题。
  为了节省服务器的资源，使得VNR可以正常更新辞书和游戏数据库，我暂时关掉了VNR的网站的Web UI。
  带来不便，很抱歉！

  * Add Adobe Flash Player 10 game engine for 輪舞曲Duo from TinkerBell.
    为TinkerBell的「輪舞曲Duo」添加了提取文本的引擎。

10/28/2014 TUE
  * Update TAH script for ATLAS/LEC.
    The scripts are from @errzotl sensei, and you can say thanks to him/her at TAHscript@outlook.com.

10/25/2014 SAT
  * Add alternative SiglusEngine that can extract character name thread.
    为SiglusEngine添加了可以提取人物姓名的thread。

  * VNR no long hooks to GDI functions when the game engine is known to be sufficient to extract all texts.
    This might save some memory and reduce the possible game slowdown caused by text extraction.

10/24/2014 FRI
  * Remove garbage texts for KAGParser and CIRCUS engines so that Share Dictionary
    rules to repair text are no longer needed.
    Additionally, ITH is extended to allow removing garbage text per game engine.
    If you find certain game engine always has similar kind of garbage, feel free to
    let me know!

    自动移除KAGParser和CIRCUS引擎文本中的垃圾。

  * Add new KiriKiriZ game engine that can extract character name.

  * 禁止把NK-Frontend.exe当做游戏添加到VNR。

10/21/2014 TUE
  * Add a new KAGParser game engine for 「VenusBlood HYPNO」, which uses KiriKiriZ.
    The existing KiriKiri1/KiriKiri2 seem to be broken for KiriKiriZ games.
    However, the new engine currently cannot extract character name, and the extracted
    text contains "[r]" garbage which requires Shared Dictionary rules to clean-up.

    As you known, KiriKiri is a very popular game engine.
    If you find a better way to handle KiriKiriZ games, feel free to let me know!

    btw., the context menu of VNR still works when KiriKiriZ games enter full screen.

    为VenusBlood HYPNO添加了新的KiriKiriZ引擎。
    感谢jin70908469 sama的报告！

    另外，在KiriKiriZ的游戏全屏后，VNR的右键菜单仍然可以使用。

  * 修正了正体中文时的【我】会被替换为【緸】的问题。
    带来不便，很抱歉！

10/20/2014 MON
  * Fix a bug in 東北ずん子 TTS that sometimes only half of the sentence was read.
    修正了東北ずん子有时只读出半句日文的bug。

10/19/2014 SUN
  * Use OpenCC instead of Google to convert different Chinese variants.
    Add an option in Preferences/Translation/Chinese for selecting default Kanji variants among
    Taiwan Standard Chinese (default), Hong Kong traditional Chinese, and Japanese Kanji.

    VNR's default Chinese UI is changed to use Taiwan Standard Chinese.

    改为使用OpenCC而不再用Google来做中文变体的转换。
    在【使用偏好/翻译/中文】中添加了选择中文变体的选项，可以在
    中华民国正体字（默认），香港繁体字，和日本汉字之间选择。

    另外，VNR默认的中文界面改为使用OpenCC的正体中文。
    马英九总统有提倡简体中文的使用者「识正书简」。希望这样可以帮助大家回归正体中文。

  * vnrcli.dll and vnreng.dll are merged into a single vnrhook.dll
    If you have anti-virus soft installed, you might have to add that dll onto the whitelist.

    用于提取文本的vnrcli.dll和vnreng.dll合并为了一个vnrhook.dll。
    如果你在使用杀毒软体，也许需要将那个dll加入白名单中。

  * For certain game engines such as SiglusEngine, VNR no longer disables context menu
    when game enters full screen.
    对于某些游戏引擎比方说SiglusEngine，VNR在游戏全屏后不再禁用右键菜单。

10/18/2014 SAT
  * Add new SiglusEngine for リア充クラスメイト孕ませ催眠.
    为「リア充クラスメイト孕ませ催眠」添加了新的游戏引擎。

  * Bugfix for the correctness of the generated romaji and hangul furigana.
    修正了罗马字和韩文的振仮名的部分错误。

10/17/2014 FRI
  * Add variable syntax to VNR's new machine translation system.
    It can be enabled in Preferences/Shared Dictionary.

    Current, it is still at testing stage.
    Please do NOT enable it to translate real-world games except for testing purpose!!

    Regarding the syntax, for example, $x can be used to match any single node in the syntax tree.
    And @x can be used to match a list of any adjacent nodes in the syntax tree.
    Here's some example illustrating how it works:

    Given a syntax tree:  ((((お前 の) (物 は)) (俺 の)) 物)
    The following replacement will translate の at the end of an adjective to "的" in Chinese.
    - ($x の) => ($x 的) -- $x = お前
    - (($x の) $y) => (($x 的) $y) -- $x = お前, $y = 物は
    Here's an example for list variables:
    - ((@adj) 物) => ((@adj) 东西) -- @adj = ((お前 の) (物 は)) and (俺 の), totally two nodes

    向VNR的翻译系统添加了变量的语法。
    在使用偏好的共享辞书中可以开启这个选项。

    现在，这个技能还在测试中。除非测试目的，请不要打开这个选项！！

    比方说，给定： ((((お前 の) (物 は)) (俺 の)) 物)
    下边是scalar形变量的例子，可以把形容词后边的【の】翻译为【的】：
    - ($x の) => ($x 的) -- $x = お前
    - (($x の) $y) => (($x 的) $y) -- $x = お前, $y = 物は
    下边是list型变量的例子：
    - ((@adj) 物) => ((@adj) 东西) -- @adj可以捕获【((お前 の) (物 は))】和【(俺 の)】一共两个node

    比方说：こう言う時どんな顔すればいいのか分からないの。
    百度的翻译：这么说的时候，什么样的表情比较好懂的。

    给定语法树：(((こう 言う) 時) どんな) (顔 すれ ば いい の か)) (分から ない の 。))
    当前可以这样定义翻译规则的：

      顔                       => 脸（表情）
      ($vi すれ ば いい の か) => ($vi 才好呢)
      ($adv どんな)            => ($adv 什么样的)
      (分から ない の 。)      => (不 知道 的 。)
      ((こう 言う) 時)         => ((这样 说的) 时候)

    这些规则，会按照它们根节点孩子的数目排序。
    根节点的孩子最多的规则（也就是第二条）会先执行，最少的（也就是第一条）会最后执行。
    使用这些规则后，最终的翻译的结果是：

       这样说的时候什么样的脸（表情）才好呢不知道的。

10/13/2014 MON
  * Improve the support for 東北ずん子.
    VNR can directly play the TTS without launching zunko's program.
    I dissembled zunko into C# code and reimplemented the logic using C++.
    .NET and clipboard are not needed, and there is no blacklist of H-words.
    But currently, the pitch/speed/range of the voice cannot be adjusted like in zunko.

    改善了对「東北ずん子」的支持。VNR不需要启动她，就可以直接调用TTS了。
    这个功能不需要.NET，不需要剪贴板，也没有ずん子的H黑名单的问题。
    不过，当前还不支持调整ずん子的音调、语速和重音。

  * VNR's UI is flatter.
    改为扁平界面了。

10/11/2014 SAT
  * Add rUGP2 engine for new マブラヴ series games from アージュ.
    为アージュ社的新游戏添加了rUGP2的引擎。

10/9/2014 THU
  * Add support for all VOICEROID+ and VoiceText online TTS.
    You can select your favorite TTS in Preferences/Text-to-speech or per-game Voice Settings.
    But the online TTS is relatively slow comparing to the offline version.

    添加了对全部VOICEROID+和VoiceText的在线TTS的支持。
    在【使用偏好】或者【语音设定】中可以选择这些TTS。
    在线的版本比离线的版本要慢。

  * 修正了金山快译使用一段时间后可能会失效的问题。

10/8/2014 WED
  * Add a toggle in Preferences/Translation to convert Mandarin to Yue Chinese.
    添加了使用百度将国语字幕转换为粤语的选项。在【使用偏好/翻译】中可以开启。

  * Display game sizes on the Game Board.
    You can also search "GB" for large games >= 1GB, or "MB" for small game < 1GB.
    Game Board会显示游戏的大小。
    你也可以搜索“GB”来得到大于1GB的游戏，或者“MB”来得到小于1GB的游戏。

  * The texts modified by the Shared Dictionary are underlined by default now.
    This could help remove the redundant spaces for Chinese/Korean escape terms.
    If you don't like the underline, it can be disabled in Preferences/Shared Dictionary.
    VNR现在默认会下划线被共享辞书修改的文本。
    这样可以帮助删掉被替换文本两边的多余的空格。
    如果你不希望看到下划线，可以在【使用偏好/共享辞书】中禁用下划线。

10/7/2014 TUE
  * Fixed a severe regression that might crash VNR.
    I am very sorry for the inconvenience! m(_ _)m

    修正了一个可能会让VNR崩溃的问题。
    给大家带来不便，非常抱歉！m(_ _)m

  * Add Baidu TTS. The voice is the same as VW Misaki from Korea, except that
    the bitrate is lower than the offline version.
    添加了对百度TTS的支持。
    百度的日文TTS使用的是韩国的VoiceText Misaki。
    和离线版本比起来，百度TTS的bitrate更低，音质要差些。除此之外，没有区别。

  * Add Bing TTS.
    添加了对Bing TTS的支持。

  * The volume and speed for online TTS can be adjusted in Preferences.
    在使用偏好中可以调整在线TTS的速度和音量。

  * The pitch for SAPI TTS can be adjusted in Preferences.
    Higher pitch will make the voice to sound younger.
    在使用偏好中可以调整SAPI TTS的音调。
    音调变大时，声音听起来会更年轻些。

  * You can toggle "Speak -> Original" or "Speak -> Translation" on the left dock
    to select whether to read the original game texts or the subtitles.
    运行游戏后，点击左边的【朗读】=> 【翻译】，VNR会使用在线或离线TTS读出中文字幕。

  * Online TTS support for VNR's website reader has not been implemented yet.
    VNR内置的浏览器暂时不支持在线的TTS。

10/6/2014 MON
  * The online TTS implementation is switched from Apple QuickTime to native Windows Media Player (WMP).
    If you have a genuine Windows, WMP has already been installed.
    So, nothing is required to use the online TTS.

    The performance of the online TTS is improved.
    You can find the cached TTS audios in MP3 format in Caches/tmp/reader/tts.
    The new online TTS implementation is surprisingly very fast. Even as fast as offline TTS.
    And it works both with and without administrator privileges.
    I am going to add more online TTS and support for adjusting TTS volume and speed soon.

    在线TTS的音频改为使用Windows Media Player（WMP）来播放，而不再使用QuickTime。
    如果你在使用的是正版的Windows，那么WMP默认已经安装了的。

    另外改善了在线TTS的performance。
    在线TTS的音频会以MP3的格式保存在Caches/tmp/reader/tts。
    新的在线TTS的实现非常非常的快，甚至和离线的TTS一样快。
    并且在线TTS在管理员和非管理员权限下都可以正常使用的。
    我在之后会添加更多的在线TTS，和添加调整TTS语调和音量的设定。

10/4/2014 SAT
  * Fixed a cache inconsistency bug for the Shared Dictionary.

  * Add a new kind of syntax-based translation terms to the Shared Dictionary.
    It might help improve machine translation quality.
    Comparing to the old terms which work at Japanese-character level, the new terms can catch
    lexical or syntactical patterns.
    You can enable it in Preferences/Shared Dictionary.
    The new translation system requires MeCab, CaboCha, and UniDic to work.
    All of them are open-sourced libraries and can be downloaded for free in Preferences/Downloads.

    You can ignore the following text if you don't know any Japanese or have never used the
    Shared Dictionary before.

    There is a also a Japanese Syntax Tester for debugging the terms.
    But currently, the new syntax terms cannot be debugged in the Machine Translation Tester
    (I haven't got time to implemented the support in this tester yet).

    Currently, guest account is not allowed to create syntax terms.

    As none of the existing machine translators is open-sourced, we cannot have fine-control
    over the translation process, and the machine translation quality is always bound by
    the 3rd-party translator being used.
    Though there are Shared Dictionary and TAH scripts, but all of the existing rules
    are context-insensitive lexical-level text replacement, and their capabilities are quite limited.

    My ultimate goal is to a design new rule-based machine translator in VNR based only on
    the community-contributed translation rules in the Shared Dictionary.
    The other machine translators will become optional, and only serve as alternatives
    or dictionaries for looking up seldom used words.

    The current syntax-based translation system is still very primitive, though.
    I guess it might take at least half a year to get every thing done and have
    enough translation rules for daily Japanese sentences.

    If you have questions or suggestions, feel free to post them to the following topic.

        http://sakuradite.com/topic/471

    You can play with the new syntax terms, but please don't extensively add tons of rules
    at the moment. I am going to add more grammar to describe the syntax soon.

    Currently, my focus is on Japanese-Chinese translation.
    It might also work well for Japanese-Korean translation.
    But my current focus is NOT on Japanese-English translation.
    The current translation system does not address the challenges in English translation,
    such as how to deal with plurals/articles, which do not exist in Chinese/Japanese/Korean.
    I might come back to think about English and other languages after the Chinese/Korean
    translation support is mostly done.

    In the following text, I am going to discuss the new system and the future plan in my mind.

    I. Motivation

    Let's start with an example:

        白い髪の娘は白ちゃんです。

    If I want to translate, say, 【白】=>【Haku】using a Translation term, it will break 【白い】.
    This problem can be solved in the new translation system.

    In the new system, VNR will first construct a Syntax Parse Tree for the sentence,
    as follows:

        (((白い (髪 の)) (娘 は)) (白 ちゃん です 。))

    There are 9 leaves in total: 白い, 髪, の, 娘, は, 白, ちゃん, です, and 。.
    These nodes are separated by either " " (space) or "()" (parentheses).
    The content in-out of the parentheses are parent-child.
    The content next to each other are sibling nodes.
    For instance: (白い (髪 の)) is the parent of(髪 の), and the grand-parent of【髪】.
    And 【髪】 and 【の】are siblings.

    Additionally, I also have the types of each node, such as if the node is a noun, name, verb, etc.
    The current VNR does not support matching the types of the nodes, though.
    Going to add this support soon.

    After the syntax parse tree is constructed, VNR will use the syntax terms from the community
    to translate the tree.
    The pattern of the term will be used to match any subtree in the Syntax Tree.
    If matched, the node will be replaced by the subtree created from the replacement text.
    You can debug this process in the "Japanese Syntax Tester" widget.

    For example, 【白】 will match 白 which used independently, but will not match 白い.
    And【髪 の】won't match【白髪 の】, because,【白髪】will be a single node.

    Additionally, nested parentheses can be used to express trees whose height > 1,
    such as 【(白い (髪 の))】.

    Besides, just one to mention that a list with/without parentheses are different.
    【白髪 の】and【(白髪 の)】 are different.

    For example, giving the following two syntax trees:

        (((((こう 言う) 時) どんな) (顔 すれ ば いい の か)) (分から ない の))
        (((((こう 言う) 時) どんな) (顔 すれ ば いい の か)) (分から ない の です か))

    【分から ない の】(without parentheses) will match the nodes in both of the sentences.
    But 【(分から ない の)】(with parentheses) will only match the first sentence.

    II. Translation workflow

    If you know Compiler, the translation process is quite similar to compiling one language to another:

                              front-end                              mid-end                          back-end
        Japanese sentence    =>  token stream  => Japanese parse tree => Chinese parse tree => token stream => Chinese sentence
                   (lexical tokenizer)     (syntax parser)          (translator)          (unparser)      (join)

    Below is the the actual translation workflow in VNR:

                             front-end                              mid-end              back-end
        Japanese sentence   => word stream    => Japanese parse tree => Chinese parse tree => Chinese sentence
                  (MeCab+CaboCha+UniDic)  (VNR syntax parser)    (VNR translator)    (VNR unparser)

    Current, our shared syntax translation rules are applied at mid-end (VNR translator).
    Later, I am going to add syntax support for Input/Output terms as well, which will be applied
    to front-end parser and back-end unparser respectively.

    After the translation, if VNR has found there are untranslated nodes, VNR will use the
    existing machine translator you have selected, such as Google, to translate the left
    untranslated subtrees.

    The order to apply the syntax rules and the other existing types of the terms are as follows:

        Apply input term => Apply general translation term => (Apply syntax translation terms) => Apply machine translation => Apply output terms

    It is done like this which is easier to implement. But it does not make sense.
    I am going to change the order to the following one soon.

        Apply input term => (Apply syntax translation terms) => Apply general translation term => Apply machine translation => Apply output terms

    III. Future work
    The current grammar for the pattern still cannot describe all Japanese syntax.
    I am planning to add the following grammars one by one.

    Capture variables. Below is a Japanese-Chinese example (I don't know how to express this in a single English word):
       ($x の) => ($x 的)  -- $x represents a single node
       ($x $y の) => ($x $y 的)  -- $x and $y represent two different nodes
       (@x の) => (@x 的)  -- @x represents a list of sibling nodes, similar to @array in Perl
    You might know that Japanese is an Agglutinative language.
    The above rules can be used to express the trailing の in Japanese adjectives.

    Types of the words. Japanese-Chinese Example:
       ($x:noun:name の) => ($x 的) -- here, :noun:name means $x must be either a noun or a name
       ($x:verb で) => (通过 $x:verb) -- :verb means $x must be a verb.

    Express optional nodes. Example:
        ($x? の) => ($x 的)  -- "?" means $x can be optional
        (分から ない の? です?  。?) -- の? and です? can be optional

    Integrate regular expressions. Example:
        (/[わ分]から/ ない の) -- the text within // is a regular expression
        (/[わ分]から/:v ない の) -- the ":v" means the regular expression must be a verb
        ($x=/[わ分]から/:v ない の) -- capture the regular expression using $x

    Use quotes to escape special characters
        $x="English word with space" -- the quotes here is used to escape " " (space)

    Currently, we cannot directly modify the generated parse tree from CaboCha.
    I am going to add a new MeCab typed terms that will be compiled into MeCab user-defined dictionary.
    The term will have a weight parameter used to express the expected frequency of the word.
    This might be a way to combine the syntax-based MT with the statistical MT.

    If you have other suggestions, for instance, if a Japanese syntax cannot be expressed
    under the current system, feel free to suggest to me.

    添加了一个新的基于语法的日文翻译体系开改进日文翻译的质量。
    可以在【使用偏好/共享辞书】中开启。
    打开这个选项会需要在【使用偏好/下载】中安装MeCab、CaboCha和UniDic。

    你可以忽略下边如果你从来没有使用过共享辞书。

    我在共享辞书中添加了新的【语法】的选项。
    当前，只有翻译词条可以开启这个选项。其他类型的词条我还没有实现。
    开启了【语法】的词条和以往的词条截然不同。
    以往的词条都不过是简单的文本替换。而语法词条可以识别和描述日文的文法。

    新添加的【语法】词条可以使用新添加的【测试日文文法】的widget来debug。
    【测试机器翻译】的widget暂时不能够debug语法词条。

    Guest用户暂时不可以提交语法词条。

    我的最终的目标，是希望可以最终实现VNR自己的基于community的日文翻译系统，
    而不再依赖第三方的J北京之类的翻译器。
    不过当前的实现还是原始。另外，有很多我想做的东西还没有来的及实现。
    如果你有需要或者建议，比方说，你想要实现的逻辑在当前的体系中不支持，
    那么可以下边的topic里留言。

        http://sakuradite.com/topic/471

    You can play with the new syntax terms, 但是请暂时不要大量添加这个类型的词条。
    我在以后马上会添加更多的语法的。

    I. Motivation

    还是举个例子吧。

        白い髪の娘は白ちゃんです。

    彼方说，如果简单的定义【白】=>【白】的人物词条, 那么会破坏掉【白い】。
    这个问题在新的翻译模式下就可以解决了的。

    在新的翻译模式下，VNR会先利用UniDic创建一棵Syntax Parse Tree，如下：

        (((白い (髪 の)) (娘 は)) (白 ちゃん です 。))

    上边的树有9个leaves，分别是：白い、髪、の、娘、は、白、ちゃん、です、"。"
    这些节点是靠空格或者括号分割的。
    然后呢，括号内外表示父子关系，相邻的括号或者节点表示sibling的关系。
    比方说：【(白い (髪 の))】是【(髪 の)】的爸爸，是【髪】的爷爷。
    而【髪】和【の】互为兄弟。

    除此之外，我可以知道所有节点的词性，比如名词、动词、名字，拟声词等。
    不过当前版本的VNR的匹配文本的语法还不支持描述词性。

    在建好树后，VNR用会大家提交的词条的【匹配的文本】来匹配这课语法树中的subtree。
    当匹配时，VNR会用【替换的文本】来创建一个新的subtree，并替换掉原来的。
    你可以在【测试日文语法】的widget中来尝试。

    比方说：【白】只会匹配到【白】单独使用的情况，而不会匹配到【白い】。
    而【髪 の】不会匹配到【白髪 の】，因为【白髪】是一个完整的词。

    除此之外，比方说，还可以用【(白い (髪 の))】来匹配parse tree内部中间的一个
    高度=2的subtree。

    另外要说明的是，【白髪 の】和【(白髪 の)】这里加不加括号是不同的。
    比方说，给定下边的两棵syntax tree：

        (((((こう 言う) 時) どんな) (顔 すれ ば いい の か)) (分から ない の))
        (((((こう 言う) 時) どんな) (顔 すれ ば いい の か)) (分から ない の です か))

    那么【分から ない の】（没有括号）这两句话都可以匹配到。
    而【(分から ない の)】（有括号）只会匹配到第一句，而匹配不到第二句。

    II. 翻译的workflow

    如果你有学过编译原理，那么不妨把翻译的过程想象成compiler编译语言的过程。

                          front-end                              mid-end                          back-end
    Japanese sentence    =>  token stream  => Japanese parse tree => Chinese parse tree =>  stream => Chinese sentence
               (lexical tokenizer)     (syntax parser)          (translator)          (unparser)      (join)

    VNR实际的翻译过程如下：

                         front-end                              mid-end              back-end
    Japanese sentence   => word stream    => Japanese parse tree => Chinese parse tree => Chinese sentence
              (MeCab+CaboCha+UniDic)  (VNR syntax parser)    (VNR translator)    (VNR unparser)

    当前，大家定义的规则是作用在mid-end的VNR translator的步骤上的。
    我在之后，会为Input、Ouput的词条也添加语法的选项。
    添加后，它们会分别作用在front-end和back-end的parser和unparser上。

    当翻译后，VNR发现有部分节点没有被大家的词条翻译到，那么VNR会改用用户选择的其他翻译器，
    比方说百度或者金山快译，来翻译剩余的节点。

    当前语法词条和其他非语法词条作用的顺序如下：

        应用输入词条 => 应用一般翻译词条 => (应用语法翻译词条) => 进行机器翻译 => 应用输出词条

    这样子做主要是因为好实现，但是并不make sense。我在以后会把顺序改成下边这样：

        应用输入词条 => (应用语法翻译词条) => 应用一般翻译词条 => 进行机器翻译 => 应用输出词条

    III. Future work
    当前的匹配文本的语法还远远不能表达很多很多的日文文法。
    我在之后会逐渐添加下边的语法，希望最终可以利用这个翻译体系来描述绝大部分日文的文法。
    下边是一些例子。

    capture变量，比如：
       ($x の) => ($x 的)  -- 这里$x代表单个节点。
       ($x $y の) => ($x $y 的)  -- 这里$x和$y代表两个节点。
       (@x の) => (@x 的)  -- 这里@x代表a list of节点，参考Perl中的array
    你可能知道，日语是粘滞语言(Agglutinative language)。
    上边的逻辑表示仅仅用于修饰语后边的【的】（仅仅出现在形容词词组的最右边）。

    表达词性，比如：
       ($x:noun:name の) => ($x 的) -- 这里:noun:name表示$x必需是名词或者名字。
       ($x:verb で) => (通过 $x:verb) -- 这里:verb表示$x必需是动名词。

    表达可选，比如：
        ($x? の) => ($x 的)  -- 这里?代表单$x可以为空
        (分から ない の? です?  。?) -- 这里的【の?】【です?】这些节点可以是空。

    结合正则表达式，比如：
        (/[わ分]から/ ない の) -- 这里的//表示中间的是正则表达式，参考Perl和JavaScript的语法
        (/[わ分]から/:v ない の) -- 这里的//表示中间的是正则表达式，并且是个动词
        ($x=/[わ分]から/:v ない の) -- 这里将正则表达式用$x的变量来capture

    用引号来转义特殊的字符，比如：
        $x="English word with space" -- 这里用引号来避免VNR把空格当成节点的分隔符。

    另外，现在还不能直接修改搭建的parse tree。我打算在以后再添加一个MeCab的类型的词条，用来编译成MeCab的词典来控制parse tree的生成。
    MeCab的词条会需要一个权重（即单词频度）的参数，这样就可以把syntax-based MT和statistical MT结合在一起了。

    如果你有其他的建议，或者觉得这样定义语法并不方便，或者还是有很多逻辑无法表达，可以让我知道的。

10/2/2014 THU
  * 更新了djz大先生的J北京辞书到141001的版本。
    你可以通过下边的qq向djz大先生表示感谢，或者询问关于J北京问题。

        330102505@qq.com

  * Reduce VNR's memory usage by 70MB by adding __slots__ to Python classes.
    减少了VNR的内存使用量。

9/30/2014 TUE
  * The types of the terms in the Shared Dictionary are slightly changed.
    You can ignore the following text if you have never used it before.

    + For Chinese and Korean
      Nothing has been changed except the names of the term types, as follows:
      - Translation: the same as "Escape"   -- the translation will be escaped before/after the machine translation.
      - Input: the same as "Japanese"       -- used to repair the Japanese text before applying machine translation
      - Output: the same as "Translation"   -- used to repair the Chinese/Korean text after applying machine translation
      - Name: the same as "Chara"           -- Japanese names, such as 「釘宮」
      - Suffix: the same as "Title"         -- the titles after Japanese names, such as 「ちゃん」
      - Game: the same as "Original text"   -- used to repair the text extracted from the game
      - TTS: not changed                    -- used to repair the text before applying TTS
      - OCR: not changed                    -- used to repair the text after applying OCR
      - Macro: not changed                  -- reusable regular expression patterns

    + For any other languages including English
      1. The "escape" type is removed
      2. A new "translation" type is added, which is the same as the old "Japanese" terms
      3. The names of the terms are changed, as follows:

      - Translation: the same as "Japanese" -- the same as the old "Japanese" type, different from Chinese/Korean

      - Input: the same as "Japanese"       -- (the same as Chinese/Korean)
      - Output: the same as "Translation"   -- (the same as Chinese/Korean)
      - Name: the same as "Chara"           -- (the same as Chinese/Korean)
      - Suffix: the same as "Title"         -- (the same as Chinese/Korean)
      - Game: the same as "Original text"   -- (the same as Chinese/Korean)
      - TTS: not changed                    -- (the same as Chinese/Korean)
      - OCR: not changed                    -- (the same as Chinese/Korean)
      - Macro: not changed                  -- (the same as Chinese/Korean)

      The "Translation" terms should be used to translate Japanese to English or any other Latin languages.
      The "Input" terms should be used to translate Japanese to Japanese.

      Currently, the "Translation" and the "Input" terms are handled the same way for Latin languages,
      both of which are equivalent to the old "Japanese" terms.
      But they will be handled differently soon in the future version of VNR.

      If you would like to add new rules to the Shared Dictionary, I hope if you could distinguish
      "Translation" and "Input" types. For example:
      - to transform "あたし" to "I", "Translation" should be used
      - to transform "あたし" to "私", "Input" should be used

      Let's wait for two weeks until most people have updated to this version of VNR.
      And then I am going to revise the Shared Dictionary to distinguish Translation from Input type
      for old terms in Latin languages.

    主要是变更了处理中文和韩文以外语言的共享辞书词条的方法。
    对中文，只是词条类型的名字改变了，如下。除此之外，词条的功能上没有被任何变化。

      - 翻译: 即以前的【转义】词条 -- 通过转义来将日文翻译为中文
      - 输入: 即以前的【日文】词条 -- 在翻译前，修正输入的日文文字
      - 输出: 即以前的【翻译】词条 -- 在翻译后，修正输出的中文文字
      - 名字: 即以前的【人物】词条 -- 日本人的名字，比如「釘宮」
      - 后缀: 即以前的【称谓】词条 -- 跟在名字后边的称谓，比如「ちゃん」
      - 游戏: 即以前的【原文】词条 -- 在翻译前首先修正从游戏中提取出的文字
      - 语音合成: 和以前一样       -- 在TTS前修正输入的文字
      - 光学识别: 和以前一样       -- 在OCR后修正输出的文字
      - 宏: 和以前一样             -- 可以重用的正则表达式

9/28/2014 SUN
  * Fixed a severe bug that OCR might stop working when the inserting space option is enabled.
    Sorry for the issue!
    修正了插入空格打开时，OCR无法使用的问题。
    带来不便很抱歉！

9/27/2014 SAT
  * Modify the ScenarioPlayer engine to support new すたじお緑茶 games.
    修正了本月「南十字星恋歌」的游戏引擎。

  * Fix the ApRicoT engine to support イセカイ・ラヴァーズ this month.
    修正了本月「イセカイ・ラヴァーズ」的游戏引擎。

9/26/2014 FRI
  * The text processing using the Shared Dictionary is reimplemented using C++ with Boost.Regex.
    It is more powerful, much faster (time < 0.01 second) and using less memory (about 20MB for 20k rules).
    If you have never used the Shared Dictionary before, you can ignore the following text.

    The major changes about the Shared Dictionary are as follows:

    + VNR no longer processes the Shared Dictionary on the startup any more.

    + VNR won't process the Shared Dictionary until the first time you use it, such as
      when a sentence is translated, or when TTS is triggered.
      The bad thing is, for example, that the first machine translated subtitle will not
      use the Shared Dictionary, and the translation quality might be bad.
      But after that, the follow-up translations will be processed by the Shared Dictionary.

    + After the first time the Shared Dictionary is used, you can find the enabled text replacement
      rules in the following directory:

          Caches/tmp/reader/dict

      VNR will rebuild the cache there whenever the Shared Dictionary is modified, or the current
      game is changed, or your language is changed.
      You can also open that directory by pressing the "Browse" tool button in the Shared Dictionary.

    + The regex library used in the Shared Dictionary is changed from Python.re to Boost.Regex.
      Boost's implementation is a superset of Python's and is more powerful, which supports
      recursive syntax. More details about Boost.Regex's syntax could be found in the following pages.

        http://www.boost.org/doc/libs/1_56_0/libs/regex/doc/html/boost_regex/syntax.html
        http://www.boost.org/doc/libs/1_56_0/libs/regex/doc/html/boost_regex/syntax/perl_syntax.html

      I haven't explored all available features in boost.regex yet.
      But here are some usage examples of the recursive syntax "(?+-N", which might be interesting:

      - Multiple replacement. For example:

          薫(?:(ちゃん)|(さん)|(くん)) => Kaoru-(?1chan)(?2san)(?3kun)

        The above rule could translate "薫ちゃん" to Kaoru-chan, "薫さん" to Kaoru-san, and
        "薫くん" to Kaoru-kun at the same time.

      - Conditionals. For example:

          薫(ちゃん) => Kaoru-(?1chan:san)

        The above rule will translate "薫ちゃん" to "Kaoru-chan", and "薫 otherwise" to "Kaoru-san otherwise"

     + Boost is intentionally not compiled with ICU so that regex is not aware of unicode characters.
       For instance:
       - "\s" will match ascii spaces, but won't match \u3000.
       - :digit: only matches ascii [0-9], and won't match "一", "二", "三", etc.

    共享辞书处理文本改为用C++来实现。正则表达式从Python.re改为Boost.Regex。
    处理辞书花费的时间和内存都比以前要小很多了。
    如果你并没有使用过共享辞书，那么忽略下边的文字吧。

    + VNR会将当前开启的规则保存到下边，也许可以帮助大家编辑和了解辞书。

        Caches/tmp/reader/dict

      点击共享辞书上边的【浏览】按钮也可以打开这个文件夹的。
      每当共享辞书被编辑，游戏改变，或者你的语言改变，VNR都重新生成上边的Caches。

    + VNR在启动后，默认不再处理辞书。直到辞书第一次使用后（比方说处理机器翻译或者TTS），
      才会去生成上边的Caches。生成Caches大概会花费不到1秒钟。

    + Boost.Regex比Python.re要支持更多的正则表达式语法（主要是增加了递归语法）。
      具体的可以参看下边的文献。

        http://www.boost.org/doc/libs/1_56_0/libs/regex/doc/html/boost_regex/syntax.html
        http://www.boost.org/doc/libs/1_56_0/libs/regex/doc/html/boost_regex/syntax/perl_syntax.html

9/23/2014 TUE
  * Dictionary lookup was moved to threads.
    When "Popup when hover" is enabled, it won't block GUI any more.
    即时【翻译鼠标下边的文本】不会卡GUI了。

9/22/2014 MON
  * Disable the keeping spaces option in Text Settings for Japanese/Chinese games.
    It does not make sense to keep spaces for these languages.

    如果游戏语言是日文或中文，VNR会禁止文本设定中【保存单词空格】的选项。
    这样做没有道理。

9/21/2014 SUN
  * Bypass the issue for embedding Chinese translations where Kanji becomes "?".
    内嵌正体中文翻译到游戏可以正常显示了。

    但是简体中文仍然无法正常显示。VNR会自动将简体中文转换为正体中文来绕过这个问题。
    下边是内嵌对话和选项的中文翻译到BGI引擎的截图：

        http://sakuradite.com/images/screenshots/sekai_bgi2_zh.jpg
        http://sakuradite.com/images/screenshots/sekai_bgi2_choice_zh.jpg

    不过目前，只有非常少的几个引擎支持内嵌翻译，绝大部分游戏都不支持。
    感谢青龙sama的报告！

9/20/2014 SAT
  * Fix a bug that might crash the Elf engine on Windows XP.
    Thanks for @goodboyye sama's report!
    修正了Elf引擎在Windows XP上可能会崩溃的问题。
    带来不便很抱歉！

  * SAPI TTS is moved to a different thread so that it won't block GUI.

9/18/2014 THU
  * The mouse hotkey to select OCR region can be changed in Preferences (default is SHIFT).
    在使用偏好中可以变更选定OCR区域的快捷键（之前默认是SHIFT）。

  * Bugfix for the hue calculation in OCR filter.
    修正了对OCR中色度过滤的计算方法。

  * Add support for Kingsoft FastAIT that is a free Chinese offline translator.
    You can use it to re-translate Chinese-translated VNs to English if you want.
    It can be downloaded here for free:

        http://ky.iciba.com  (534MB after installation)

    It does not contain any nasty ads like Baidu products. So, feel free to use.

    添加了对金山快译的支持。
    这个程式是免费的，可以提供离线的日中、英中翻译。可以从上边链接的地方下载到。

    我个人非常建议你来尝试下这个翻译器，作为百度或J北京的补充。
    下边是我个人感觉和百度、J北京比起来的一些优缺点。

    + 优点
      - 这个程式是免费的。
      - 倾向直接翻译，不打乱语序，translate as it is。我很喜欢这一点了。一些例子在下边。
        这样也许会对学习日语的同学做日中的对比更有些帮助吧。
      - 和J北京一样，VNR支持金山快译的用户定义的辞书。
      - 本身支持正体中文，不像百度，还需要VNR做简繁转换。
      - 支持离线的中英翻译，但是个人感觉中英翻译质量不如Dr.eye。
        比如，金山快译总是把「you」翻译成「您」orz。

    + 缺点
      - 慢。
        比北京慢。尤其当有些不常用的词语查找词条失败时（怀疑），可能会需要两三秒才翻译好。

        另外，金山快译自带一系列专业辞书（比如计算机、健康、金融），但是当都加载后，会导致翻译时间x2到3倍。
        *** VNR暂时禁用了全部专业辞书。***
        我个人没发现这些辞书对翻译galgame有什么帮助，开启or not，翻译都一样。
        如果你觉得哪个辞书还是打开好，可以让我知道。

        关于翻译的速度，金山快译支持多线程，但是实现起来比较tricky（DLL中的函数不是reentrant的，访问需要独立的key）。
        我想在以后有时间，再来用多线程来解决翻译个别句子突然变得很慢的问题。

    下边是对「レミニセンス」中一些对话翻译的比较：

        日文：最悪の事態が起こる前に助け出せたようだ。
        人工：看起来，在最糟糕的事情发生前被救下了。
        百度：最糟糕的事態發生之前，助け出せ。
        北京：好像在發生最壞的事態之前能救出了。
        快译：發生最壞的局勢前幫助能拿出各式各樣。

        日文：と、足音が聞こえた。
        人工：…那样的脚步声传来。
        百度：和，腳步聲。            -- 「聞こえた」被删掉了
        北京：腳步聲聽得見了。
        快译：和，聽得見了腳步聲。

        日文：「そこの女は、こっちのなんだが、何か迷惑をかけたか？」
        人工：「那个女人是我的，给你们添麻烦了吗？」
        百度：「那裏的女人，這邊的什麽，不過，什麽添麻煩了嗎？」
        北京：「那裡的女人，是這邊的,不過，是什麼是不是添了麻煩？」
        快译：「那裏的女人，這邊的是什麼，但是給您增添什麼麻煩了嗎？」

        日文： そんな声が届く。
        人工： 那样的声音传过来。
        百度： 那樣的聲響。           -- 动词「届く」被删掉了
        北京： 那樣的聲音傳達。
        快译： 那樣的聲音送往。

        日文：「その人を連れて逃げる準備をしてくれ……」
        人工：「快准备好带着那个人一起逃走……」
        百度：「那個帶人逃跑的準備……」 -- 宾语「準備」的谓语「してくれ」被删掉了
        北京：「帶那個人準備……逃跑」   -- 从句顺序被打乱了
        快译：「做帶那個人逃的準備……」 -- exact原始的逻辑，虽然有些拗口

    总的感觉吧，百度更倾向于润色翻译，但是从而导致一些日文单词直接被删掉。
    J北京则很少删词，但是有时会根据上下文替换单词的含义，或者改变词组或从句的顺序。

    而金山快译则倾向于直译，使用日文本来的含义，保留本来的词语顺序。
    这样也许在中文翻译和日文之间更容易建立一对一的关系吧。

9/16/2014 TUE
  * Add a new Macro type to the Shared Dictionary.
    You can ignore the following text if you don't know Japanese.

    Macro terms will be used to replace regular expression patterns.
    For example, I defined the following macro to express the beginning of a sentence.

      bos => (?:^|(?<=[「。？]))

    Then, you can use it like this to capture "あなた" at the beginning of a sentence:

        {{bos}}あなた

    The text within {{}} will be replaced by macros. This only applies to regex patterns.

    btw., we can filter certain types of the terms in the Shared Dictionary.
    If we search "Macro", all macro terms will show up.

    You can name the macro in whatever way you like.
    But let's make some conventions so that it is easier to understand each other's macros.
    For example, I want to define some macros to match all 平仮名, and I did it this way:

        :hira: => あ-ん        -- use a pair of ":" to represent a character set, just like :digit: in regex.
        hira => [{{:hira:}}]   -- express positive predicate by default
        !hira => [^{{:hira:}}] -- use leading "!" to represent negative predicate

    You can also name the macro as, say, KiriKiriRemoveRepeat, or kiri_remove_repeat, etc.
    If you need intermediate tmp macros, you might give it a name starting with "_".

    在共享辞书中添加了宏类型词条。
    如果你不懂日文，那么可以忽略下边的文字的。

    比方说，下边会定义一个叫bos的宏来代表句子的开始：

      bos => (?:^|(?<=[「。？]))

    随后，你就可以使用下边的规则来匹配仅仅出现在句子开始的「あなた」。

        {{bos}}あなた

    在{{}}中间的文字会被定义的宏替换掉。这个仅对正则表达式的匹配文本有效。

    btw, 共享辞书是可以检索词条类别的。
    比方说，搜索【宏】，会显示全部宏类型的词条。搜索【人物】，会显示全部姓名词条。

    你也可以用中文或者任意的符号来定义宏的名字的。
    但是，大家还是约定下命名的convention，让其他同学可以更加容易理解macro的含义。
    比方说，我要定义一些匹配平仮名的宏，我是这样命名的：

        :hira: => あ-ん        -- 用一对":"来代表字符集，这和正则表达中的:digit:之类的是类似的
        hira => [{{:hira:}}]   -- 默认使用肯定语气的逻辑
        !hira => [^{{:hira:}}] -- 用!来表达否定语气的逻辑

    大家也可以将宏命名为，比方说：KiriKiriRemoveRepeat, or kirikiri_remove_repeat
    如果需要定义一些临时的变量，最好使用_（下划线）来作为宏名称的开头。

9/15/2014 MON

  由于众所周之的原因，VNR在沦陷区不可以使用google翻译了。我会想办法修正这个问题的。

  * OCR operations are moved to threads so that the GUI won't get blocked while analyzing images.
    修正了OCR时可能会卡屏的问题。

9/14/2014 SUN
  * When the underline option in Shared Dictionary is enabled, character names defined by Chara terms
    for Kanji-based languages (Chinese, Korean, etc.) will also be underlined.
    Due to technical difficulties, character names of Latin-based languages such as English will not be underlined.

    当共享辞书中的下划线选项开启后，中文和韩文的人物词条的翻译也会显示下划线。

  * Add global keyboard shortcuts for taking snapshot as request.
    添加了为游戏窗口截图的快捷键 as request。

  * Add more image filters for OCR, mainly filters for HSI color model.
    - Usually, if the font color is always white/black, the "I" (intensity) filter might be sufficient.
    - Otherwise, if the font is in a single color, the "H" (hue) might help.
    - The worse case, if the font color usually changes, but always in a pure color, the "S" (saturation) might help.

      You can find the formulation of these terminologies here:

        https://en.wikipedia.org/wiki/HSL_and_HSV#Lightness

    - Additionally, if the game text is extremely large/small, then the "Z" (zoom) filter could be used.

    为OCR提取文本添加了更多的过滤器。
    - 通常情况下，如果文字是白色或者黑色的，那么亮度过滤器就足够了。
    - 否则，如果文字总是其他的某个颜色，那么，色度过滤器也许可以帮上忙。
    - 最差的情况，如果文字的颜色经常变化，但是总是纯净的，那么，也许可以尝试饱和度过滤器。
    - 此外，如果文字的字体非常大或者非常小，那么可以使用缩放过滤器。

9/13/2014 SAT
  * Add an option to underline the modified text by escape or translation terms in the Shared Dictionary.
    The changes that made by Japanese terms are not marked, which might sacrifice the translation quality
    in order to implement the marks.
    You don't have to bother this unless you are actively editing the Shared Dictionary.

    在共享辞书中，添加了选项可以下划线被转义或翻译词条修改了的文字。
    日文词条还不可以被下划线，因为如果实现这个功能，将可能以降低机翻质量为代价。
    如果你不常编辑共享辞书，那么并不需要打开这个选项。

  * Fix a bug existing for a long time that the subtitles are sometimes displayed below the game window.
    修正了字幕有时候会跑到游戏窗口的下边去的bug。

  * Add a Desktop button to the game OCR dock.
    By default, VNR will only capture images in the game window for OCR.
    However, certain images might not be captured this way, such as MPEG videos.
    When that happen, you can toggle the Desktop button so that VNR will capture
    the entire visible desktop to make sure the images are visible.

    btw, when the "Desktop" button is enabled, the OCR region can also track other
    windows outside of the game, such as anime subtitles in video players.
    Here's a screenshot of the captured subtitles on Youtube:

        http://i859.photobucket.com/albums/ab155/jichi/youtube_zpscd6bf9cb.png

    However, currently, one game has to be launched in VNR in order to capture
    the video players, which is very inconvenient.
    I am going to create an independent app for OCR videos in the future.

    在OCR的按钮中添加了【桌面】按钮。
    VNR默认只会从游戏窗口截图，这样可能会无法从，比如，MPEG的动画中截图。
    打开【桌面】后，VNR会转而从桌面的截图中提取文本。

    btw, 当这个选项开启后，VNR其实就可以，彼方说，通过OCR提取动画中的字幕了。
    下边是从Youtube的动画中提取字幕的截图：

        http://i859.photobucket.com/albums/ab155/jichi/youtube_zpscd6bf9cb.png

    不过，VNR当前需要先启动任何一个游戏，才可以从屏幕任何地方截图。这样很不方便。
    我在以后会把这部分功能从VNR中分离出来，OCR时就不需要打开游戏了。

9/12/2014 FRI
  * Able to select OCR regions where VNR will periodically capture the image and extracing text in them.
    I hope if this could serve as an alternative text extractor when the game does have supported game engines.

    A screenshot is as follows:

      http://i859.photobucket.com/albums/ab155/jichi/ocr-region_zps009469c1.png

    (Note that 「剣の街の異邦人」 does have an EXP game engine, and it does not need OCR to work.)

    As you know, by default, you can Shift+Mouse to select one region for instant machine translation.
    After launching the game, there is a new OCR button on the left dock which contains two sub buttons.
    - Edit: The new Shift+Mouse region will become persistent.
    - Monitor: Monitor the persistent regions and periodically extract texts in them.
    The interval of the capturing can be adjusted in Preferences/OCR.

    The region can be both resized and moved.
    There are current three buttons on the top-left of the persistent regions:
    - × : Permanently destroy the region.
    - ◯ : Temporarily enable/disable the region.
    - ⌘ : Edit the image filtering option for the region.

    Comparing to ITH, the texts from OCR are slower and more unreliable.
    It is still better to stick to ITH if it works.

    The subtitles and danmaku are temporarily disabled for OCR texts as they are unreliable.
    I will turn them on after I finish implementing all the image filters for OCR.

    It also works for full-screen games, but context menu will be disabled as usual.

    Currently, this feature cannot be enabled unless a game is launched.
    I will move this feature out of VNR into a standalone application in the future.

    添加了通过OCR来从选定的区域连续提取文本的功能。
    如果VNR不支持从某个游戏的内存提取文本，那么，OCR也许可以作为暂时的提取文本的方法。
    下边是一张截图：

      http://i859.photobucket.com/albums/ab155/jichi/ocr-region_zps009469c1.png

   （注：「剣の街の異邦人」已有EXP的游戏引擎，并不需要OCR来提取文本。）

    打开游戏后，这个功能可以在左边的OCR按钮中开启。
    在OCR按钮中包含有两个子按钮：
    - 编辑：开启后可以用Shift+鼠标来选定OCR的区域。
    - 有效：开启后，VNR会不断的从选定的区域提取文字。提取的时间间隔可以在使用偏好中调整。

    由于OCR会占用很多CPU，并且提取的文本并不准确，所以如果VNR的文本设定可以工作，
    还是不建议使用OCR提取文本。

    OCR可以在游戏全屏时使用，但是和往常一样右键菜单会被禁用（因为包含的focus会导致游戏退出全屏）。

    由于从OCR提取的文本经常包含错误，暂时对OCR禁止了字幕和弹幕的机能。

    当前，开启这个功能需要先用VNR打开游戏。我在以后会将这个功能从VNR和游戏中分离出来的。

9/10/2014 WED
  * Update the TAH script for LEC from @errzotl sensei.

  * 更新了djz大先生的J北京辞书。
    你可以通过下边的qq向djz大先生表示感谢，或者询问关于J北京问题。

        330102505@qq.com

9/9/2014 TUE
  * I made a wiki as follows for what to do if you cannot find correct text in the game.

        http://sakuradite.com/wiki/en/VNR/Game_Settings

    The above link can also be found in Text Settings.
    Sometimes, the game settings has to be adjusted in order to work with VNR,
    such as changing Text Speed to fastest or changing Text Font to MS Gothic.
    You can find these game-specific information on that page.

    创建了一个wiki来总结下哪些会社的游戏需要调整文本速度到最快，哪些游戏需要设置字体为MS Gothic，
    在找不到正确的文本时该怎么做什么的。

        http://sakuradite.com/wiki/zh/VNR/Game_Settings

    这个链接也可以在文本设定中找到。

9/8/2014 MON
  * Add TAH script for LEC online/offline Japanese-English translation.
    The script is from @errzotl sensei, and you can say thanks to him/her at TAHscript@outlook.com.

  * Add EXP engine for 剣の街の異邦人 released last month.
    为八月的「剣の街の異邦人」添加了引擎。

  * Add an option to select the range of the color intensity to identify the target text.
    This might help eliminate irregular colorful background behind the target text.
    A screenshot is as follows.
    Windows native UI widgets (buttons, text editors, etc.) are not used so that it could work with
    full screen games.

      http://i859.photobucket.com/albums/ab155/jichi/VNROCRColorIntensity_zps48f059b6.png

    Let's say, if the selected range is from 30% to 70%.
    Then, only the pixel whose color satisfy the following logic will be identified as "text".

      function isTextColor(color) {
        var intensity = sqrt(color.red*color.red + color.green*color.green + color.blue*color.blue);
        var min = 0.3 * 255 * sqrt(3);
        var max = 0.7 * 255 * sqrt(3);
        return min <= intensity && intensity <= max;
      }

    The OCR support is still under construction.
    I am going to create a help page on the wiki regarding how to use OCR in VNR later after I
    finish implementing all the OCR features in my mind.

    添加了选择OCR文本颜色强度的功能。
    这样也许可以帮助过滤掉游戏中不规则的背景颜色。
    下边是张截图。

      http://i859.photobucket.com/albums/ab155/jichi/VNROCRColorIntensity_zps48f059b6.png

9/7/2014 SUN
  * Make sure OCR works for Direct X and full screen games.
    修正了OCR在游戏全屏后或者有些游戏启动后失效的问题。

9/6/2014 SAT
  * OCR text boxes will follow the position of the first-clicked window.
    OCR的文本框会跟随第一次点击的窗口而移动。

  * Add multi-language support for OCR.
    Some screenshots are shown below.
    It will take 61MB after installation.
    If you already have MODI OCR installed from the old VNR, please RE-DOWNLOAD
    MOD OCR from VNR's mega repo, then check Readme.txt for how to update.
    Sorry for the inconvenience!

      Japanese: http://sakuradite.com/images/screenshots/ocr_wiki_ja.png
      English:  http://sakuradite.com/images/screenshots/ocr_wiki_en.png
      Korean:   http://sakuradite.com/images/screenshots/ocr_wiki_ko.png
      Russian:  http://sakuradite.com/images/screenshots/ocr_wiki_ru.png
      Chinese:  http://sakuradite.com/images/screenshots/ocr_wiki_zh.png

    OCR可以支持多语言了。在上边的是一些语言和机器翻译的截图。
    安装完成后，新版的OCR会占用61MB的硬盘空间。
    如果你已经安装了VNR老版的MODI OCR程式，请重新在Mega下载新版的OCR。
    你可以在Readme.txt中找到升级的方法。带来不便很抱歉！

    Since there are currently so many languages in VNR, some of the languages
    supported by MODI are not enabled in VNR.
    If you need support certain languages that are disabled, feel free to let me know.

    Enabled MODI Languages and Locales in VNR
    - 1028: Chinese - Republic of China (Taiwan)
    - 1029: Czech - Czech Republic
    - 1031: German - Germany
    - 1033: English - United States
    - 1036: French - France
    - 1040: Italian - Italy
    - 1041: Japanese - Japan
    - 1042: Korean - Korea
    - 1043: Dutch - Netherlands
    - 1045: Polish - Poland
    - 1046: Portuguese - Brazil
    - 1049: Russian - Russia
    - 2052: Chinese (Simplified) - People's Republic of China
    - 3076: Chinese - Hong Kong (S.A.R.)
    - 3082: Spanish (Modern Sort) - Spain

    Disabled MODI Languages and Locales in VNR
    - 1030: Danish - Denmark
    - 1032: Greek - Greece
    - 1035: Finnish - Finland
    - 1038: Hungarian - Hungary
    - 1044: Norwegian (Bokmål) - Norway
    - 1053: Swedish - Sweden
    - 1055: Turkish - Turkey

9/5/2014 FRI
  * Add Felistella engine for PSP game Summon Night 5.

9/4/2014 THU
  * TAH script is changed to be ATLAS only, only for Japanese-English machine translation.
    TAH script is also updated to the latest version from @errzotl sensei.
    Please report bugs to TAHscript@outlook.com.

8/31/2014 SUN
  * Add a shared window for leaving messages.
    When new messages are received, the message button will flash.
    You can discuss everything there EXCEPT DISTRIBUTING PIRATE SOFTWARE AND GAMES!

    添加了一个留言板。
    收到新留言时，留言按钮会闪烁。
    在那里讨论什么都可以的，除了不要张贴海贼版的软件和游戏！

8/30/2014 SAT
  * Add zoom buttons to the header of the text boxes.
    你可以用文本框上边的-和+按钮来缩放文字的大小。

8/29/2014 FRI
  * Add support for PPSSPPEX.exe and PPSSPPSP.exe that is the same as PPSSPPWindows.exe.

8/28/2014 THU
  * I changed the mouse behaviors of the text boxes (subtitles, dictionary, OCR, etc.)
    - Drag the center of the box: vertically scroll the text
    - Drag the top/bottom border: move the text box
    - Drag the left/right border: horizontally resize the text box
      It is the same as adjusting the width in the left dock.

    字幕、字典、OCR等的文本框可以通过拖动左边或者右边的边界来改变宽度，拖动上边
    或下边的边界来改变位置，拖动中间来翻页。
    这样调整的宽度和左边选项中的宽度是一样的。

8/26/2014 TUE
  对日中翻译禁用了绝大部分的TAH翻译脚本。

  I disabled 99.999% of the TAH scripts and changed them to be for English translation only.
  You can revert my changes here:

      http://www.sakuradite.com/wiki/en/VNR/Translation_Scripts

  To be honest, I don't know why lots of people love these rules.
  To me, TAH is far too aggressive that it will remove the EMOTIONs and kawaii/ecchi sounds
  from Japanese, which can be at least recognized by All online/offline Chinese translators.
  I don't know how bad the existing English translators are, and I have no idea whether
  non-ATLAS English translators such as Google can recognize the TAH deleted structures or not.

  One example of the Japanese before/after applying TAH is here:

      http://sakuradite.com/upload/image/396.jpg

  TAH scripts will turn
      「はぁ、はぁっ……やぁっ、ぁぁっ…そんな場合じゃないのにっ……んんっ、んあふうぅ……へ、変な気分になっちゃうっ……はぁ……はぁ……」
  to
      「……そんな場合じゃないのに……あふ……変な気分になう……」
  The ecchi voices such as "はぁ、はぁっ" were removed.
  The emotional sentence such as "へ、変な気分になっちゃうっ" was rewritten to plain
  Japanese "変な気分になう" where the emotion is lost.
  As a result, after applying TAH, the Chinese translation become much much much worse.

  Currently, all TAH rules are still enabled for English by default.
  But I am not maintaining it for English, and I don't know whether it will make the
  English machine translation better or worse.
  I suggest you to try enabling/disabling TAH based on your own judgment.
  If you feel TAH is usually making the English translation better or worse, I hope
  if you could let me know your option. Thanks!

  * Bugfix when applying name and title terms in Shared Dictionary.

8/25/2014 MON
  * Fixed the OCR bug. Sorry for the inconvenience! m(_ _)m
    修正了OCR的问题。带来不便，很抱歉！ m(_ _)m

  * Add a TTS button to read OCR text.
    Note that currently only Google TTS and Voiceroid work.
    SAPI TTS does not work when VNR is launched as Administrator.

    添加了读出OCR文本的按键。
    不过，SAPI的TTS无法在管理员权限下工作。只有Google TTS和Voiceroid可以工作。

  * Reduce memory usage for network access to online machine translators.

8/23/2014 SAT
  * 禁止把猎豹浏览器当成游戏添加到VNR。
    如果你要翻译网页，可以用VNR自带的浏览器来做日中翻译。
    但是不要把浏览器当初游戏来翻译才好。ITH是无法提取到网页中的文本的。

  * VNR will cache all online machine translations to Library/Translations using SQLite.
    VNR会将全部在线的机器翻译都保存到Caches/Translations，希望可以些许加快在线翻译的速度.

  * Rewrite VNR's internal network access to use QtNetwork to replace Python requests that is slow.
    Online machine translation is faster now.
    减少了在线机器翻译的延时。

8/21/2014 THU
  * Fixed a bug that OCR might stop working after a while.
    修正了OCR用过一会后鼠标无法选择的bug。

8/19/2014 TUE
  * Fix the NEXTON engine for 淫烙の巫女.
    修正了从Normad的淫烙の巫女提取文本的问题。

  * Fix the OCR selection bug.
    Thanks so much for 1dat1 sensei's patch!!
    修正了OCR无法选择文本框的Bug。非常感谢1dat1 sensei的修正！

  * VNR will popup confirmation if you want clone other's terms in the Shared Dictionary.
    You don't need clone others' the terms to enable them. They have already been enabled.
    Cloning will result in duplicate rules which will make it more difficult to manage the rules.

    如果你要克隆其他同学的词条，VNR会弹出警告。
    其他同学的词条本来就已经开启了，并不需要克隆的。
    克隆会产生重复规则，会增加管理词条的难度。

  * Forbid adding terms whose pattern and translation are the same except for escaped terms.
    Having pattern == translation is meaningless except for escaping.

    禁止向共享辞书添加匹配文本等于替换文本的词条（除了转义和姓名词条）。
    两者相等的规则是没有意义的。

8/18/2014 MON
  * Bugfix for OCR.
    I forgot to register DLLs for MODI OCR.
    If you would like to try OCR, you can either re-download MODI OCR (36MB) and re-run the scripts here:

        https://mega.co.nz/#F!g00SQJZS!pm3bAcS6qHotPzJQUT596Q

    Or, if you don't want to re-download, you can manually run the following commands AS ADMINISTRATOR:

        regsvr32 "C:\Program Files (x86)\Common Files\Microsoft Shared\MODI\12.0\MDIVWCTL.DLL"
        regsvr32 "C:\Program Files (x86)\Common Files\Microsoft Shared\MODI\12.0\MSPCORE.DLL"

    Please remove x86 if you are on a x86 Windows.


    很抱歉，忘记注册OCR的DLL了。
    如果你想尝试下OCR的功能，请重新在这里下载MODI OCR（36MB）并重新运行安装的脚本：

        https://mega.co.nz/#F!g00SQJZS!pm3bAcS6qHotPzJQUT596Q

    或者，如果你不想重新下载了，你也可以使用管理员的权限手动运行下边的命令

        regsvr32 "C:\Program Files (x86)\Common Files\Microsoft Shared\MODI\12.0\MDIVWCTL.DLL"
        regsvr32 "C:\Program Files (x86)\Common Files\Microsoft Shared\MODI\12.0\MSPCORE.DLL"

    请手动删掉x86如果你在32位的Windows上。

8/17/2014 SUN
  * Add an OCR type to the Shared Dictionary for correcting OCR text, which is not accurate.
    在共享辞书中添加了OCR类型的词条用来矫正OCR提取出的文字。

  * Add support of Ntleas for changing locale.
    You can get it here:
        http://ntlea.codeplex.com
    添加了对使用Ntleas改变游戏日文编码的支持。

  * Restore the support of using Locale Switch to change game locale.
    You can turn it on in Preferences/Launch, which requires admin privileges.
    Locale Emulator is better in most cases.
    But if Locale Emulator does not work, you could also give LocaleSwitch a try.

    恢复了对Locale Switch的支持，在【使用偏好/启动】中可以开启。
    Locale Emulator在绝大多数情况下都是更好的选择。
    不过如果Locale Emulator无法工作，你也许可以尝试下LocaleSwitch。

  * Add alternative NEXTON engine for old NEXTON brands such as Nomad.
    为Nomad「淫烙の巫女」添加了游戏引擎。

8/16/2014 SAT
  * Add very primitive OCR support.
    A screenshot of レミニセンス's Config UI with OCR popup and translations are as follows:

        http://sakuradite.com/images/screenshots/ocr_popup.jpg

    You can press Shift+Mouse to select an area, and VNR will popup translation in the selected rectangle.
    You can enable it in Preferences/OCR.
    It could work without launching games.
    It might be used to identify texts in games as well as anime, manga, websites, or any other texts on the screen.

    REQUIREMENTS
    - You must have Microsoft MODI OCR installed.
      You can either purchase Microsoft Office 2007 and manually enabled it, or get it from here:

          https://mega.co.nz/#F!g00SQJZS!pm3bAcS6qHotPzJQUT596Q

      Currently, it is only 36MB, and only Japanese/Chinese fonts are included.

    LIMITATIONS
    - VNR must be launched as Administrator to make MODI OCR work.
      The trade-off is that several features (including SAPI TTS) will not work when VNR is launched as admin.
    - Currently, only machine translation works.
      TTS, 振仮名, and popup dictionaries including EDICT and EPWING are not implemented yet.
    - Currently, no settings can be adjusted for OCR.
      You cannot specify the target text color, size, and orientation which are critical to enhance OCR accuracy.
      As a result, irregular texts (fat, large, outlined), texts on the fancy background, and vertical texts
      can not be correctly identified.

    添加了使用微软的MODI OCR来识别和翻译屏幕是任何可见日文的功能。
    下边是「レミニセンス」Config界面中OCR的截图。

        http://sakuradite.com/images/screenshots/ocr_popup.jpg

    在【使用偏好/光学识别】中可以开启OCR。
    开启后，可以使用SHIFT+鼠标左键来选定需要提取文本和翻译的区域。
    使用OCR不需要运行游戏。你也可以用它来识别动画或者漫画中的文字。

    MODI OCR的idea来着【寒风游戏翻译机】。之前都没注意到可以通过微软实现OCR。
    在这里感谢下寒风游戏翻译机的作者hhyjq007！

    亚欧使用光学识别的功能，首先要安装MODI OCR。
    你可到微软购买正版的Office 2007，并开启MODI OCR；也可以从下边地址自己安装：

          https://mega.co.nz/#F!g00SQJZS!pm3bAcS6qHotPzJQUT596Q

    因为只包含日文和中文的字体，安装后只有36MB。

    现在VNR的OCR功能还非常的原始，有很多局限性：
    - 要使用OCR，必需以管理员权限打开VNR
    - 当前的版本只支持机器翻译，不支持振仮名，不支持EPWING字典查词，不支持TTS。
      这些在以后有空会加上的。
    - 不可以指定OCR文本的颜色，大小，orientation什么的。
      这导致很多不规则的文字，过大的文字，背景很花的文字，或者竖排的文字无法通过OCR提取。

8/15/2014 FRI
  * Add support to use TA Helper replacement scripts to improve machine translation quality.
    The current version is modified from @errzotl sensei 's 0.16 version.
    The TAH scripts are equivalent to VNR's Japanase terms in the Shared Dictionary.
    VNR will automatically update the scripts on the following wiki:

        http://sakuradite.com/wiki/en/VNR/Translation_Scripts

    Since the scripts on the wiki will affect all users,
    PLEASE BE VERY VERY VERY CAREFUL if you want to edit it.
    If you want to edit it, please first try your modification in Test Machine Translation
    offline before adding it to the online wiki!

    添加了对在日英翻译的community中非常有名的TAH翻译脚本的支持。
    VNR默认是开启这个脚本的。不过，你也可以在使用偏好的翻译中禁用这个脚本。

    这个脚本和VNR中的日文词条是等价的，包含大量（8000+）的规则用来修正日文的口语。
    这些规则包含去除垃圾，改写关西方言，纠正口癖等。
    比方说，打开翻译脚本可以将 「れ、恋さん！？」 =>  「恋さん！？」

    另外，由于这个功能是用C++而不是Python实现的，速度非常快（0.006秒即可完成）。
    不用担心因为打开这选项而让机翻变慢。

8/13/2014 WED
  * Add scripts to totally uninstall VNR.
    If you want uninstall VNR or reset its settings, you can run the following files:

        Scripts/Remove VNR Profiles.cmd  -- This will delete %APPDATA%/org.sakuradite.*
        Scripts/Remove VNR Settings.reg  -- This will delete HKCU/Software/sakuradite.org

    添加了完全删除VNR的脚本。
    你可以执行上边的文件来移除VNR，或者重置VNR在本地的设定。

  * Fixed the random crash for certain PPSSPP games.
    Some hooks (Alchemist, 5pb and Nippon1) sometimes do not work on PPSSPP 0.9.9.
    If you find a game does not work on PPSSPP 0.9.9, you might try switching back to 0.9.8.

8/12/2014 TUE
  * Bug fix CYBERFRONT PSP engine for old KID games.
    修正了CYBERFRONT PSP引擎。

  * Add KONAMI engine for PSP game 「幻想水滸伝 紡がれし百年の時」.
    为PSP上的幻想水浒传添加了引擎。

8/9/2014 SAT

  请不要将QQ之类的软件添加到VNR中了！ 添加的IP：123.244.x.x（沈阳）
  添加QQ到VNR，会对其他同学造成很糟糕的影响。同时使用VNR和QQ的软件，VNR会误认为QQ是游戏而hook上去。
  我非常不希望通过屏蔽IP来禁止添加QQ程序到VNR的数据库。

  如果你一定要添加QQ的软件到VNR，可以告诉我原因吗？
  比方说，如果你的中文不好，希望把中文QQ翻译为越南文。
  那么，我也许可以为你添加新的功能来翻译非游戏的程序。
  但是，现在请不要直接把非游戏程序添加到VNR中！

  * Add alternative Imageepoch engine for PSP game SOL TRIGGER.
    为PSP上的「SOL TRIGGER」添加了引擎.

  * Add machine translation ability to VNR's built-in browser.
    I hope if could help ease reading online Visual Novels or any other Japanese websites.

    It now supports using machine translator to translate Japanese websites,
    using MeCab to add ruby 振仮名, and using TTS to read the clicked sentence.
    A screenshot of the translated http://ja.wikipedia.org/wiki/Clover_Day's is as follows:

      http://sakuradite.com/images/screenshots/wr_wiki_en.png

    Additionally, VNR's Game Information page also supports the same translation system.

      http://sakuradite.com/images/screenshots/wr_vnr_en.png

    Comparing to VNR, a couple of features are still missing in the browser:
    - Shared Dictionary is not supported in the Browser.
    - Dictionaries such as EPWING and EDICT are not supported in the Browser.
    - Most Preferences cannot be changed in the Browser.
      If you want to, say, change the default TTS to use, you have to change VNR's Preferences.

    There are currently four buttons that can be toggled to adjust how to translate the website, as follows:
    - あ: Use VNR's MeCab and UniDic to add 振仮名 to all texts
    - 訳: Use the machine translation to replace all texts (slow unless using an offline translator)
    - 示: Display machine translation for the hovered sentence in the tooltip
    - ♪: Use TTS to read the clicked sentence (don't forget to install QuickTime if you want to use Google TTS)

    为VNR自带的浏览器添加了机翻功能。这个工具也许可以帮助翻译在线的Visual Novel或者其他日文网站。
    下面是一张 http://ja.wikipedia.org/wiki/Clover_Day's 的截图：

      http://sakuradite.com/images/screenshots/wr_wiki_zh.png

    另外，VNR的游戏情报中也采用了相同的翻译机制：

      http://sakuradite.com/images/screenshots/wr_vnr_zh.png

    这个浏览器当前可以支持机翻，振仮名，以及TTS。
    可以通过点击上方的按钮来开启这些功能。按钮的含义如下：
    - あ: 为日文添加ruby振仮名
    - 訳: 用机翻替换原始文字。最好使用离线的J北京。在线翻译会很慢。
    - 示: 不替换原始文字，但是用tooltip弹出机翻。
    - ♪: 使用TTS读出点击的日文。如果你要用Google TTS，不要忘记安装QuickTime。

    这个浏览器还处在alpha的阶段，和VNR比起来还缺少的功能如下：
    - 不支持共享辞书。
    - 不支持用EPWING辞书查字典。
    - 很多使用偏好无法在浏览器中修改，需要打开VNR在VNR的使用偏好中修改。
    - 浏览器中有些地方是英文或日文的，还没有添加中文翻译。

8/7/2014 THU
  * VNR内部不再使用百度翻译网站的API。当选定百度翻译时，VNR会调用金山词霸的API。
    两者翻译的内容应该是一样的。但是至少在我这里和日本的服务器上，金山词霸翻译的时间只有百度的一半。
    特别当短时间内连续使用百度翻译时，很容易造成卡主。金山词霸的API就没有这个问题。

  * Use persistent threads and sessions to reduce the latency of online machine translation.
    减少了在线机器翻译的时间。

  * 修正了Excite由于网站变更无法翻译中文的问题。
    Excite的日中翻译可以匹敌JBeijing的（两者基本相同）。
    如果你没有被q的问题，又没有安装JBeijing，那么也许可以尝试下。

  * Hide text box when no visible texts.
    当没有文本显示时，自动隐藏文本框，不再显示上边的黑边。

8/5/2014 TUE
  * Add new BGI engine for 「蒼の彼方のフォーリズム」.
    Thanks for @98549177 sama's report!
    为「蒼の彼方のフォーリズム」添加了新的BGI引擎。

  * Add embedding translation support for the new BGI engine.
    A screenshot of 「蒼の彼方のフォーリズム」 with embedded English translation is as follows

      http://i859.photobucket.com/albums/ab155/jichi/84BC306E5F7C65B9306E30D530A930FC30EA30B9309930E0_zpsa69ea4f1.png

    It ONLY works for LATIN charactered languages.

8/3/2014 SUN
  * Add support for Fate/stay night on PCSX2.
    A screenshot is as follows (tested on pcsx2-v1.2.1-328-gef0e3fe-windows-x86):

      http://sakuradite.com/images/screenshots/pcsx2_fate.jpg

    The compatibility issue is the same as PSP:
      1. Do not work on Windows XP
      2. Must launch VNR AFTER the PS2 ISO has been loaded
      3. Changing game ISO requires restarting VNR

    可以从PCSX2上的「Fate/stay night」提取文本了。

  * Add Marvelous PS2 engine for 「School Rumble ねる娘は育つ」and 「School Rumble二学期」
    为PS2上的「School Rumble ねる娘は育つ」和「School Rumble二学期」添加了Marvelous引擎。

8/2/2014 SAT
  * 更新了djz大先生的J北京辞书。

  * Add 2RM engine for PC games from エロイット.

  * Add side-B engine for PC game メルトピア.
    The existing H-code has the issue of floating address.
    It is better to use this hook than the H-code so that you don't have to adjust Text Settings
    everytime before the game starts.

    为side-B的「メルトピア」添加了游戏引擎。

8/1/2014 FRI
  请大家不要将QQ之类的软件当成新游戏添加到VNR中了！

  * 添加了简明和汉字典。
    这个字典比VNR当前的日中辞书词汇量要小（一共只有2MB），解释也少，没什么用。
    这个字典是用来实现为日语单词添加中文注释的，那部分还没写完，先把字典的部分commit上来。

7/31/2014 THU
  * 禁止把QQDownload添加到VNR。

  * Increase the black padding border's width in full screen.

  * Add a toggle to the left dock for copying machine/shared translation to the clipboard.

    I am sorry that I failed to find a way to load LEC translator's DLL for non-English translation.
    If you want to translate Japanese to non-English  using LEC, currently, you might have to
    turn on this "Sub to clipboard" toggle to re-translate English to your native language
    through clipboard using LEC or any other translators.

  * Able to add/detect games running on a network drive, such as a NAS drive, or Parallels Desktop's host.

  * Add a command line parameter --pid for specifying which game process to attach.
    For instance, run "Debug VNR.cmd --pid 1234" will attach to the process whose PID is 1234.
    If there are multiple games running at the same time, or if there are multiple game processes
    for the same game, you can use this parameter to select which game process to attach.

    I posted current supported parameters here: http://www.sakuradite.com/wiki/en/VNR/Command_Line

    添加了--pid的命令行参数可以指定要提取文本的游戏的PID。
    参看： http://www.sakuradite.com/wiki/zh/VNR/命令行

  * Bug fix for PPSSPP 0.9.9. Most engines should work now.
    But in order to support 0.9.9, VNR is 10 times slower than before to scan the memory.
    It could take up to 10 seconds to determine the PSP game engine to use.
    After VNR is launched, you might have to wait for 10 seconds for the text to appear.

    修正了对PPSSPP的0.9.9支持。

7/29/2014 TUE
  * Add Otomate PSP hook for PPSSPP 0.9.9.
    It should cover most cases where 0.9.8 hooks (BANDAI, Alchemist, and Otomate) do not work.

    为Otomate的PSP游戏添加了对PPSSPP 0.9.9的支持。

  * Display required PPSSPP version in Text Settings
    If it shows =0.9.x, then the hook works for all PSP versions.
    If it shows =0.9.9 or 0.9.8, then the hook might work only for the specified PPSSPP.

    在文本设定中会显示提取文本需要的PPSSPP版本。

7/27/2014 SUN
  * Add Intense PSP engine for 「密室のサクリファイス」.

  Note: It is reported by @roninmedia that certain games did not work on PPSSPP 0.9.9.
  I am going to investigate the changes from 0.9.8 to 0.9.9 which broke VNR.
  If you find certain games working on 0.9.8 no longer working on 0.9.9, you can also let me know the game.
  Sorry for the inconvenience!

  注：VNR当前只在0.9.8下完全测试过。
  如果你发现一些游戏在0.9.8上可以工作，但是0.9.9上不能工作了，很希望可以让我知道无法工作的游戏的名字。

  * Reduce VNR's memory usage from 330MB to 190MB.
    VNR的内存使用量从330MB降低为190MB。

7/26/2014 SAT
  * Add EAGLS engine for games from TechArts which does not have text duplication issue.
    TechArts owns several popular nuki-ge brand, including G.J?, SQUEEZ（炎の孕ませシリーズ）
    and May-Be Soft.
    If you are playing 「ちぇ～んじ！」released this month, please re-adjust Text Settings.
    There will be several EAGLS threads, and be careful about the subtle differences that only 1 is correct.

    为本月的「ちぇ～んじ！」添加了游戏引擎。
    请重新调整文本设定。尽管会有很多EAGLS，要仔细看下区别才好，只有一个EAGLS的文本才是对的。
    这个引擎也可以解决「炎の孕ませ」シリーズ中文本重复的问题。

  Otome:
  * Add Brocolli engine for PSP game 「明治東亰恋伽」.
  * Add Otomate engine for PSP game 「クロノスタシア」 and 「忍び、恋うつつ」.
  * Add 日本一SOFTWARE engine for PSP game 「神々の悪戯」.
  * Remove garbage text for PSP game 「Are you Alice?」.

  Non-otome:
  * Add PSP engine for KADOKAWA game 「フォトカノ」.
  * Add alternative Yeti engine for Never7, Remember1, Ever17.

7/25/2014 FRI
  * Modify BANDAI PSP hook to support SEGA's Shining Hearts and Shape's
    とある科学の超電磁砲.
    添加了对PSP游戏「Shining Hearts」和「とある科学の超電磁砲」的支持。

    I created a wiki page for the known games that are not supported by VNR.
    If you find a game does not work with VNR, you can also put it there.
    I will try to make the games on the list to work when I have time.

            http://sakuradite.com/wiki/en/VNR/Compatibility

    我把已知的VNR无法提取文本的游戏放在上面了。
    如果你有发现VNR不支持某个游戏，也可以把游戏的信息放到那里去。

7/24/2014 THU
  * Add support for Arabic language.
    You can switch the language in Preferences/Account.
    If your language is not supported by VNR, feel free to let me know.

    When Arabic language is selected, VNR will try to switch the alignment
    from left-right to right-left.
    A screenshot of the current Arabic UI is as follows:

        http://sakuradite.com/images/screenshots/vnr_ar.jpg

    However, since I don't know any Arabic, I am not able to verify myself
    if an Arabic sentence is from left-to-right or right-to-left.
    If you find the text alignment is wrong in certain places, feel free to
    complain to me.

  * Restore the toggle in Preferences/Features to force enabling context menu in
    full screen game.

    This is requested by @goodboyye ONLY for people who have very small screen size.
    Since context menu would break full screen in most games, you normally don't
    want to enable this unless your laptop has a very small screen size.

    在【使用偏好/功能】恢复了在全屏时强迫开启右键菜单的选项。

    然而，这个仅仅是@goodboyye为了小屏幕同学的request。
    由于右键菜单会让很多游戏离开全屏状态，除非你因为笔记本屏幕太小迫不得已，
    否则千万不要打开这选项。


  btw., I rewrote the comet service from scratch at the server side.
  There should be no more network errors while signing in VNR or updating
  database when lots of users are using VNR.

  简单的说，在每天晚上VNR使用的高峰期，不会再出现无法登陆或者无法更新数据库
  之类的网络错误了。

7/23/2014 WED
  * Add Hán Việt Chinese-Vietnamese offline translator (漢越辭典).
    The dictionary is from Quick Translator TAO (http://www.tangthuvien.vn/forum/showthread.php?t=30151).
    You can enable it in Preferences/Translation if you want to cross-translate
    Chinese-translated eroge to Vietnamese.
    To translate Chinese games, you also need to change the game language
    from Japanese to Chinese in Text Settings.

7/22/2014 TUE
  * Fix the regression for Ryokucha engine. Sorry for the problem!
    修正了绿茶社引擎的bug。带来不便，非常抱歉！

  * Add BANDAI PSP engine for School Rumble PSP.
    为「スクールランブル 姉さん事件です」添加了BANDAI PSP的引擎。

  * Add Brocolli PSP engine for うたの☆プリンスさまっ.

7/20/2014 SUN
  * Add a Vanillaware engine for Wii game 朧村正.
    Tested on Dolphin 4.0, and a screenshot is as follows:

      http://sakuradite.com/images/screenshots/dolphin_oboro.jpg

    This is just a test for extracting texts from Dolphin.
    Please hold until this feature become stable.

    btw, the compatibility and limitation of Dolphin support is similar to PSP:
    1. Do not work on Windows XP
    2. Must launch VNR AFTER the GameCube/Wii ISO has been loaded
    3. Changing game ISO requires restarting VNR

  * Reduce garbage characters for Rejet PSP games.
    Thanks for @Sakamichi sama's report!

  * Add alternative engine for old Alchemist PSP game のーふぇいと.
    为老的Alchemist PSP游戏「のーふぇいと」添加了游戏引擎。
    感谢的@三十张sama报告！

7/19/2014 SAT
  * Add KID PSP engine for old KID games which does not have repetition texts.
    为KID添加了PSP游戏引擎来解决文本重复的问题。

  * Add CYBERFRONT PSP engine for old KID games.
    为KID添加了CYBERFRONT游戏引擎。

  * Add Yeti PSP engine for Secret Game.
    为Secret Game添加了PSP游戏引擎。

  * Bug fix PSP game engines.  I tested several PSP games, as follows:
    修正了PSP引擎的一些Bug。

    Work - 可以工作
    - [KID] Monochrome <= 文本设定请选择蓝色的KID的文本，而不要选择sceFont开头的文本

    - [5pb.] STEINS;GATE
    - [5pb.] Chaos Head Noah
    - [5pb.] DUNAMIS15
    - [Alchemist] 処女はお姉さまに恋してる 2人のエルダー
    - [Alchemist] 俺の彼女のウラオモテ
    - [Alchemist] your diary+
    - [CYBERFRONT] 想いのかけら
    - [Imageepoch] BLACK☆ROCK SHOOTER
    - [SEGA] SHINING BLADE
    - [Yeti] Secret Game

    Work, but have repetition in texts - 可以提取文本，但有重复文本
    - [NAMCO] .hack//.link

    Not work - 完全不能工作
    - [スクエニ] Final Fantasy Zero
    - [Imageepoch] 那由多の軌跡
    - [Spike] ダンガンロンパ
    - [Shade] とある科学の超電磁砲
    - [Shade] とある魔術と科学の群奏活劇

    Additional game engines are needed for the games that are not supported at the time.
    Note: None of the above games works on Windows XP.
    Note2: Just to emphasize, you MUST ENTER THE GAME (not only load PSP ISO) before launching VNR.

    注：
    1. 这些游戏在Windows XP上不能工作。
    2. 再次强调下，一定要先进入游戏（不只是插入PSP ISO，而是要进入游戏看到对话），再打开VNR。

7/16/2014 WED
  * Bug fix PSP game engines, which should now work on both Windows 7 and 8, x86 or x64.
    But it does NOT support Windows XP.
    If you are using Windows 7/8, but VNR cannot get text from PSP games made from
    Alchemist, 5pb, SEGA, or Imageepoch, I hope you could let me know.

    修正了PSP的游戏引擎。VNR应该可以从任何版本的Windows 7/8提取文本了。
    但是，PSP的游戏引擎不支持Windows XP！！
    如果你正在使用Windows 7/8，而VNR无法从Alchemist，5pb，SEGA，或是Imageepoch的游戏提取文本，
    很希望你可以让我知道出现问题的游戏的名字。

7/16/2014 WED
  * Fix the text duplication issue for 5pb PSP engine.

  * Fix a bug in Alchemist PSP engine.
    btw., it seems that this engine works for various game makers.
    It also works for SEGA PSP games such as SHINING BLADE.
    The hooked function can also be found in STEINS;GATE (@5pb.), though not called.
    I guess the hooked function was in certain common PSP SDK/Library.

    The Imageepoch's hooked function was also found in SEGA's SHINING BLADE, though not called.
